# Capytaine: a linear potential flow BEM solver with Python.

![CI status](https://github.com/capytaine/capytaine/actions/workflows/test_new_commits.yaml/badge.svg?event=push)
![CI status](https://github.com/capytaine/capytaine/actions/workflows/test_with_latest_dependencies.yaml/badge.svg)


Capytaine is Python package for the simulation of the interaction between water waves and floating bodies in frequency domain.
It is built around a full rewrite of the open source Boundary Element Method (BEM) solver Nemoh for the linear potential flow wave theory.

## Installation

[![PyPI](https://img.shields.io/pypi/v/capytaine)](https://pypi.org/project/capytaine)
[![Conda-forge](https://img.shields.io/conda/vn/conda-forge/capytaine)](https://github.com/conda-forge/capytaine-feedstock)

Packages for Windows, macOS and Linux are available on PyPI:

```bash
pip install capytaine
```
and Conda-forge

```bash
conda install -c conda-forge capytaine
```

## Documentation

[https://capytaine.github.io/](https://capytaine.github.io/)

[![DOI](http://joss.theoj.org/papers/10.21105/joss.01341/status.svg)](https://doi.org/10.21105/joss.01341)

## License

Copyright (C) 2017-2024, Matthieu Ancellin

Since April 2022, the development of Capytaine is funded by the Alliance for Sustainable Energy, LLC, Managing and Operating Contractor for the National Renewable Energy Laboratory (NREL) for the U.S. Department of Energy.

This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

It is based on version 2 of [Nemoh](https://lheea.ec-nantes.fr/logiciels-et-brevets/nemoh-presentation-192863.kjsp), which has been developed by Gérard Delhommeau, Aurélien Babarit et al., (École Centrale de Nantes) and was distributed under the Apache License 2.0.

Some core Fortran routines of Capytaine coming from Nemoh version 2 are also available under the Apache License 2.0. They can be found in the [`capytaine/green_functions/libDelhommeau`](https://github.com/capytaine/capytaine/tree/master/capytaine/green_functions/libDelhommeau) directory of Capytaine's repository.

Capytaine includes code from [meshmagick](https://github.com/LHEEA/meshmagick/) by François Rongère (École Centrale de Nantes), licensed under the GNU General Public License (GPL).

                                                        FINGREEN3D

FINGREEN3D is an open-source package for computation of the free-surface Green's function under a finite water depth, which is the core-part of the boundary integral equations in the potential flow theory for analysis of wave-structure interactions. It is currently written in FORTRAN 90. The code is based on a state-of-the-art method developed in recent years by the authors. The main strategy of this method is to use a set of different series expansions in appropriate sub-regions. Therefore, we can avoid calculating the Green's function by direct time-consuming integrations.

FINGREEN3D is freely distributed under the LGPL License, Version 3.0, https://www.gnu.org/licenses/lgpl-3.0.html, and may be modified and
extended by researchers who intend to enhance its capabilities and port the code to other platforms.

It should be noted that, any modified version should be licensed under the LGPL License and be released open-publicly as well. The contributors can add their names in the "contributors list" ahead of the modified subroutine(s).

...

Note that the input & output parameters should keep the correct form as described in the accompanying ECM paper:

Yingyi Liu, Shigeo Yoshida, Changhong Hu, Makoto Sueyoshi, Liang Sun, Junliang Gao, Peiwen Cong, Guanghua He. A reliable open-source package for performance evaluation of floating renewable energy systems in coastal and offshore regions. Energy Conversion and Management, 174 (2018): 516-536.

Please cite the above paper in your relevant publications if the FINGREEN3D code or its executable (dynamic link library) has contributed to your work.

NO WARRANTY is given to FINGREEN3D.

The authors are not liable for any misuse or real and/or presumed damage which can arise from an improper use or removing/deleting some
parts of this software.

Adapted for Capytaine from https://github.com/YingyiLiu/FinGreen3D by Matthieu Ancellin, 2025.

# LibDelhommeau

A Fortran 90 library for the computation of the Green function for linear potential flow BEM problems, using Delhommeau's method as in Aquaplus, [Nemoh](https://lheea.ec-nantes.fr/valorisation/logiciels-et-brevets/nemoh-presentation) and [Capytaine](https://joss.theoj.org/papers/10.21105/joss.01341).

This Fortran repository contains the source code of the compiled extensions of the Python software [Capytaine](https://github.com/capytaine/capytaine).
One of the reason to have it in a separate repository is because libDelhommeau is distributed with a more permissive license than Capytaine.
Another reason to decouple it from Capytaine is to support reuse of the code in other software.

However, unless you are an experienced user, you might be more interested in using the full [Capytaine](https://github.com/capytaine/capytaine) software which is easier to use and better documented than this library.

## Authors
Matthieu Ancellin, based on the work of Gérard Delhommeau, Aurélien Babarit, and other contributors to the aforementioned codes.

## License
Apache license 2.0

! Copyright (C) 2017-2019 Matthieu Ancellin
! See LICENSE file at <https://github.com/mancellin/capytaine>
MODULE INITIALIZE_GREEN_WAVE

  USE CONSTANTS

  IMPLICIT NONE

  PUBLIC :: GG
  PUBLIC :: INITIALIZE_TABULATED_INTEGRALS
  PUBLIC :: FF

CONTAINS

!------------------------------------------------------------------------------

  FUNCTION GG(ZZ)
    ! Estimation of exp(z)·E1(z) where E1(z) = ∫_z^∞ exp(-t)/t dt
    ! See p.367 of G. Delhommeau thesis (referenced as [Del]).

    ! This routine is only used in the following subroutine to compute the tabulated integrals

    ! The computation is done is single precision.

    COMPLEX(KIND=PRE),      INTENT(IN)  :: ZZ
    COMPLEX(KIND=PRE)                   :: GG
    COMPLEX(KIND=KIND(1e0))             :: G, Y, Z

    Z = CMPLX(ZZ, KIND=KIND(1e0))
    IF (REAL(Z) < -16.0) THEN                                      ! Case 1 p. 368 in [Del]
      Y = 1./Z
      G = Y*(1.+Y*(-1.+Y*(2.+Y*(-6.+Y*(24.+Y*(-120.))))))
    ELSE IF (ABS(AIMAG(Z)) > 10.0) THEN                            ! Case 3 p. 368 in [Del]
      G = 0.711093/(Z+0.415775)+0.278518/(Z+2.29428)+0.010389/(Z+6.2900)
    ELSE IF (REAL(Z) > -0.5) THEN                                  ! Case 2 p. 368 in [Del]
      G = -(LOG(Z)*(.1E+01+Z*(0.23721365E+00+Z*(0.206543E-01+Z*(0.763297E-03+     &
        Z*0.97087007E-05))))+0.5772156649E+00*(0.99999207E+00+                    &
        Z*(-0.149545886E+01+Z*(0.41806426E-01+Z*(-0.3000591E-01+                  &
        Z*(0.19387339E-02+Z*(-0.51801555E-03)))))))/(0.1E+01+                     &
        Z*(-0.76273617E+00+Z*(0.28388363E+00+Z*(-0.66786033E-01+Z*(0.12982719E-01 &
        +Z*(-0.8700861E-03+Z*0.2989204E-03))))))
    ELSE                                                           ! Case 4 p. 369 in [Del]
      IF (AIMAG(Z) < 0) THEN
        G = ((((((( (1.000000, 1.3935496E-06)*Z+ (15.82958, -20.14222))   &
          *Z+ (-70.52863, -227.9511))*Z+ (-985.4221, -226.6272))*Z        &
          + (-1202.318, 1580.907))*Z+ (953.2441, 1342.447))*Z             &
          + (417.3716, -196.6665))*Z+ (-9.881266, -24.24952))/            &
          (((((((( (1.000000, 0.0000000E+00)*Z+ (16.83184, -20.14481))*Z  &
          + (-55.66969, -248.1167))*Z+ (-1068.640, -434.4707))*Z          &
          + (-2082.250, 1522.471))*Z+ (383.3455, 2730.378))*Z             &
          + (1216.791, 351.7189))*Z+ (115.3926, -161.2647))*Z             &
          + (-3.777369, -4.510900))
      ELSE
        G = ((((((( (1.000000, -1.3935496E-06)*Z+ (15.82958, 20.14222))   &
          *Z+ (-70.52863, 227.9511))*Z+ (-985.4221, 226.6272))*Z          &
          + (-1202.318, -1580.907))*Z+ (953.2441, -1342.447))*Z           &
          + (417.3716, 196.6665))*Z+ (-9.881266, 24.24952))/              &
          (((((((( (1.000000, 0.0000000E+00)*Z+ (16.83184, 20.14481))*Z   &
          + (-55.66969, 248.1167))*Z+ (-1068.640, 434.4707))*Z            &
          + (-2082.250, -1522.471))*Z+ (383.3455, -2730.378))*Z           &
          + (1216.791, -351.7189))*Z+ (115.3926, 161.2647))*Z             &
          + (-3.777369, 4.510900))
      END IF
    END IF
    GG = CMPLX(G, KIND=PRE)

  END FUNCTION GG

!------------------------------------------------------------------------------

  SUBROUTINE INITIALIZE_TABULATED_INTEGRALS(IR, JZ, NPINTE, XR, XZ, APD)
    ! Compute the tabulated integral for the wave part of the Green function.
    ! These tables are independant of the mesh and of the frequency.
    ! They are only initialised once at the beginning of the computation.

    ! References:
    ! [1] Delhommeau, Amélioration des codes de calcul de diffraction-radiation, 2èmes journées de l'hydrodynamique, 1989
    ! [2] Babarit and Delhommeau, Theoretical and numerical aspects of the open source BEM solver NEMOH, EWTEC 2015
    ! [3] Xie et al., Comparison of existing methods for the calculation of the infinite water depth free-surface Green
    !                 function for the wave-structure interaction problem, Applied Ocean Research, 2018

    ! Inputs
    INTEGER, INTENT(IN) :: IR     != 328
    INTEGER, INTENT(IN) :: JZ     != 46
    INTEGER, INTENT(IN) :: NPINTE

    ! Outputs
    REAL(KIND=PRE), DIMENSION(IR),           INTENT(OUT) :: XR
    REAL(KIND=PRE), DIMENSION(JZ),           INTENT(OUT) :: XZ
    REAL(KIND=PRE), DIMENSION(IR, JZ, 2, 2), INTENT(OUT) :: APD

    ! Local variables
    INTEGER :: I, J, K
    REAL(KIND=PRE) :: THETA(NPINTE), CQT(NPINTE)
    REAL(KIND=PRE) :: CT
    COMPLEX(KIND=PRE) :: C1, C2, ZETA, CEX

    ! Initialize XZ (named Z(J) in [1, 2])
    DO J = 1, JZ
      XZ(J) = -AMIN1(10**(J/5.0-6), 10**(J/8.0-4.5), 16.)
    END DO

    ! Initialize XR (named X(I) in [1, 2])
    XR(1) = 0.0
    DO I = 2, IR
      IF (I < 40) THEN
        XR(I) = AMIN1(10**((I-1.0)/5-6), 4.0/3.0 + ABS(I-32)/3.0)
      ELSE
        XR(I) = 4.0/3.0 + ABS(I-32)/3.0
      ENDIF
    END DO

    ! Initialize THETA and CQT for the integration between -pi/2 and pi/2 with the Simpson rule.
    DO K = 1, NPINTE
      THETA(K) = -PI/2 + (K-1.0)/(NPINTE-1.0)*PI  ! The 1.0 are here on purpose to force the recasting of K and NPINTE as floats.
      IF ((K == 1) .OR. (K == NPINTE)) THEN
        CQT(K) = PI/(3*(NPINTE-1))
      ELSEIF (MOD(K,2)==0) THEN
        CQT(K) = 4.0/(3*(NPINTE-1))*PI
      ELSE
        CQT(K) = 2.0/(3*(NPINTE-1))*PI
      ENDIF
    ENDDO

    ! Initialize APD..
    APD(:, :, :, :) = 0.0
    DO J = 1, JZ
      DO I = 1, IR
        DO K = 1, NPINTE
          CT = COS(THETA(K))
          ZETA = CMPLX(XZ(J), XR(I)*CT, KIND=PRE)
          IF (REAL(ZETA) <= -30.0) THEN
            CEX = (0.0, 0.0)
          ELSE
            CEX = EXP(ZETA)
          ENDIF
          IF (AIMAG(ZETA) < 0) THEN
            C1 = CQT(K)*(GG(ZETA) - II*PI*CEX - 1.0/ZETA)
          ELSE
            C1 = CQT(K)*(GG(ZETA) + II*PI*CEX - 1.0/ZETA)
          END IF
          C2 = CQT(K)*CEX
          APD(I, J, 1, 1) = APD(I, J, 1, 1) + CT*AIMAG(C1) ! named D_1(Z, X) in [1, 2]
          APD(I, J, 1, 2) = APD(I, J, 1, 2) + REAL(C1)     ! named D_2(Z, X) in [1, 2]
          APD(I, J, 2, 1) = APD(I, J, 2, 1) + CT*AIMAG(C2) ! named Z_1(Z, X) in [1, 2]
          APD(I, J, 2, 2) = APD(I, J, 2, 2) + REAL(C2)     ! named Z_2(Z, X) in [1, 2]
        END DO
      END DO
    END DO

    RETURN

  END SUBROUTINE INITIALIZE_TABULATED_INTEGRALS

!-------------------------------------------------------------------------------!

  FUNCTION FF(XTT, AK, AM)
    ! A function that will be Prony-decomposed for the finite-depth Green function.
    ! See the method "compute_exponential_decomposition" in bem/nemoh.py.

    ! Input
    REAL(KIND=PRE), INTENT(IN) :: XTT, AK, AM

    ! Local variables
    REAL(KIND=PRE) :: COEF, TOL, A, B, C, D, E, F, FF

    COEF = (AM+AK)**2/(AM**2-AK**2+AK)

    TOL = MAX(0.1, 0.1*AM)
    IF (ABS(XTT-AM) > TOL) THEN
      FF = (XTT+AK)*EXP(XTT)/(XTT*SINH(XTT)-AK*COSH(XTT)) - COEF/(XTT-AM) - 2
    ELSE
      A = AM - TOL
      B = AM
      C = AM + TOL
      D = (A+AK)*EXP(A)/(A*SINH(A)-AK*COSH(A)) - COEF/(A-AM) - 2
      E = COEF/(AM+AK)*(AM+AK+1)               - (COEF/(AM+AK))**2*AM - 2
      F = (C+AK)*EXP(C)/(C*SINH(C)-AK*COSH(C)) - COEF/(C-AM) - 2
      FF = D*(XTT-B)*(XTT-C)/((A-B)*(A-C)) + &
           E*(XTT-C)*(XTT-A)/((B-C)*(B-A)) + &
           F*(XTT-A)*(XTT-B)/((C-A)*(C-B))
    ENDIF
    
    RETURN
  END FUNCTION FF

!----------------------------------------------------------------

END MODULE INITIALIZE_GREEN_WAVE

! Copyright (C) 2017-2019 Matthieu Ancellin
! See LICENSE file at <https://github.com/mancellin/capytaine>

MODULE CONSTANTS

  INTEGER, PARAMETER :: PRE = KIND(1d0) ! Floating point numbers precision

  REAL(KIND=PRE), PARAMETER :: ZERO = 0
  REAL(KIND=PRE), PARAMETER :: ONE = 1
  REAL(KIND=PRE), PARAMETER :: INFINITE_DEPTH = 0

  REAL(KIND=PRE), PARAMETER :: PI = 3.141592653588979 ! π
  COMPLEX(KIND=PRE), PARAMETER :: II = (0, 1)         ! Imaginary unit

END MODULE CONSTANTS

! Copyright (C) 2017-2019 Matthieu Ancellin
! See LICENSE file at <https://github.com/mancellin/libDelhommeau>
MODULE GREEN_WAVE

  USE CONSTANTS
  USE DELHOMMEAU_INTEGRALS
  USE GREEN_RANKINE, ONLY: COMPUTE_ASYMPTOTIC_RANKINE_SOURCE

  IMPLICIT NONE

  ! Dependencies between the functions of this module:
  ! (from top to bottom: "is called by")
  !
  !               (Delhommeau_integrals.f90)
  !                          |
  !              COLLECT_DELHOMMEAU_INTEGRALS       (COMPUTE_ASYMPTOTIC_RANKINE_SOURCE)
  !                        /   \                    /
  ! WAVE_PART_INFINITE_DEPTH   WAVE_PART_FINITE_DEPTH
  !                        \   /
  !                    (matrices.f90)
  !                          |
  !                    (python code)

CONTAINS

  ! =====================================================================

  SUBROUTINE COLLECT_DELHOMMEAU_INTEGRALS                        &
      (X0I, X0J, wavenumber,                                     &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      FS, VS)

    ! Inputs
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN) :: X0I, X0J
    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber

    ! Tabulated data
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_r_range
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_z_range
    REAL(KIND=PRE), DIMENSION(size(tabulated_r_range), size(tabulated_z_range), 2, 2), INTENT(IN) :: tabulated_integrals

    ! Outputs
    COMPLEX(KIND=PRE),                        INTENT(OUT) :: FS  ! the integral
    COMPLEX(KIND=PRE), DIMENSION(3),          INTENT(OUT) :: VS  ! its gradient

    ! Local variables
    REAL(KIND=PRE) :: r, z, r1
    REAL(KIND=PRE), dimension(2, 2) :: integrals
    COMPLEX(KIND=PRE) :: G, dGdr

    r = wavenumber * NORM2(X0I(1:2) - X0J(1:2))
    z = wavenumber * (X0I(3) + X0J(3))
    r1 = hypot(r, z)

    IF (z > -1e-8) THEN
      PRINT*, "Error: Impossible to compute the wave part of the Green function due to panels on the free surface (z=0) or above."
      ERROR STOP
    ENDIF

    !=======================================================
    ! Evaluate the elementary integrals depending on z and r
    !=======================================================
    IF ((MINVAL(tabulated_z_range) < z) .AND. (r < MAXVAL(tabulated_r_range))) THEN
        ! Within the range of tabulated data
        integrals = pick_in_default_tabulation(r, z, tabulated_r_range, tabulated_z_range, tabulated_integrals)

      ELSE
        ! Asymptotic expression for distant panels
        integrals = asymptotic_approximations(MAX(r, 1e-10), z)
      ENDIF

      !================================================
      ! Add the elementary integrals to build FS and VS
      !================================================

#ifdef XIE_CORRECTION
      G    = CMPLX(integrals(1, 2)/PI + ONE/r1, integrals(2, 2), KIND=PRE)
#else
      G    = CMPLX(integrals(1, 2)/PI, integrals(2, 2), KIND=PRE)
#endif
      dGdr = CMPLX(integrals(1, 1)/PI, integrals(2, 1), KIND=PRE)

      FS    = G
      VS(1) = dGdr * wavenumber*(X0J(1) - X0I(1))/r
      VS(2) = dGdr * wavenumber*(X0J(2) - X0I(2))/r
      VS(3) = G

      IF (r < REAL(1e-5, KIND=PRE)) THEN
        ! Limit case r ~ 0 ?
        VS(1:2) = CMPLX(0.0, 0.0, KIND=PRE)
      END IF

    RETURN
  END SUBROUTINE COLLECT_DELHOMMEAU_INTEGRALS

  ! =========================

  SUBROUTINE WAVE_PART_INFINITE_DEPTH &
      (X0I, X0J, wavenumber,          &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      SP, VSP)
    ! Compute the wave part of the Green function in the infinite depth case.
    ! This is mostly the integral computed by the subroutine above.

    ! Inputs
    REAL(KIND=PRE),                           INTENT(IN)  :: wavenumber
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN)  :: X0I   ! Coordinates of the source point
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN)  :: X0J   ! Coordinates of the center of the integration panel

    ! Tabulated data
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_r_range
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_z_range
    REAL(KIND=PRE), DIMENSION(size(tabulated_r_range), size(tabulated_z_range), 2, 2), INTENT(IN) :: tabulated_integrals

    ! Outputs
    COMPLEX(KIND=PRE),               INTENT(OUT) :: SP  ! Integral of the Green function over the panel.
    COMPLEX(KIND=PRE), DIMENSION(3), INTENT(OUT) :: VSP ! Gradient of the integral of the Green function with respect to X0I.

    ! Local variables
    REAL(KIND=PRE), DIMENSION(3) :: XJ_REFLECTION

    ! The integrals
    CALL COLLECT_DELHOMMEAU_INTEGRALS(                           &
      X0I, X0J, wavenumber,                                      &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      SP, VSP(:))
    SP  = 2*wavenumber*SP
    VSP = 2*wavenumber**2*VSP

    ! Only one singularity is missing in the derivative
    XJ_REFLECTION(1:2) = X0J(1:2)
    XJ_REFLECTION(3) = - X0J(3)
    VSP = VSP - 2*(X0I - XJ_REFLECTION)/(NORM2(X0I-XJ_REFLECTION)**3)

    RETURN
  END SUBROUTINE WAVE_PART_INFINITE_DEPTH

  ! ======================

  SUBROUTINE WAVE_PART_FINITE_DEPTH &
      (X0I, X0J, wavenumber, depth, &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      NEXP, AMBDA, AR,              &
      SP, VSP_SYM, VSP_ANTISYM)
    ! Compute the frequency-dependent part of the Green function in the finite depth case.

    ! Inputs
    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber, depth
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN) :: X0I  ! Coordinates of the source point
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN) :: X0J  ! Coordinates of the center of the integration panel

    ! Tabulated data
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_r_range
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_z_range
    REAL(KIND=PRE), DIMENSION(size(tabulated_r_range), size(tabulated_z_range), 2, 2), INTENT(IN) :: tabulated_integrals

    ! Prony decomposition for finite depth
    INTEGER,                                  INTENT(IN) :: NEXP
    REAL(KIND=PRE), DIMENSION(NEXP),          INTENT(IN) :: AMBDA, AR

    ! Outputs
    COMPLEX(KIND=PRE),               INTENT(OUT) :: SP  ! Integral of the Green function over the panel.
    COMPLEX(KIND=PRE), DIMENSION(3), INTENT(OUT) :: VSP_SYM, VSP_ANTISYM ! Gradient of the integral of the Green function with respect to X0I.

    ! Local variables
    INTEGER                              :: KE
    REAL(KIND=PRE)                       :: AMH, AKH, A
    REAL(KIND=PRE)                       :: AQT, R
    REAL(KIND=PRE),    DIMENSION(3)      :: XI, XJ
    REAL(KIND=PRE),    DIMENSION(4)      :: FTS, PSR
    REAL(KIND=PRE),    DIMENSION(3, 4)   :: VTS
    COMPLEX(KIND=PRE), DIMENSION(4)      :: FS
    COMPLEX(KIND=PRE), DIMENSION(3, 4)   :: VS

    !========================================
    ! Part 1: Solve 4 infinite depth problems
    !========================================

    XI(:) = X0I(:)
    XJ(:) = X0J(:)

    ! Distance in xOy plane
    R = NORM2(XI(1:2) - XJ(1:2))

    ! 1.a First infinite depth problem
    CALL COLLECT_DELHOMMEAU_INTEGRALS(                           &
      XI(:), XJ(:), wavenumber,                                  &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      FS(1), VS(:, 1))

    PSR(1) = ONE/(wavenumber*SQRT(R**2+(XI(3)+XJ(3))**2))

    ! 1.b Shift and reflect XI and compute another value of the Green function
    XI(3) = -X0I(3) - 2*depth
    XJ(3) =  X0J(3)
    CALL COLLECT_DELHOMMEAU_INTEGRALS(                           &
      XI(:), XJ(:), wavenumber,                                  &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      FS(2), VS(:, 2))
    VS(3, 2) = -VS(3, 2) ! Reflection of the output vector

    PSR(2) = ONE/(wavenumber*SQRT(R**2+(XI(3)+XJ(3))**2))

    ! 1.c Shift and reflect XJ and compute another value of the Green function
    XI(3) =  X0I(3)
    XJ(3) = -X0J(3) - 2*depth
    CALL COLLECT_DELHOMMEAU_INTEGRALS(                           &
      XI(:), XJ(:), wavenumber,                                  &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      FS(3), VS(:, 3))

    PSR(3) = ONE/(wavenumber*SQRT(R**2+(XI(3)+XJ(3))**2))

    ! 1.d Shift and reflect both XI and XJ and compute another value of the Green function
    XI(3) = -X0I(3) - 2*depth
    XJ(3) = -X0J(3) - 2*depth
    CALL COLLECT_DELHOMMEAU_INTEGRALS(                           &
      XI(:), XJ(:), wavenumber,                                  &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      FS(4), VS(:, 4))
    VS(3, 4) = -VS(3, 4) ! Reflection of the output vector

    PSR(4) = ONE/(wavenumber*SQRT(R**2+(XI(3)+XJ(3))**2))

    ! Add up the results of the four problems
    SP               = SUM(FS(1:4)) - SUM(PSR(1:4))
    VSP_SYM(1:3)     = VS(1:3, 1) + VS(1:3, 4)
    VSP_ANTISYM(1:3) = VS(1:3, 2) + VS(1:3, 3)

    ! Multiply by some coefficients
    AMH  = wavenumber*depth
    AKH  = AMH*TANH(AMH)
    A    = (AMH+AKH)**2/(2*depth*(AMH**2-AKH**2+AKH))

    SP          = A*SP
    VSP_ANTISYM = A*wavenumber*VSP_ANTISYM
    VSP_SYM     = A*wavenumber*VSP_SYM

    !=====================================================
    ! Part 2: Integrate (NEXP+1)×4 terms of the form 1/MM'
    !=====================================================

    DO KE = 1, NEXP
      XI(:) = X0I(:)

      ! 2.a Shift observation point and compute integral
      XI(3) =  X0I(3) + depth*AMBDA(KE) - 2*depth
      CALL COMPUTE_ASYMPTOTIC_RANKINE_SOURCE(XI(:), X0J(:), ONE, FTS(1), VTS(:, 1))

      ! 2.b Shift and reflect observation point and compute integral
      XI(3) = -X0I(3) - depth*AMBDA(KE)
      CALL COMPUTE_ASYMPTOTIC_RANKINE_SOURCE(XI(:), X0J(:), ONE, FTS(2), VTS(:, 2))
      VTS(3, 2) = -VTS(3, 2) ! Reflection of the output vector

      ! 2.c Shift and reflect observation point and compute integral
      XI(3) = -X0I(3) + depth*AMBDA(KE) - 4*depth
      CALL COMPUTE_ASYMPTOTIC_RANKINE_SOURCE(XI(:), X0J(:), ONE, FTS(3), VTS(:, 3))
      VTS(3, 3) = -VTS(3, 3) ! Reflection of the output vector

      ! 2.d Shift observation point and compute integral
      XI(3) =  X0I(3) - depth*AMBDA(KE) + 2*depth
      CALL COMPUTE_ASYMPTOTIC_RANKINE_SOURCE(XI(:), X0J(:), ONE, FTS(4), VTS(:, 4))

      AQT = AR(KE)/2

      ! Add all the contributions
      SP               = SP               + AQT*SUM(FTS(1:4))
      VSP_ANTISYM(1:3) = VSP_ANTISYM(1:3) + AQT*(VTS(1:3, 1) + VTS(1:3, 4))
      VSP_SYM(1:3)     = VSP_SYM(1:3)     + AQT*(VTS(1:3, 2) + VTS(1:3, 3))

    END DO

    RETURN
  END SUBROUTINE

END MODULE GREEN_WAVE

! Copyright (C) 2017-2019 Matthieu Ancellin
! See LICENSE file at <https://github.com/mancellin/libDelhommeau>
MODULE Old_Prony_decomposition

  USE FLOATING_POINT_PRECISION, ONLY: PRE
  USE CONSTANTS

  IMPLICIT NONE

! The code below performs the approximation of the function FF as a sum of exponentials.
! Unlike the rest of the Fortran code, this module has not been completely refactored.
! A more readable and maintainable Python version has been implemented in libDelhommeau/bem/prony_decomposition.py.
! However, as of today (March 2019), the two versions do not give exactly the same result in all cases.
! For compatibility with Nemoh, the old version has thus been preserved.

! Unlike most of the rest of the Fortran code, these functions are only in single precision.

  PUBLIC :: FF
  PUBLIC :: LISC   ! Initialization of AMBDA and AR
  PUBLIC :: EXPORS ! Called by LISC
  PUBLIC :: MCAS   ! Called by EXPORS
  PUBLIC :: HOUSRS ! Called by EXPORS and MCAS
  PUBLIC :: SPRBM  ! Called by EXPORS
  PUBLIC :: SPQFB  ! Called by SPRBM

CONTAINS

  FUNCTION FF(K, K0, M0)
    ! Function F_2(K) = F_1(K) - 2 from (3.47) of Delhommeau's thesis

    ! Input
    REAL, INTENT(IN) :: K, K0, M0

    ! Local variables
    REAL :: COEF, TOL, A, B, C, D, E, F, FF

    COEF = (M0+K0)**2/(M0**2-K0**2+K0)

    TOL = MAX(0.1, 0.1*M0)
    IF (ABS(K-M0) > TOL) THEN
      FF = (K+K0)*EXP(K)/(K*SINH(K)-K0*COSH(K)) - COEF/(K-M0) - 2
    ELSE  ! The fraction above is undefined 0/0 when K == M0
      A = M0 - TOL
      B = M0
      C = M0 + TOL
      D = (A+K0)*EXP(A)/(A*SINH(A)-K0*COSH(A)) - COEF/(A-M0) - 2
      E = COEF/(M0+K0)*(M0+K0+1)               - (COEF/(M0+K0))**2*M0 - 2
      F = (C+K0)*EXP(C)/(C*SINH(C)-K0*COSH(C)) - COEF/(C-M0) - 2
      FF = D*(K-B)*(K-C)/((A-B)*(A-C)) + &
           E*(K-C)*(K-A)/((B-C)*(B-A)) + &
           F*(K-A)*(K-B)/((C-A)*(C-B))
    ENDIF
  END FUNCTION FF


  SUBROUTINE LISC(AK0, wavenumber, &
                  AMBDA, AR, NEXP)
    ! Compute AMBDA and AR and test their values

    INTEGER, PARAMETER :: NEXR = 31
    INTEGER, PARAMETER :: NMAX = 4*(31-1)

    ! Range on which the function FF is tabulated
    REAL, PARAMETER :: A = -0.1
    REAL, PARAMETER :: B = 20.0

    REAL, PARAMETER :: PRECI = 1.0e-2

    ! Inputs
    REAL, INTENT(IN)                 :: AK0, wavenumber

    ! Outputs
    INTEGER, INTENT(OUT)             :: NEXP
    REAL, DIMENSION(31), INTENT(OUT) :: AMBDA, AR

    ! Local variables
    LOGICAL :: ISOR
    INTEGER :: I, J
    INTEGER :: NK, NM, NMO
    REAL :: XX, YY, TT
    REAL :: XT(4*(31-1)+1), YT(4*(31-1)+1) ! Tabulation of FF

    ! Initialize variables to be computed
    AMBDA = 0.0
    AR = 0.0

    ! Number of points in the tabulation (first try)
    NK = 4

62 CONTINUE

    ! Tabulate the function FF
    DO I = 1, (4*NK)+1
      XT(I) = A + (B-A)*(I-1)/(4*NK)
      YT(I) = FF(XT(I), AK0, wavenumber)
    END DO

    ! Compute AMBDA and AR based on this tabulation
    NM = NK
    CALL EXPORS(XT, YT, NM, NMAX, AMBDA, AR)

    ! Test values of AMBDA and AR
    ISOR = .False.
    NMO = 8*NM+1
    DO I = 1, NMO
      XX = (I-1)*B/(NMO-1)

      ! Exact value
      YY = FF(XX, AK0, wavenumber)

      ! Compute the sum of exponentials
      TT = 0.0
      DO J = 1, NM
        TT = TT + AR(J)*EXP(AMBDA(J)*XX)
      END DO

      ! Compare the error to a threshold
      IF (ABS(YY-TT) > PRECI) ISOR = .True.
    END DO

    ! The error was higher than the wanted precision
    IF (ISOR .AND. (NK <= NEXR-2)) THEN
      ! Add more exponentials to the sum and restart
      NK = NK+2
      GOTO 62
    END IF

    ! Final number of exponentials in the sum
    NEXP = NM

    RETURN

  END SUBROUTINE LISC

!---------------------------------------------------------------------

  SUBROUTINE EXPORS(XT, YT, NM, NMAX, AMBDA, AR)
    ! Compute AMBDA and AR based on XT and YT using Prony's method.

    INTEGER, INTENT(IN) :: NMAX
    REAL, INTENT(IN)    :: XT(4*(31-1)+1), YT(4*(31-1)+1)

    INTEGER, INTENT(INOUT) :: NM ! Number of exponentials in the sum.
    ! The number of exponentials will change during the computation, for
    ! instance if some roots of the polynomial are double and thus merged.

    REAL, INTENT(OUT) :: AR(31), AMBDA(31)

    ! Local variables
    INTEGER :: NPP

    REAL    :: SC(31), VR(31), VC(31)
    REAL    :: S(4*(31-1), 31+1)
    COMPLEX :: COM(31)

    INTEGER::I,J,K,JJ,II,IJ,MN,NEXP
    REAL::H,EPS

    ! Assemble an over-determined linear system
    NPP = 4*NM+1
    H = (XT(NPP) - XT(1))/(4*NM)
    K = NPP-NM
    DO I = 1, K
      DO J = 1, NM
        JJ = NM - J + I
        S(I, J) = YT(JJ)
      END DO
      II = NM + I
      S(I, NM+1) = -YT(II)
    END DO

    ! Solve the system
    CALL HOUSRS(S, NMAX, K, NM)

    ! Assemble the coefficients of the polynomial
    DO I = 1, NM
      IJ = NM-I+1
      SC(IJ) = S(I, NM+1)
    END DO
    MN = NM+1
    SC(MN) = 1.0

    ! Get roots of the polynomial
    CALL SPRBM(SC, MN, VR, VC)

    COM(1:NM) = CMPLX(VR(1:NM), VC(1:NM))
    COM(1:NM) = CLOG(COM(1:NM))/H
    VR(1:NM) = REAL(COM(1:NM))
    VC(1:NM) = AIMAG(COM(1:NM))

    ! Keep only the real part of the roots.
    ! In case of a double root, keep only one.
      I=1
      J=0
  100 IF(VC(I))110,111,110
  ! 100 IF (VC(I) == 0) THEN
  111 J=J+1
      AMBDA(J)=VR(I)
      I=I+1
      GO TO 101
    ! ELSE
  110 IF(ABS(VR(I)-VR(I+1))-1.E-5)120,120,121
      ! IF (ABS(VR(I)-VR(I+1)) <= -1.E-5) THEN
  120 J=J+1
      AMBDA(J)=VR(I)
      I=I+2
      GO TO 101
    ! ELSE
  121 J=J+1
      AMBDA(J)=VR(I)
      I=I+1
    ! END IF
    ! END IF
  101 IF(I-NM)100,100,102
  102 NEXP=J

    ! Rewrite AMBDA while keeping only the values between -20.0 and 0.0
    J = 0
    DO I = 1, NEXP
      IF ((AMBDA(I) > -20.0) .AND. (AMBDA(I) <= 0.0)) THEN
        J = J+1
        AMBDA(J) = AMBDA(I)
      END IF
    END DO

    ! Number of relevant values in AMBDA
    NEXP = J
    NM = NEXP

    ! Compute AR
    CALL MCAS(AMBDA, XT, YT, NPP, AR, S, NMAX, NEXP)

    RETURN
  END SUBROUTINE EXPORS

!----------------------------------------------------------------------------

  SUBROUTINE MCAS(AMBDA, XT, YT, NPP, AR, A, NMAX, NEXP)
    ! Compute AR as the least-square solution of an over-determined system.

    REAL, INTENT(IN)    :: AMBDA(31), XT(4*(31-1)+1), YT(4*(31-1)+1)
    INTEGER, INTENT(IN) :: NPP, NMAX, NEXP
    REAL, INTENT(INOUT) :: A(4*(31-1), 31+1)
    REAL, INTENT(OUT)   :: AR(31)

    ! Local variables
    INTEGER :: I, J, L
    REAL :: S, TT, TTT

    ! Assemble the system
    DO I = 1, NEXP
      DO J = 1, NEXP
        S = 0
        DO L = 1, NPP
          TT = (AMBDA(I)+AMBDA(J))*XT(L)
          IF(TT >= -30) THEN
            S = S + EXP(TT)
          END IF
        END DO
        A(I,J) = S
      END DO
    END DO

    DO I = 1, NEXP
      S = 0
      DO L = 1, NPP
        TTT = AMBDA(I)*XT(L)
        IF(TTT >= -30) THEN
          S = S + EXP(TTT)*YT(L)
        END IF
      END DO
      A(I, NEXP+1) = S
    END DO

    ! Solve it
    CALL HOUSRS(A, NMAX, NEXP, NEXP)

    ! Extract results
    DO I = 1, NEXP
      AR(I) = A(I, NEXP+1)
    END DO

    RETURN
  END SUBROUTINE MCAS

!---------------------------------------------------------------------

  SUBROUTINE HOUSRS(A, NMAX, NL, NCC)
    ! Least-square solver for over-determined system.
    ! NCC : Number of columns
    ! NL: Number of lines

    INTEGER, INTENT(IN) :: NMAX, NL, NCC
    REAL, INTENT(INOUT) :: A(NMAX, 31+1)

    ! Local variables
    INTEGER, PARAMETER :: NS = 1
    REAL, PARAMETER :: EPS = 1e-20

    INTEGER :: I, J, K, L
    REAL    :: E, E0, AR, BA, ETA

    IF (NCC > NL) THEN
      PRINT*, ('Error in HOUSRS: number of columns > number of lines')
      STOP
    ENDIF

    DO K = 1, NCC
      E = 0.0
      DO I = K, NL
        E = E + A(I, K)**2
      END DO

      E0 = SQRT(E)
      ! IF(E0.LT.EPS)THEN
      !   WRITE(*, 201)EPS
    ! 201 FORMAT(1X, 'NORME INFERIEURE A ', 1PE16.6/)
      !   STOP
      ! ENDIF
      IF (A(K, K) == 0) THEN
        AR = -E0
      ELSE
        AR = -SIGN(1.0, A(K, K)) * E0
      ENDIF

      ETA = AR*(AR - A(K, K))
      DO J = K+1, NCC+NS
        BA = (A(K, K)-AR)*A(K, J)
        DO I = K+1, NL
          BA = BA+A(I, K)*A(I, J)
        END DO
        A(K, J) = A(K, J)+BA/AR
        DO I = K+1, NL
          A(I, J) = A(I, J)-A(I, K)*BA/ETA
        END DO
      END DO

      A(K, K) = AR
      DO I = K+1, NL
        A(I, K) = 0
      END DO
    END DO

    DO J = 1, NS
      A(NCC, NCC+J) = A(NCC, NCC+J)/A(NCC, NCC)
      DO L = 2, NCC
        DO I = NCC+2-L, NCC
          A(NCC+1-L, NCC+J) = A(NCC+1-L, NCC+J) - A(NCC+1-L, I)*A(I, NCC+J)
        END DO
        A(NCC+1-L, NCC+J) = A(NCC+1-L, NCC+J)/A(NCC+1-L, NCC+1-L)
      END DO
    END DO

    RETURN
  END SUBROUTINE HOUSRS

!----------------------------------------------------------------------

  SUBROUTINE SPRBM(C,IC,RR,RC)
    ! Somehow get the roots of a polynomial.

    INTEGER::IC,IR,IER
    REAL :: C(31), RR(31), RC(31)
    REAL :: POL(31)
    INTEGER::I,J,L,N,LIM,IST
    REAL::A,B,H
    REAL::EPS,Q1,Q2,Q(4)

      EPS=1.E-6
      LIM=100
      IR=IC+1
    1 IR=IR-1
      IF(IR-1)42,42,2
    2 IF(C(IR))3,1,3
    3 IER=0
      J=IR
      L=0
      A=C(IR)
      DO 8 I=1,IR
      IF(L)4,4,7
    4 IF(C(I))6,5,6
    5 RR(I)=0.
      RC(I)=0.
      POL(J)=0.
      J=J-1
      GO TO 8
    6 L=1
      IST=I
      J=0
    7 J=J+1
      C(I)=C(I)/A
      POL(J)=C(I)
      IF(ABS(POL(J))-1.E27)8,42,42
    8 CONTINUE
      Q1=0.
      Q2=0.
    9 IF(J-2)33,10,14
   10 A=POL(1)
      RR(IST)=-A
      RC(IST)=0.
      IR=IR-1
      Q2=0.
      IF(IR-1)13,13,11
   11 DO 12 I=2,IR
      Q1=Q2
      Q2=POL(I+1)
   12 POL(I)=A*Q2+Q1
   13 POL(IR+1)=A+Q2
      GO TO 34
   14 DO 22 L=1,10
      N=1
   15 Q(1)=Q1
      Q(2)=Q2
      CALL SPQFB(POL,J,Q,LIM,I)
      IF(I)16,24,23
   16 IF(Q1)18,17,18
   17 IF(Q2)18,21,18
   18 GOTO(19,20,19,21),N
   19 Q1=-Q1
      N=N+1
      GO TO 15
   20 Q2=-Q2
      N=N+1
      GO TO 15
   21 Q1=1.+Q1
   22 Q2=1.-Q2
      IER=3
      IR=IR-J
      GOTO 45
   23 IER=1
   24 Q1=Q(1)
      Q2=Q(2)
      B=0.
      A=0.
      I=J
   25 H=-Q1*B-Q2*A+POL(I)
      POL(I)=B
      B=A
      A=H
      I=I-1
      IF(I-2)26,26,25
   26 POL(2)=B
      POL(1)=A
      L=IR-1
      IF(J-L)27,27,29
   27 DO 28 I=J,L
   28 POL(I-1)=POL(I-1)+POL(I)*Q2+POL(I+1)*Q1
   29 POL(L)=POL(L)+POL(L+1)*Q2+Q1
      POL(IR)=POL(IR)+Q2
      H=-.5*Q2
      A=H*H-Q1
      B=SQRT(ABS(A))
      IF(A)30,30,31
   30 RR(IST)=H
      RC(IST)=B
      IST=IST+1
      RR(IST)=H
      RC(IST)=-B
      GO TO 32
   31 B=H+SIGN(B,H)
      RR(IST)=Q1/B
      RC(IST)=0.
      IST=IST+1
      RR(IST)=B
      RC(IST)=0.
   32 IST=IST+1
      J=J-2
      GO TO 9
   33 IR=IR-1
   34 A=0.
      DO 38 I=1,IR
      Q1=C(I)
      Q2=POL(I+1)
      POL(I)=Q2
      IF(Q1)35,36,35
   35 Q2=(Q1-Q2)/Q1
   36 Q2=ABS(Q2)
      IF(Q2-A)38,38,37
   37 A=Q2
   38 CONTINUE
      I=IR+1
      POL(I)=1.
      RR(I)=A
      RC(I)=0.
      IF(IER)39,39,41
   39 IF(A-EPS)41,41,40
   40 IER=-1
   41 GOTO 45
   42 IER=2
      IR=0
   45 IF(IER-2)46,47,46
   47 WRITE(*,48)IER
   48 FORMAT(/5X,'IER = ',I3,'  ERREUR DANS SPRBM'/)
      STOP
   46 RETURN

  END SUBROUTINE SPRBM

!----------------------------------------------------------------

  SUBROUTINE SPQFB(C,IC,Q,LIM,IER)

    INTEGER::IC,LIM,IER,I,J,L,LL
    REAL:: C(31),Q(4)
    REAL:: H,HH,A,A1,AA,B,BB,B1,C1,CA,CB,CC,CD,DQ1,DQ2,EPS,EPS1
    REAL:: Q1,Q2,QQ1,QQ2,QQQ1,QQQ2

!--------- Value non initialized in previous versions ?!
      H=0.
      HH=0.
!---------
      IER=0
      J=IC+1
    1 J=J-1
      IF(J-1) 40,40,2
    2 IF(C(J)) 3,1,3
    3 A=C(J)
      IF(A-1.) 4,6,4
    4 DO 5 I=1,J
      C(I)=C(I)/A
      IF(ABS(C(I))-1.E27)5,40,40
    5 CONTINUE
    6 IF(J-3) 41,38,7
    7 EPS=1.E-14
      EPS1=1.E-6
      L=0
      LL=0
      Q1=Q(1)
      Q2=Q(2)
      QQ1=0.
      QQ2=0.
      AA=C(1)
      BB=C(2)
      CB=ABS(AA)
      CA=ABS(BB)
      IF(CB-CA) 8,9,10
    8 CC=CB+CB
      CB=CB/CA
      CA=1.
      GO TO 11
    9 CC=CA+CA
      CA=1.
      CB=1.
      GO TO 11
   10 CC=CA+CA
      CA=CA/CB
      CB=1.
   11 CD=CC*.1
   12 A=0.
      B=A
      A1=A
      B1=A
      I=J
      QQQ1=Q1
      QQQ2=Q2
      DQ1=HH
      DQ2=H
   13 H=-Q1*B-Q2*A+C(I)
      IF(ABS(H)-1.E27)14,42,42
   14 B=A
      A=H
      I=I-1
      IF(I-1) 18,15,16
   15 H=0.
   16 H=-Q1*B1-Q2*A1+H
      IF(ABS(H)-1.E27)17,42,42
   17 C1=B1
      B1=A1
      A1=H
      GO TO 13
   18 H=CA*ABS(A)+CB*ABS(B)
      IF(LL) 19,19,39
   19 L=L+1
      IF(ABS(A)-EPS*ABS(C(1))) 20,20,21
   20 IF(ABS(B)-EPS*ABS(C(2))) 39,39,21
   21 IF(H-CC) 22,22,23
   22 AA=A
      BB=B
      CC=H
      QQ1=Q1
      QQ2=Q2
   23 IF(L-LIM) 28,28,24
   24 IF(H-CD) 43,43,25
   25 IF(Q(1)) 27,26,27
   26 IF(Q(2)) 27,42,27
   27 Q(1)=0.
      Q(2)=0.
      GO TO 7
   28 HH=AMAX1(ABS(A1),ABS(B1),ABS(C1))
      IF(HH) 42,42,29
   29 A1=A1/HH
      B1=B1/HH
      C1=C1/HH ! Has C1 been initialized?
      H=A1*C1-B1*B1
      IF(H) 30,42,30
   30 A=A/HH
      B=B/HH
      HH=(B*A1-A*B1)/H
      H=(A*C1-B*B1)/H
      Q1=Q1+HH
      Q2=Q2+H
      IF(ABS(HH)-EPS*ABS(Q1)) 31,31,33
   31 IF(ABS(H)-EPS*ABS(Q2)) 32,32,33
   32 LL=1
      GO TO 12
   33 IF(L-1)12,12,34
   34 IF(ABS(HH)-EPS1*ABS(Q1)) 35,35,12
   35 IF(ABS(H)-EPS1*ABS(Q2)) 36,36,12
   36 IF(ABS(QQQ1*HH)-ABS(Q1*DQ1)) 37,44,44
   37 IF(ABS(QQQ2*H)-ABS(Q2*DQ2)) 12,44,44
   38 Q(1)=C(1)
      Q(2)=C(2)
      Q(3)=0.
      Q(4)=0.
      GOTO 45
   39 Q(1)=Q1
      Q(2)=Q2
      Q(3)=A
      Q(4)=B
      GOTO 45
   40 IER=-1
      GOTO 45
   41 IER=-2
      GOTO 45
   42 IER=-3
      GO TO 44
   43 IER=1
   44 Q(1)=QQ1
      Q(2)=QQ2
      Q(3)=AA
      Q(4)=BB
   45 RETURN

  END SUBROUTINE SPQFB

END MODULE Old_Prony_decomposition

MODULE MATRICES

  USE CONSTANTS

  USE GREEN_RANKINE
  USE GREEN_WAVE

  IMPLICIT NONE

CONTAINS

  SUBROUTINE ADD_RANKINE_PART_TO_THE_MATRICES(                        &
      nb_faces_1,                                                     &
      centers_1, normals_1,                                           &
      nb_vertices_2, nb_faces_2,                                      &
      vertices_2, faces_2, centers_2, normals_2, areas_2, radiuses_2, &
      coeff,                                                          &
      S, K)

    INTEGER,                                     INTENT(IN) :: nb_faces_1, nb_faces_2, nb_vertices_2
    REAL(KIND=PRE), DIMENSION(nb_faces_1, 3),    INTENT(IN) :: centers_1, normals_1
    REAL(KIND=PRE), DIMENSION(nb_vertices_2, 3), INTENT(IN) :: vertices_2
    INTEGER,        DIMENSION(nb_faces_2, 4),    INTENT(IN) :: faces_2
    REAL(KIND=PRE), DIMENSION(nb_faces_2, 3),    INTENT(IN) :: centers_2, normals_2
    REAL(KIND=PRE), DIMENSION(nb_faces_2),       INTENT(IN) :: areas_2, radiuses_2

    REAL(KIND=PRE), INTENT(IN) :: coeff

    COMPLEX(KIND=PRE), DIMENSION(nb_faces_1, nb_faces_2), INTENT(INOUT) :: S
    COMPLEX(KIND=PRE), DIMENSION(nb_faces_1, nb_faces_2), INTENT(INOUT) :: K

    ! Local variables
    INTEGER :: I, J
    REAL(KIND=PRE)               :: SP1
    REAL(KIND=PRE), DIMENSION(3) :: VSP1

    DO I = 1, nb_faces_1
      !$OMP PARALLEL DO PRIVATE(J, SP1, VSP1)
      DO J = 1, nb_faces_2

        CALL COMPUTE_INTEGRAL_OF_RANKINE_SOURCE( &
          centers_1(I, :),                       &
          vertices_2(faces_2(J, :), :),          &
          centers_2(J, :),                       &
          normals_2(J, :),                       &
          areas_2(J),                            &
          radiuses_2(J),                         &
          SP1, VSP1                              &
          )

        ! Store into influence matrix
        S(I, J) = S(I, J) - coeff * SP1/(4*PI)                                ! Green function
        K(I, J) = K(I, J) - coeff * DOT_PRODUCT(normals_1(I, :), VSP1)/(4*PI) ! Gradient of the Green function

      END DO
      !$OMP END PARALLEL DO
    END DO

  END SUBROUTINE

  ! =====================================================================

  SUBROUTINE ADD_WAVE_PART_TO_THE_MATRICES(  &
      nb_faces_1, centers_1, normals_1,  &
      nb_faces_2, nb_quad_points,        &
      quad_points, quad_weights,         &
      wavenumber, depth,                 &
      XR, XZ, APD,                       &
      NEXP, AMBDA, AR,                   &
      coeff,                             &
      same_body,                         &
      S, K)

    ! Mesh data
    INTEGER,                                  INTENT(IN) :: nb_faces_1, nb_faces_2
    REAL(KIND=PRE), DIMENSION(nb_faces_1, 3), INTENT(IN) :: normals_1, centers_1

    INTEGER,                                                  INTENT(IN) :: nb_quad_points
    REAL(KIND=PRE), DIMENSION(nb_faces_2, nb_quad_points, 3), INTENT(IN) :: quad_points
    REAL(KIND=PRE), DIMENSION(nb_faces_2, nb_quad_points),    INTENT(IN) :: quad_weights

    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber, depth

    ! Tabulated integrals
    REAL(KIND=PRE), DIMENSION(328),           INTENT(IN) :: XR
    REAL(KIND=PRE), DIMENSION(46),            INTENT(IN) :: XZ
    REAL(KIND=PRE), DIMENSION(328, 46, 2, 2), INTENT(IN) :: APD

    ! Prony decomposition for finite depth
    INTEGER,                                  INTENT(IN) :: NEXP
    REAL(KIND=PRE), DIMENSION(NEXP),          INTENT(IN) :: AMBDA, AR

    REAL(KIND=PRE), INTENT(IN) :: coeff

    ! Trick to save some time
    LOGICAL,                                  INTENT(IN) :: same_body

    ! Output
    COMPLEX(KIND=PRE), DIMENSION(nb_faces_1, nb_faces_2), INTENT(INOUT) :: S
    COMPLEX(KIND=PRE), DIMENSION(nb_faces_1, nb_faces_2), INTENT(INOUT) :: K

    ! Local variables
    INTEGER                         :: I, J, Q
    COMPLEX(KIND=PRE)               :: SP2
    COMPLEX(KIND=PRE), DIMENSION(3) :: VSP2_SYM, VSP2_ANTISYM

    IF ((SAME_BODY) .AND. (nb_quad_points == 1)) THEN
      ! If we are computing the influence of some cells upon themselves, the resulting matrices have some symmetries.
      ! This is due to the symmetry of the Green function, and the way the integral on the face is approximated.
      ! (More precisely, the Green function is symmetric and its derivative is the sum of a symmetric part and an anti-symmetric
      ! part.)

      DO I = 1, nb_faces_1
        !$OMP PARALLEL DO PRIVATE(J, SP2, VSP2_SYM, VSP2_ANTISYM)
        DO J = I, nb_faces_2

          IF (depth == INFINITE_DEPTH) THEN
            CALL WAVE_PART_INFINITE_DEPTH &
              (wavenumber,                &
              centers_1(I, :),            &
              quad_points(J, 1, :),       & ! centers_2(J, :),
              XR, XZ, APD,                &
              SP2, VSP2_SYM               &
              )
            VSP2_ANTISYM(:) = ZERO
          ELSE
            CALL WAVE_PART_FINITE_DEPTH   &
              (wavenumber,                &
              centers_1(I, :),            &
              quad_points(J, 1, :),       & ! centers_2(J, :),
              depth,                      &
              XR, XZ, APD,                &
              NEXP, AMBDA, AR,            &
              SP2, VSP2_SYM, VSP2_ANTISYM &
              )
          END IF

          S(I, J) = S(I, J) - coeff/(4*PI) * SP2 * quad_weights(J, 1)
          K(I, J) = K(I, J) - coeff/(4*PI) * &
            DOT_PRODUCT(normals_1(I, :), VSP2_SYM + VSP2_ANTISYM) * quad_weights(J, 1)

          IF (.NOT. I==J) THEN
            VSP2_SYM(1:2) = -VSP2_SYM(1:2)
            S(J, I) = S(J, I) - coeff/(4*PI) * SP2 * quad_weights(I, 1)
            K(J, I) = K(J, I) - coeff/(4*PI) * &
              DOT_PRODUCT(normals_1(J, :), VSP2_SYM - VSP2_ANTISYM) * quad_weights(I, 1)
          END IF

        END DO
        !$OMP END PARALLEL DO
      END DO

    ELSE
      ! General case: if we are computing the influence of a some cells on other cells, we have to compute all the coefficients.

      DO I = 1, nb_faces_1
        !$OMP PARALLEL DO PRIVATE(J, SP2, VSP2_SYM, VSP2_ANTISYM)
        DO J = 1, nb_faces_2
          DO Q = 1, nb_quad_points
            IF (depth == INFINITE_DEPTH) THEN
              CALL WAVE_PART_INFINITE_DEPTH &
                (wavenumber,                &
                centers_1(I, :),            &
                quad_points(J, Q, :),       &
                XR, XZ, APD,                &
                SP2, VSP2_SYM               &
                )
              VSP2_ANTISYM(:) = ZERO
            ELSE
              CALL WAVE_PART_FINITE_DEPTH   &
                (wavenumber,                &
                centers_1(I, :),            &
                quad_points(J, Q, :),       &
                depth,                      &
                XR, XZ, APD,                &
                NEXP, AMBDA, AR,            &
                SP2, VSP2_SYM, VSP2_ANTISYM &
                )
            END IF

            S(I, J) = S(I, J) - coeff/(4*PI) * SP2 * quad_weights(J, Q)
            K(I, J) = K(I, J) - coeff/(4*PI) * &
              DOT_PRODUCT(normals_1(I, :), VSP2_SYM + VSP2_ANTISYM) * quad_weights(J, Q)

          END DO
        END DO
        !$OMP END PARALLEL DO
      END DO
    END IF

  END SUBROUTINE

  ! =====================================================================

  SUBROUTINE BUILD_MATRICES(                          &
      nb_faces_1, centers_1, normals_1,               &
      nb_vertices_2, nb_faces_2, vertices_2, faces_2, &
      centers_2, normals_2, areas_2, radiuses_2,      &
      nb_quad_points, quad_points, quad_weights,      &
      wavenumber, depth,                              &
      coeffs,                                         &
      XR, XZ, APD,                                    &
      NEXP, AMBDA, AR,                                &
      same_body,                                      &
      S, K)

    ! Mesh data
    INTEGER,                                     INTENT(IN) :: nb_faces_1, nb_faces_2, nb_vertices_2
    REAL(KIND=PRE), DIMENSION(nb_faces_1, 3),    INTENT(IN) :: centers_1, normals_1
    REAL(KIND=PRE), DIMENSION(nb_vertices_2, 3), INTENT(IN) :: vertices_2
    INTEGER,        DIMENSION(nb_faces_2, 4),    INTENT(IN) :: faces_2
    REAL(KIND=PRE), DIMENSION(nb_faces_2, 3),    INTENT(IN) :: centers_2, normals_2
    REAL(KIND=PRE), DIMENSION(nb_faces_2),       INTENT(IN) :: areas_2, radiuses_2

    INTEGER,                                                  INTENT(IN) :: nb_quad_points
    REAL(KIND=PRE), DIMENSION(nb_faces_2, nb_quad_points, 3), INTENT(IN) :: quad_points
    REAL(KIND=PRE), DIMENSION(nb_faces_2, nb_quad_points),    INTENT(IN) :: quad_weights

    LOGICAL,                                  INTENT(IN) :: same_body

    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber, depth

    REAL(KIND=PRE), DIMENSION(3) :: coeffs

    ! Tabulated integrals
    REAL(KIND=PRE), DIMENSION(328),           INTENT(IN) :: XR
    REAL(KIND=PRE), DIMENSION(46),            INTENT(IN) :: XZ
    REAL(KIND=PRE), DIMENSION(328, 46, 2, 2), INTENT(IN) :: APD

    ! Prony decomposition for finite depth
    INTEGER,                                  INTENT(IN) :: NEXP
    REAL(KIND=PRE), DIMENSION(NEXP),          INTENT(IN) :: AMBDA, AR

    ! Output
    COMPLEX(KIND=PRE), DIMENSION(nb_faces_1, nb_faces_2), INTENT(OUT) :: S
    COMPLEX(KIND=PRE), DIMENSION(nb_faces_1, nb_faces_2), INTENT(OUT) :: K

    ! Local variables
    INTEGER :: I
    REAL(KIND=PRE), DIMENSION(nb_faces_1, 3) :: reflected_centers_1, reflected_normals_1


    !!!!!!!!!!!!!!!!!!!!
    !  Initialization  !
    !!!!!!!!!!!!!!!!!!!!

    S(:, :) = CMPLX(0.0, 0.0, KIND=PRE)
    K(:, :) = CMPLX(0.0, 0.0, KIND=PRE)


    !!!!!!!!!!!!!!!!!!
    !  Rankine part  !
    !!!!!!!!!!!!!!!!!!

    IF (coeffs(1) .NE. ZERO) THEN
      CALL ADD_RANKINE_PART_TO_THE_MATRICES(                            &
        nb_faces_1,                                                     &
        centers_1, normals_1,                                           &
        nb_vertices_2, nb_faces_2,                                      &
        vertices_2, faces_2, centers_2, normals_2, areas_2, radiuses_2, &
        coeffs(1),                                                      &
        S, K)
    END IF


    !!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !  Reflected Rankine part  !
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!

    IF (coeffs(2) .NE. ZERO) THEN

      IF (depth == INFINITE_DEPTH) THEN
        ! Reflection through free surface
        reflected_centers_1(:, 1:2) = centers_1(:, 1:2)
        reflected_centers_1(:, 3)   = -centers_1(:, 3)
      ELSE
        ! Reflection through sea bottom
        reflected_centers_1(:, 1:2) = centers_1(:, 1:2)
        reflected_centers_1(:, 3)   = -centers_1(:, 3) - 2*depth
      END IF

      reflected_normals_1(:, 1:2) = normals_1(:, 1:2)
      reflected_normals_1(:, 3)   = -normals_1(:, 3)

      CALL ADD_RANKINE_PART_TO_THE_MATRICES(                            &
        nb_faces_1,                                                     &
        reflected_centers_1, reflected_normals_1,                       &
        nb_vertices_2, nb_faces_2,                                      &
        vertices_2, faces_2, centers_2, normals_2, areas_2, radiuses_2, &
        coeffs(2),                                                      &
        S, K)

    END IF

    !!!!!!!!!!!!!!!
    !  Wave part  !
    !!!!!!!!!!!!!!!

    IF (coeffs(3) .NE. ZERO) THEN

      CALL ADD_WAVE_PART_TO_THE_MATRICES(  &
        nb_faces_1, centers_1, normals_1,  &
        nb_faces_2, nb_quad_points,        &
        quad_points, quad_weights,         &
        wavenumber, depth,                 &
        XR, XZ, APD,                       &
        NEXP, AMBDA, AR,                   &
        coeffs(3),                         &
        same_body,                         &
        S, K)

    END IF

    !!!!!!!!!!!!!

    IF (SAME_BODY) THEN
      DO I = 1, nb_faces_1
        K(I, I) = K(I, I) + 0.5
      END DO
    END IF

    RETURN

  END SUBROUTINE

  ! =====================================================================

END MODULE MATRICES

! Copyright (C) 2017-2019 Matthieu Ancellin
! See LICENSE file at <https://github.com/mancellin/capytaine>
MODULE GREEN_WAVE

  USE CONSTANTS
  USE INITIALIZE_GREEN_WAVE
  USE GREEN_RANKINE, ONLY: COMPUTE_ASYMPTOTIC_RANKINE_SOURCE

  IMPLICIT NONE

  ! Dependancies between the functions of this module:
  ! (from top to bottom: "is called by")
  !
  !            LAGRANGE_POLYNOMIAL_INTERPOLATION
  !                          |
  !              COMPUTE_INTEGRALS_WRT_THETA       (COMPUTE_ASYMPTOTIC_RANKINE_SOURCE)
  !                        /   \                    /
  ! WAVE_PART_INFINITE_DEPTH   WAVE_PART_FINITE_DEPTH
  !                        \   /
  !              BUILD_MATRICES_WAVE_SOURCE
  !                          |
  !                    (python code)

CONTAINS

  ! =====================================================================

  SUBROUTINE LAGRANGE_POLYNOMIAL_INTERPOLATION &
    (AKR, AKZ,                                 &
     XR, XZ, APD,                              &
     PD1X, PD2X, PD1Z, PD2Z)
   ! Helper function used in the following subroutine to interpolate between the tabulated integrals.

    ! Inputs
    REAL(KIND=PRE),                        INTENT(IN) :: AKR, AKZ
    REAL(KIND=PRE), DIMENSION(3),          INTENT(IN) :: XR
    REAL(KIND=PRE), DIMENSION(3),          INTENT(IN) :: XZ
    REAL(KIND=PRE), DIMENSION(3, 3, 2, 2), INTENT(IN) :: APD

    ! Output
    REAL(KIND=PRE), INTENT(OUT) :: PD1X, PD2X, PD1Z, PD2Z

    ! Local variable
    REAL(KIND=PRE), DIMENSION(3) :: XL, ZL

    XL(1) = PL2(XR(2), XR(3), XR(1), AKR)
    XL(2) = PL2(XR(3), XR(1), XR(2), AKR)
    XL(3) = PL2(XR(1), XR(2), XR(3), AKR)
    ZL(1) = PL2(XZ(2), XZ(3), XZ(1), AKZ)
    ZL(2) = PL2(XZ(3), XZ(1), XZ(2), AKZ)
    ZL(3) = PL2(XZ(1), XZ(2), XZ(3), AKZ)

    PD1Z = DOT_PRODUCT(XL, MATMUL(APD(:, :, 1, 2), ZL))
    PD2Z = DOT_PRODUCT(XL, MATMUL(APD(:, :, 2, 2), ZL))
    PD1X = DOT_PRODUCT(XL, MATMUL(APD(:, :, 1, 1), ZL))
    PD2X = DOT_PRODUCT(XL, MATMUL(APD(:, :, 2, 1), ZL))

  CONTAINS

    REAL(KIND=PRE) FUNCTION PL2(U1, U2, U3, XU)
      REAL(KIND=PRE) :: U1, U2, U3, XU
      PL2 = ((XU-U1)*(XU-U2))/((U3-U1)*(U3-U2))
      RETURN
    END FUNCTION

  END SUBROUTINE LAGRANGE_POLYNOMIAL_INTERPOLATION

  ! =====================================================================

  SUBROUTINE COMPUTE_INTEGRALS_WRT_THETA                         &
      (XI, XJ, wavenumber,                                       &
      tabulated_r_range, tabulated_Z_range, tabulated_integrals, &
      FS, VS)
    ! Compute the expression FS = Re[ ∫(J(ζ) - 1/ζ)dθ ] + i Re[ ∫(e^ζ)dθ ] and the integrals appearing in its gradient.
    ! For this, this function uses tabulated values of the following integrals:
    ! PD1X = Re[ ∫(-i cosθ)(J(ζ) - 1/ζ)dθ ]
    ! PD2X = Re[ ∫(-i cosθ)(e^ζ)dθ ]
    ! PD1Z = Re[ ∫(J(ζ) - 1/ζ)dθ ]
    ! PD2Z = Re[ ∫(e^ζ)dθ ]
    ! (See theory manual for the definition of the symbols above.)

    ! Inputs
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN) :: XI, XJ
    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber

    ! Tabulated data
    REAL(KIND=PRE), DIMENSION(328),           INTENT(IN) :: tabulated_r_range
    REAL(KIND=PRE), DIMENSION(46),            INTENT(IN) :: tabulated_Z_range
    REAL(KIND=PRE), DIMENSION(328, 46, 2, 2), INTENT(IN) :: tabulated_integrals

    ! Outputs
    COMPLEX(KIND=PRE),                        INTENT(OUT) :: FS  ! the integral
    COMPLEX(KIND=PRE), DIMENSION(3),          INTENT(OUT) :: VS  ! its gradient

    ! Local variables
    INTEGER        :: KI, KJ
    REAL(KIND=PRE) :: r, dimless_r, Z, dimless_Z, R1
    REAL(KIND=PRE) :: SIK, CSK, SQ, EPZ
    REAL(KIND=PRE) :: PD1X, PD2X, PD1Z, PD2Z

    r = NORM2(XI(1:2) - XJ(1:2))
    dimless_r = wavenumber*r

    Z = XI(3) + XJ(3)
    dimless_Z = wavenumber*Z

    R1 = SQRT(r**2 + Z**2)

    IF ((R1 < 1e-5) .OR. (wavenumber == 0)) THEN
      PRINT*, "Error: Impossible to compute the wave part of the Green function (division by zero)."
      ERROR STOP
    ENDIF

    !=====================================================================================
    ! Evaluate the elementary integrals PDnX and PDnZ depending on dimless_Z and dimless_r
    !=====================================================================================
    IF ((MINVAL(tabulated_Z_range) < dimless_Z) .AND. (dimless_Z < MAXVAL(tabulated_Z_range))) THEN
      IF ((MINVAL(tabulated_r_range) <= dimless_r) .AND. (dimless_r < MAXVAL(tabulated_r_range))) THEN
        ! Within the range of tabulated data
        ! Note that MINVAL(tabulated_r_range) == 0, so one of the conditions is not actually useful.

        IF (dimless_r < 1) THEN
          KI = INT(5*(LOG10(dimless_r+1e-20)+6)+1)
        ELSE
          KI = INT(3*dimless_r+28)
        ENDIF
        KI = MAX(MIN(KI, 327), 2)

        IF (dimless_Z < -1e-2) THEN
          KJ = INT(8*(LOG10(-dimless_Z)+4.5))
        ELSE
          KJ = INT(5*(LOG10(-dimless_Z)+6))
        ENDIF
        KJ = MAX(MIN(KJ, 45), 2)

        CALL LAGRANGE_POLYNOMIAL_INTERPOLATION                           &
             (dimless_r, dimless_Z,                                      &
             tabulated_r_range(KI-1:KI+1), tabulated_Z_range(KJ-1:KJ+1), &
             tabulated_integrals(KI-1:KI+1, KJ-1:KJ+1, :, :),            &
             PD1X, PD2X, PD1Z, PD2Z)

      ELSE  ! MAXVAL(tabulated_r_range) < dimless_r
        ! Asymptotic expression for (horizontally) distant panels

        EPZ  = EXP(dimless_Z)
        SQ   = SQRT(2*PI/dimless_r)
        CSK  = COS(dimless_r-PI/4)
        SIK  = SIN(dimless_r-PI/4)

        PD1X = PI*EPZ*SQ*(CSK - 0.5*SIK/dimless_r) - PI*r/(wavenumber**2*R1**3)
        PD2X =    EPZ*SQ*(SIK + 0.5*CSK/dimless_r)
        PD1Z = -EPZ*SQ*SIK*PI + PI*dimless_Z/(wavenumber*R1)**3
        PD2Z =  EPZ*SQ*CSK
      ENDIF

      !================================================
      ! Add the elementary integrals to build FS and VS
      !================================================

      FS    = CMPLX(PD1Z, PD2Z, KIND=PRE)
      VS(1) = (XI(1) - XJ(1))/r * CMPLX(-PD1X, -PD2X, KIND=PRE)
      VS(2) = (XI(2) - XJ(2))/r * CMPLX(-PD1X, -PD2X, KIND=PRE)
      VS(3) = CMPLX(PD1Z, PD2Z, KIND=PRE)

      IF (r < REAL(1e-5, KIND=PRE)) THEN
        ! I'm not totally sure why this is here, but it seems to be necessary.
        VS(1:2) = CMPLX(0.0, 0.0, KIND=PRE)
      END IF

    ELSE  ! dimless_Z < MINVAL(tabulated_Z_range) or MAXVAL(tabulated_Z_range) < dimless_Z
      FS      = CMPLX(PI*dimless_Z/(wavenumber*R1)**3, 0.0, KIND=PRE)
      VS(1:3) = CMPLX(0.0, 0.0, KIND=PRE)
    ENDIF

    RETURN
  END SUBROUTINE COMPUTE_INTEGRALS_WRT_THETA

  ! =========================

  SUBROUTINE WAVE_PART_INFINITE_DEPTH &
      (wavenumber, X0I, X0J,          &
      XR, XZ, APD,                    &
      SP, VSP)
    ! Compute the wave part of the Green function in the infinite depth case.
    ! This is mostly the integral computed by the subroutine above.

    ! Inputs
    REAL(KIND=PRE),                           INTENT(IN)  :: wavenumber
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN)  :: X0I   ! Coordinates of the source point
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN)  :: X0J   ! Coordinates of the center of the integration panel

    ! Tabulated data
    REAL(KIND=PRE), DIMENSION(328),           INTENT(IN) :: XR
    REAL(KIND=PRE), DIMENSION(46),            INTENT(IN) :: XZ
    REAL(KIND=PRE), DIMENSION(328, 46, 2, 2), INTENT(IN) :: APD

    ! Outputs
    COMPLEX(KIND=PRE),               INTENT(OUT) :: SP  ! Integral of the Green function over the panel.
    COMPLEX(KIND=PRE), DIMENSION(3), INTENT(OUT) :: VSP ! Gradient of the integral of the Green function with respect to X0I.

    ! Local variables
    REAL(KIND=PRE), DIMENSION(3) :: XJ_REFLECTION

    ! The integrals
    CALL COMPUTE_INTEGRALS_WRT_THETA(X0I, X0J, wavenumber, XR, XZ, APD, SP, VSP(:))
    SP  = 2*CMPLX(wavenumber/PI*REAL(SP),     wavenumber*AIMAG(SP),   KIND=PRE)
    VSP = 2*CMPLX(wavenumber**2/PI*REAL(VSP), wavenumber**2*AIMAG(VSP), KIND=PRE)

    ! Only one singularity is missing in the derivative
    XJ_REFLECTION(1:2) = X0J(1:2)
    XJ_REFLECTION(3) = - X0J(3)
    VSP = VSP - 2*(X0I - XJ_REFLECTION)/(NORM2(X0I-XJ_REFLECTION)**3)

    RETURN
  END SUBROUTINE WAVE_PART_INFINITE_DEPTH

  ! ======================

  SUBROUTINE WAVE_PART_FINITE_DEPTH &
      (wavenumber, X0I, X0J, depth, &
      XR, XZ, APD,                  &
      NEXP, AMBDA, AR,              &
      SP, VSP_SYM, VSP_ANTISYM)
    ! Compute the frequency-dependent part of the Green function in the finite depth case.

    ! Inputs
    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber, depth
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN) :: X0I  ! Coordinates of the source point
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN) :: X0J  ! Coordinates of the center of the integration panel

    REAL(KIND=PRE), DIMENSION(328),           INTENT(IN) :: XR
    REAL(KIND=PRE), DIMENSION(46),            INTENT(IN) :: XZ
    REAL(KIND=PRE), DIMENSION(328, 46, 2, 2), INTENT(IN) :: APD

    INTEGER,                                  INTENT(IN) :: NEXP
    REAL(KIND=PRE), DIMENSION(NEXP),          INTENT(IN) :: AMBDA, AR

    ! Outputs
    COMPLEX(KIND=PRE),               INTENT(OUT) :: SP  ! Integral of the Green function over the panel.
    COMPLEX(KIND=PRE), DIMENSION(3), INTENT(OUT) :: VSP_SYM, VSP_ANTISYM ! Gradient of the integral of the Green function with respect to X0I.

    ! Local variables
    INTEGER                              :: KE
    REAL(KIND=PRE)                       :: AMH, AKH, A, COF1, COF2, COF3, COF4
    REAL(KIND=PRE)                       :: AQT, R
    REAL(KIND=PRE),    DIMENSION(3)      :: XI, XJ
    REAL(KIND=PRE),    DIMENSION(4)      :: FTS, PSR
    REAL(KIND=PRE),    DIMENSION(3, 4)   :: VTS
    COMPLEX(KIND=PRE), DIMENSION(4)      :: FS
    COMPLEX(KIND=PRE), DIMENSION(3, 4)   :: VS

    !========================================
    ! Part 1: Solve 4 infinite depth problems
    !========================================

    XI(:) = X0I(:)
    XJ(:) = X0J(:)

    ! Distance in xOy plane
    R = NORM2(XI(1:2) - XJ(1:2))

    ! 1.a First infinite depth problem
    CALL COMPUTE_INTEGRALS_WRT_THETA(XI(:), XJ(:), wavenumber, XR, XZ, APD, FS(1), VS(:, 1))

    PSR(1) = PI/(wavenumber*SQRT(R**2+(XI(3)+XJ(3))**2))

    ! 1.b Shift and reflect XI and compute another value of the Green function
    XI(3) = -X0I(3) - 2*depth
    XJ(3) =  X0J(3)
    CALL COMPUTE_INTEGRALS_WRT_THETA(XI(:), XJ(:), wavenumber, XR, XZ, APD, FS(2), VS(:, 2))
    VS(3, 2) = -VS(3, 2) ! Reflection of the output vector

    PSR(2) = PI/(wavenumber*SQRT(R**2+(XI(3)+XJ(3))**2))

    ! 1.c Shift and reflect XJ and compute another value of the Green function
    XI(3) =  X0I(3)
    XJ(3) = -X0J(3) - 2*depth
    CALL COMPUTE_INTEGRALS_WRT_THETA(XI(:), XJ(:), wavenumber, XR, XZ, APD, FS(3), VS(:, 3))

    PSR(3) = PI/(wavenumber*SQRT(R**2+(XI(3)+XJ(3))**2))

    ! 1.d Shift and reflect both XI and XJ and compute another value of the Green function
    XI(3) = -X0I(3) - 2*depth
    XJ(3) = -X0J(3) - 2*depth
    CALL COMPUTE_INTEGRALS_WRT_THETA(XI(:), XJ(:), wavenumber, XR, XZ, APD, FS(4), VS(:, 4))
    VS(3, 4) = -VS(3, 4) ! Reflection of the output vector

    PSR(4) = PI/(wavenumber*SQRT(R**2+(XI(3)+XJ(3))**2))

    ! Add up the results of the four problems
    SP               = SUM(FS(1:4)) - SUM(PSR(1:4))
    VSP_SYM(1:3)     = VS(1:3, 1) + VS(1:3, 4)
    VSP_ANTISYM(1:3) = VS(1:3, 2) + VS(1:3, 3)

    ! Multiply by some coefficients
    AMH  = wavenumber*depth
    AKH  = AMH*TANH(AMH)
    A    = (AMH+AKH)**2/(depth*(AMH**2-AKH**2+AKH))
    COF1 = A/(2*PI)
    COF2 = A/2
    COF3 = wavenumber*COF1
    COF4 = wavenumber*COF2

    SP          = CMPLX(REAL(SP)*COF1,          AIMAG(SP)*COF2, KIND=PRE)
    VSP_ANTISYM = CMPLX(REAL(VSP_ANTISYM)*COF3, AIMAG(VSP_ANTISYM)*COF4, KIND=PRE)
    VSP_SYM     = CMPLX(REAL(VSP_SYM)*COF3,     AIMAG(VSP_SYM)*COF4, KIND=PRE)

    !=====================================================
    ! Part 2: Integrate (NEXP+1)×4 terms of the form 1/MM'
    !=====================================================

    DO KE = 1, NEXP
      XI(:) = X0I(:)

      ! 2.a Shift observation point and compute integral
      XI(3) =  X0I(3) + depth*AMBDA(KE) - 2*depth
      CALL COMPUTE_ASYMPTOTIC_RANKINE_SOURCE(XI(:), X0J(:), ONE, FTS(1), VTS(:, 1))

      ! 2.b Shift and reflect observation point and compute integral
      XI(3) = -X0I(3) - depth*AMBDA(KE)
      CALL COMPUTE_ASYMPTOTIC_RANKINE_SOURCE(XI(:), X0J(:), ONE, FTS(2), VTS(:, 2))
      VTS(3, 2) = -VTS(3, 2) ! Reflection of the output vector

      ! 2.c Shift and reflect observation point and compute integral
      XI(3) = -X0I(3) + depth*AMBDA(KE) - 4*depth
      CALL COMPUTE_ASYMPTOTIC_RANKINE_SOURCE(XI(:), X0J(:), ONE, FTS(3), VTS(:, 3))
      VTS(3, 3) = -VTS(3, 3) ! Reflection of the output vector

      ! 2.d Shift observation point and compute integral
      XI(3) =  X0I(3) - depth*AMBDA(KE) + 2*depth
      CALL COMPUTE_ASYMPTOTIC_RANKINE_SOURCE(XI(:), X0J(:), ONE, FTS(4), VTS(:, 4))

      AQT = AR(KE)/2

      ! Add all the contributions
      SP               = SP               + AQT*SUM(FTS(1:4))
      VSP_ANTISYM(1:3) = VSP_ANTISYM(1:3) + AQT*(VTS(1:3, 1) + VTS(1:3, 4))
      VSP_SYM(1:3)     = VSP_SYM(1:3)     + AQT*(VTS(1:3, 2) + VTS(1:3, 3))

    END DO

    RETURN
  END SUBROUTINE

  ! =====================================================================

  SUBROUTINE BUILD_MATRICES_WAVE_SOURCE  &
      (nb_faces_1, centers_1, normals_1, &
      nb_faces_2,                        &
      centers_2, areas_2,                &
      wavenumber, depth,                 &
      XR, XZ, APD,                       &
      NEXP, AMBDA, AR,                   &
      same_body,                         &
      S, V)

    ! Mesh data
    INTEGER,                                  INTENT(IN) :: nb_faces_1, nb_faces_2
    REAL(KIND=PRE), DIMENSION(nb_faces_1, 3), INTENT(IN) :: normals_1, centers_1
    REAL(KIND=PRE), DIMENSION(nb_faces_2, 3), INTENT(IN) :: centers_2
    REAL(KIND=PRE), DIMENSION(nb_faces_2),    INTENT(IN) :: areas_2

    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber, depth

    ! Tabulated integrals
    REAL(KIND=PRE), DIMENSION(328),           INTENT(IN) :: XR
    REAL(KIND=PRE), DIMENSION(46),            INTENT(IN) :: XZ
    REAL(KIND=PRE), DIMENSION(328, 46, 2, 2), INTENT(IN) :: APD

    ! Prony decomposition for finite depth
    INTEGER,                                  INTENT(IN) :: NEXP
    REAL(KIND=PRE), DIMENSION(NEXP),          INTENT(IN) :: AMBDA, AR

    ! Trick to save some time
    LOGICAL,                                  INTENT(IN) :: same_body

    ! Output
    COMPLEX(KIND=PRE), DIMENSION(nb_faces_1, nb_faces_2), INTENT(OUT) :: S
    COMPLEX(KIND=PRE), DIMENSION(nb_faces_1, nb_faces_2), INTENT(OUT) :: V

    ! Local variables
    INTEGER                         :: I, J
    COMPLEX(KIND=PRE)               :: SP2
    COMPLEX(KIND=PRE), DIMENSION(3) :: VSP2_SYM, VSP2_ANTISYM

    IF (SAME_BODY) THEN
      ! If we are computing the influence of some cells upon themselves, the resulting matrices have some symmetries.
      ! This is due to the symmetry of the Green function, and the way the integral on the face is approximated.
      ! (More precisely, the Green function is symmetric and its derivative is the sum of a symmetric part and an anti-symmetric
      ! part.)

      DO I = 1, nb_faces_1
        !$OMP PARALLEL DO PRIVATE(J, SP2, VSP2_SYM, VSP2_ANTISYM)
        DO J = I, nb_faces_2

          IF (depth == INFINITE_DEPTH) THEN
            CALL WAVE_PART_INFINITE_DEPTH &
              (wavenumber,                &
              centers_1(I, :),            &
              centers_2(J, :),            &
              XR, XZ, APD,                &
              SP2, VSP2_SYM               &
              )
            VSP2_ANTISYM(:) = ZERO
          ELSE
            CALL WAVE_PART_FINITE_DEPTH   &
              (wavenumber,                &
              centers_1(I, :),            &
              centers_2(J, :),            &
              depth,                      &
              XR, XZ, APD,                &
              NEXP, AMBDA, AR,            &
              SP2, VSP2_SYM, VSP2_ANTISYM &
              )
          END IF

          S(I, J) = -1/(4*PI) * SP2*areas_2(J)
          V(I, J) = -1/(4*PI) * DOT_PRODUCT(normals_1(I, :),         &
                                            VSP2_SYM + VSP2_ANTISYM) &
                                            *areas_2(J)

          IF (.NOT. I==J) THEN
            VSP2_SYM(1:2) = -VSP2_SYM(1:2)
            S(J, I) = -1/(4*PI) * SP2*areas_2(I)
            V(J, I) = -1/(4*PI) * DOT_PRODUCT(normals_1(J, :),         &
                                              VSP2_SYM - VSP2_ANTISYM) &
                                              *areas_2(I)
          END IF

        END DO
        !$OMP END PARALLEL DO
      END DO

    ELSE
      ! General case: if we are computing the influence of a some cells on other cells, we have to compute all the coefficients.

      DO I = 1, nb_faces_1
        !$OMP PARALLEL DO PRIVATE(J, SP2, VSP2_SYM, VSP2_ANTISYM)
        DO J = 1, nb_faces_2

          IF (depth == INFINITE_DEPTH) THEN
            CALL WAVE_PART_INFINITE_DEPTH &
              (wavenumber,                &
              centers_1(I, :),            &
              centers_2(J, :),            &
              XR, XZ, APD,                &
              SP2, VSP2_SYM               &
              )
            VSP2_ANTISYM(:) = ZERO 
          ELSE
            CALL WAVE_PART_FINITE_DEPTH   &
              (wavenumber,                &
              centers_1(I, :),            &
              centers_2(J, :),            &
              depth,                      &
              XR, XZ, APD,                &
              NEXP, AMBDA, AR,            &
              SP2, VSP2_SYM, VSP2_ANTISYM &
              )
          END IF

          S(I, J) = -1/(4*PI) * SP2*areas_2(J)                                ! Green function
          V(I, J) = -1/(4*PI) * DOT_PRODUCT(normals_1(I, :),         &
                                            VSP2_SYM + VSP2_ANTISYM) &
                                            *areas_2(J) ! Gradient of the Green function

        END DO
        !$OMP END PARALLEL DO
      END DO
   END IF

  END SUBROUTINE

  ! =====================================================================

END MODULE GREEN_WAVE

module fingreen3D_module

  implicit none

contains

! ==================================================================================
!
!     Purpose: This program computes the three-dimensional free-surface
!             Green function for finite depth and the derivatives of it
!
!             Code Original Author: Yingyi Liu       created on  2013.09.07
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!         Remark:    The Green function can be decomposed into following form,
!                    where the rankine part can be evaluated separately
!                    based on the method of Hess and Smith (1964) or Newman (1986)
!                    in constant panel method due to its high singularity
!
!                             G= 1/r+1/r'+Gw,
!                    where
!                            r:  dsqrt((x-x')^2+(y-y')^2+(z-z')^2);
!                            r': dsqrt((x-x')^2+(y-y')^2+(z+z')^2).
!  Parameters:
!       Input:      RR  --- horizontal distance between the field and the source point
!                   ZF  --- z,  vertical coordinate of the field point
!                   ZP  --- z', vertical coordinate of the source point
!                    V  --- wave number in deep water,i.e., w^2/g
!                  WVN  --- the first elememnt is the positive root of the dispersion
!                        equation V = k*tanh(k*h), the rest elements are the real
!                        roots of the equation um*tanh(um*h)= -V
!                        (w:circular frequency,g:gravity acceleration)
!                   NK  --- number of elements in the array WVN
!                   H   --- water depth (h>0)
!
!       Output:    GRN(1)  --- value of Green's function
!                  GRN(2)  --- derivative of Green's function with respect to R
!                  GRN(3)  --- derivative of Green's function with respect to z
!
!  Contributors list:
!         Yingyi Liu
!         Matthieu Ancellin
!         to be continued...
!
! ==================================================================================
!!-------------------------------------------------------------------------------!!
!                      Level-1 (Top-level) driver subroutine                      !
!!-------------------------------------------------------------------------------!!

      SUBROUTINE fingreen3d_routine(RR,ZF,ZP,V,WVN,NK,H,GRN)

        INTEGER, INTENT(IN) :: NK
        REAL*8,INTENT(IN) :: RR,ZF,ZP,V,WVN(1:NK),H
        COMPLEX*16,INTENT(OUT) :: GRN(3)

        REAL*8 R,R1,PI4,G,RHP,WK
        COMPLEX*16 FG(3)

        DATA  G,PI4 /9.807D0,12.56637061435917D0/

! Initialize parameters based on the inputs

        R =DSQRT(RR**2+(ZP-ZF)**2)
        R1 =DSQRT(RR**2+(ZP+ZF)**2)

        WK=WVN(1)

! Choose an appropriate method to calculate the Green function
! based on the value of RHP (R/h)
!
        RHP=DABS(RR/H)
         IF (RHP.LT.0.0005D0) THEN
          CALL LINTON(RR,ZF,ZP,V,WK,WVN,NK,H,FG)
        ELSEIF (RHP.GE.0.0005D0.AND.RHP.LT.0.05D0) THEN
          CALL PIDCOCK(RR,ZF,ZP,V,WK,WVN,NK,H,FG)
         ELSEIF (RHP.GE.0.05D0.AND.RHP.LT.0.5D0) THEN
          CALL EIGENE(RR,ZF,ZP,WK,WVN,NK,H,FG)
         ELSE
          CALL EIGEN(RR,ZF,ZP,WK,WVN,NK,H,FG)
        ENDIF

! Post-process the Green function's value
! if R=0, the value of its derivative with respect to R should be zero
!
        GRN(:)=DCMPLX(0.D0,0.D0)

        GRN(1)=FG(1)
        IF(RR.NE.0.0D0) THEN
        GRN(2)=FG(2)
        ELSE
        GRN(2)=DCMPLX(0.D0,0.D0)
        ENDIF
        GRN(3)=FG(3)

        RETURN
        END SUBROUTINE fingreen3d_routine

! ==================================================================================
!   Purpose: This subroutine computes roots of the water-wave dispersion equation
!             in finite water depth, by using a higher-order iterative method
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Author:
!
!    Yingyi Liu on Mar.23, 2017
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!    J.N. Newman
!    Numerical solutions of the water-wave dispersion relation
!    Applied Ocean Research 12 (1990) 14-18
!
!  Parameters:
!      Input:   NRT --- Integer, the number of roots required
!                W   --- Real, wave angular frequency
!                H   --- Real, water depth (h>0)
!      Output:  WVN --- Real, an array storing roots of the dispersion equation
! ==================================================================================

    SUBROUTINE DISPERSION(WVN,NRT,W,H)
!
!   Evaluation of the roots of the following equations
!   by higher-order iterative method
!   first root stored in WVN is from Eq. (i)
!   the rest roots are from Eq. (ii)
!   i) w*w/g = k tanh ( kh )
!   ii) -w*w/g = Um tan ( Umh )
!

      INTEGER,INTENT(IN):: NRT
      REAL*8,INTENT(IN):: W,H
      REAL*8,INTENT(OUT):: WVN(1:NRT)
      INTEGER I, M
      REAL*8 T,X,U,Y,DNM,G,PI
      REAL*8 FUN,DFUN,D2FUN,TRIAL,EXX

      DATA G,PI/9.807d0,3.141592653589793d0/

!------------------------------------------------------------------
! I. calculation of wave number (root of Eq. (i))
!------------------------------------------------------------------
!
!   initialize iteration by an accurate Chebyshev approximation
!   if y=x, use the approximation directly insteady of iteration
!   to avoid the singularity in the denomenator of the transcendental
!   function; otherwise, do the iterative procedure.
!
      X=W*W*H/G
      IF (X.GT.0.D0.AND.X.LE.2.D0) THEN
       Y=DSQRT(X)*(0.9994D0+0.1701D0*X+0.0305*X*X)
      ELSE
       T=X*DEXP(-2.D0*X)
       Y=X+2.D0*T-6.D0*T*T
      ENDIF

      IF (DABS(Y-X).LT.1.E-10) THEN
       WVN(1)=X/H
      ELSE
       M=0
       EXX=1.D0
       DO WHILE (EXX.GT.1.0D-10)
        TRIAL=Y
        DNM=TRIAL*TRIAL-X*X
        FUN=DLOG((TRIAL+X)/(TRIAL-X))/2.D0-TRIAL
        DFUN=-X/DNM-1.D0
        D2FUN=2.D0*X*TRIAL/(DNM*DNM)
        Y=TRIAL-FUN/DFUN*(1.D0+(FUN/DFUN)*(D2FUN/DFUN)/2.D0)
        EXX=DABS(Y-TRIAL)
        M=M+1
       ENDDO
       WVN(1)=Y/H
      ENDIF

!------------------------------------------------------------------
! II. calcultion of roots of Eq. (ii), which characterizes
!     the evanescene modes in eigenfunction
!------------------------------------------------------------------
!
!   initialize iteration by a suitable starting approximation
!
      U=3.D0*X/(7.D0+3.D0*X)
      T=0.0159D0+0.1032D0*U+4.3152D0*U*U-2.8768D0*U*U*U
!
!   perform iterative procedure to find exact solution of Um (m=1,..NRT-1)
!   of the transcendental equation Eq. (ii)
!
      DO I=2,NRT
       M=0
       EXX=1.D0
       DO WHILE (EXX.GT.1.0D-10)
        TRIAL=T
        Y=(I-1)*PI-TRIAL
        DNM=Y*Y+X*X
        FUN=ATAN2(X,Y)-TRIAL
        DFUN=X/DNM-1.D0
        D2FUN=2.D0*X*TRIAL/(DNM*DNM)
        T=TRIAL-FUN/DFUN*(1.D0+(FUN/DFUN)*(D2FUN/DFUN)/2.D0)
        EXX=DABS(T-TRIAL)
        M=M+1
       ENDDO
       Y=(I-1)*PI-T
       WVN(I)=Y/H
       T=T-PI*X/(X*X+PI*I*(PI*(I-1)-T))
      ENDDO

      END SUBROUTINE DISPERSION

!!-------------------------------------------------------------------------------!!
!                Belows are Level-2 (intermediate-level) subroutines              !
!!-------------------------------------------------------------------------------!!

! ==================================================================================
!       Purpose: This program computes Green function and its derivatives
!                using series expansion, without epsilon algorithm, in the region
!                R/H.GT.0.5. The terms needed is 2~10 to 10^-6 accuracy,
!                with a maximum number of term 10.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                V --- wave number in deep water , i.e., V= w^2/g
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!                WVN --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                NK --- number of elements in the array WVN
!                H --- water depth (h>0)
!       Output:  GRN --- Green function value and its derivatives
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!.
! ==================================================================================

        SUBROUTINE EIGEN(R,ZF,ZP,WK,WVN,NK,H,GRN)

         INTEGER I,NK,NT
         REAL*8 J0,J1,Y0,Y1,K0,K1
         REAL*8 PI,KM,PM,RM(3)
         REAL*8 SR,SR1,DSRR,DSRZ,DSR1R,DSR1Z
         REAL*8,INTENT(IN)::R,ZF,ZP,H,WK,WVN(1:NK)

         COMPLEX*16,INTENT(OUT):: GRN(3)
         COMPLEX*16 CI,P0,DP0,NM0

         DATA  PI,CI/3.141592653589793d0,(0.D0,1.0D0)/

! initialize some important parameters
!
         NT=10

         NM0=H/2.D0*(1.D0+DSINH(2.D0*WK*H)/(2.D0*WK*H))
         P0=PI/NM0*DCOSH(WK*(ZF+H))*DCOSH(WK*(ZP+H))
         DP0=PI/NM0*DSINH(WK*(ZF+H))*DCOSH(WK*(ZP+H))

! calculate the imaginary part of the Green function
!
         CALL JY01B(WK*R,J0,J1,Y0,Y1)

         GRN(1)=P0*(CI*J0-Y0)
         GRN(2)=-WK*P0*(CI*J1-Y1)
         GRN(3)=WK*DP0*(CI*J0-Y0)

! calculate the real part of the Green function
! the trunction terms number depends on the value of RHP
!
         DO I=2,NT

         KM=WVN(I)

         PM = 4.D0/(1.D0+DSIN(2.D0*KM*H)/(2.D0*KM*H))/H

         CALL IK01A(KM*R,K0,K1)

         RM(1) = PM*K0*DCOS(KM*(ZF+H))*DCOS(KM*(ZP+H))
         RM(2) = -PM*KM*K1*DCOS(KM*(ZF+H))*DCOS(KM*(ZP+H))
         RM(3) = -PM*KM*K0*DSIN(KM*(ZF+H))*DCOS(KM*(ZP+H))

         GRN(1)= GRN(1)+RM(1)
         GRN(2)= GRN(2)+RM(2)
         GRN(3)= GRN(3)+RM(3)

         IF (DABS(RM(1)).LT.1.E-6.AND.DABS(RM(2)).LT.1.E-6.AND.DABS(RM(3)).LT.1.E-6) THEN
          EXIT
         ENDIF

         ENDDO

! exclude the singular terms for the purpose of analytical integration over panels
!
         SR=DSQRT(R**2+(ZF-ZP)**2)
         SR1=DSQRT(R**2+(ZF+ZP)**2)

         DSRR=R/SR
         DSRZ=(ZF-ZP)/SR
         DSR1R=R/SR1
         DSR1Z=(ZF+ZP)/SR1

         GRN(1)=GRN(1)-(1.D0/SR+1.D0/SR1)
         GRN(2)=GRN(2)+(DSRR/SR**2+DSR1R/SR1**2)
         GRN(3)=GRN(3)+(DSRZ/SR**2+DSR1Z/SR1**2)

        RETURN
        END SUBROUTINE EIGEN

! ==================================================================================
!       Purpose: This program computes Green function and its derivatives
!                using series expansion, with epsilon algorithm, in the region
!                R/H.GT.0.01 and R/H.LT.0.5. The terms needed is 10~80 to
!                10^-5 accuracy, with a maximum number of term 80.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- Horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                V --- wave number in deep water , i.e., V= w^2/g
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!                WVN --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                NK --- number of elements in the array WVN
!                H --- water depth (h>0)
!       Output:  GRN --- Green function value and its derivatives
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

        SUBROUTINE EIGENE(R,ZF,ZP,WK,WVN,NK,H,GRN)

         INTEGER I,NK,NT,I_PADE,K_PADE
         REAL*8 J0,J1,Y0,Y1,K0,K1
         REAL*8 PI,KM,PM,RM(3),RL(3),ERR,RHP
         REAL*8 SR,SR1,DSRR,DSRZ,DSR1R,DSR1Z
         REAL*8 G(0:NK-1),GR(0:NK-1),GZ(0:NK-1)
         REAL*8,INTENT(IN)::R,ZF,ZP,H,WK,WVN(1:NK)

         COMPLEX*16,INTENT(OUT):: GRN(3)
         COMPLEX*16 CI,P0,DP0,NM0

         DATA  PI,CI/3.141592653589793d0,(0.D0,1.0D0)/

! initialize some important parameters
!
         RHP=DABS(R/H)
         NT=INT(-88.89*RHP+54.45)

         NM0=H/2.D0*(1.D0+DSINH(2.D0*WK*H)/(2.D0*WK*H))
         P0=PI/NM0*DCOSH(WK*(ZF+H))*DCOSH(WK*(ZP+H))
         DP0=PI/NM0*DSINH(WK*(ZF+H))*DCOSH(WK*(ZP+H))

! calculate the imaginary part of the Green function
!
         CALL JY01B(WK*R,J0,J1,Y0,Y1)

         GRN(1)=P0*(CI*J0-Y0)
         GRN(2)=-WK*P0*(CI*J1-Y1)
         GRN(3)=WK*DP0*(CI*J0-Y0)

! calculate the real part of the Green function
! the trunction terms number depends on the value of RHP
!
         G(0)= 0.D0
         GR(0)= 0.D0
         GZ(0)= 0.D0

         DO I=2,NT

         KM=WVN(I)

         PM = 4.D0/(1.D0+DSIN(2.D0*KM*H)/(2.D0*KM*H))/H

         CALL IK01A(KM*R,K0,K1)

         RM(1) = PM*K0*DCOS(KM*(ZF+H))*DCOS(KM*(ZP+H))
         RM(2) = -PM*KM*K1*DCOS(KM*(ZF+H))*DCOS(KM*(ZP+H))
         RM(3) = -PM*KM*K0*DSIN(KM*(ZF+H))*DCOS(KM*(ZP+H))

         G(I-1)= G(I-2)+RM(1)
         GR(I-1)= GR(I-2)+RM(2)
         GZ(I-1)= GZ(I-2)+RM(3)

         ENDDO

! call the epsilon algorithm to approximate the limit of the infinite series
!
         CALL Limes (NT-1,G(0:NT-1),RL(1),I_PADE,K_PADE,ERR)
         CALL Limes (NT-1,GR(0:NT-1),RL(2),I_PADE,K_PADE,ERR)
         CALL Limes (NT-1,GZ(0:NT-1),RL(3),I_PADE,K_PADE,ERR)

         GRN(1)= GRN(1)+RL(1)
         GRN(2)= GRN(2)+RL(2)
         GRN(3)= GRN(3)+RL(3)

! exclude the singular terms for the purpose of analytical integration over panels
!
         SR=DSQRT(R**2+(ZF-ZP)**2)
         SR1=DSQRT(R**2+(ZF+ZP)**2)

         DSRR=R/SR
         DSRZ=(ZF-ZP)/SR
         DSR1R=R/SR1
         DSR1Z=(ZF+ZP)/SR1

         GRN(1)=GRN(1)-(1.D0/SR+1.D0/SR1)
         GRN(2)=GRN(2)+(DSRR/SR**2+DSR1R/SR1**2)
         GRN(3)=GRN(3)+(DSRZ/SR**2+DSR1Z/SR1**2)

        RETURN
        END SUBROUTINE EIGENE


! ==================================================================================
!       Purpose: This program computes Green function and its derivatives
!                using Pidcock's method, with epsilon algorithm, in the region
!                R/H.GT.0.0005 and R/H.LT.0.01. The terms needed is 50~100 to
!                10^-4 accuracy, with a maximum number of term 100.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                V --- wave number in deep water , i.e., V= w^2/g
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!                WVN --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                NK --- number of elements in the array WVN
!                H --- water depth (h>0)
!       Output:  GRN --- Green function value and its derivatives
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

        SUBROUTINE PIDCOCK(R,ZF,ZP,V,WK,WVN,NK,H,GRN)

         INTEGER NK,NT,I,I_PADE,K_PADE

         REAL*8 J0,J1,Y0,Y1,K0,K0T,K1,K1T
         REAL*8 NM0,P0,DP0,X,PI,GA
         REAL*8 RM(3),SM(3),RL(3),ERR,RHP
         REAL*8 UM,UMT,MP,AC,AM,AMT,DAM,DAMT
         REAL*8 SR,SR1,DSRR,DSRZ,DSR1R,DSR1Z
         REAL*8 G(0:NK-1),GR(0:NK-1),GZ(0:NK-1)
         REAL*8,INTENT(IN)::R,ZF,ZP,H,V,WK,WVN(1:NK)
         !REAL*8,EXTERNAL:: IMGS,DGSR,DGSZ

         COMPLEX*16,INTENT(OUT):: GRN(3)
         COMPLEX*16 CI

         DATA PI,GA /3.141592653589793D0,0.5772156649015328D0/
         DATA CI/(0.0D0, 1.0D0)/

! initialize some important parameters
!
         NM0=H/2.D0*(1.D0+DSINH(2.D0*WK*H)/(2.D0*WK*H))
         P0=PI/NM0*DCOSH(WK*(ZF+H))*DCOSH(WK*(ZP+H))
         DP0=WK*PI/NM0*DSINH(WK*(ZF+H))*DCOSH(WK*(ZP+H))

! calculate the imaginary part of the Green function
!
         CALL JY01B(WK*R,J0,J1,Y0,Y1)

         GRN(1)=P0*(CI*J0-Y0)+2.D0/H*(GA+DLOG(R/4.D0/H))
         GRN(2)=-WK*P0*(CI*J1-Y1)+2.D0/(R*H)
         GRN(3)=DP0*(CI*J0-Y0)

! calculate the real part, for the infinite series of Eq.(13)
! the series applies an acceleration method by subtracting an asymptotic series
!
         RHP=DABS(R/H)
         NT=INT(-1010.10*RHP+100.50)

         G(0)= 0.D0
         GR(0)= 0.D0
         GZ(0)= 0.D0

         DO I=2,NT

          MP=(I-1)*PI
          UMT=MP/H
          UM=WVN(I)
          X=UM*R

          CALL IK01A(X,K0,K1)
          CALL IK01A(UMT*R,K0T,K1T)

          AC=(UM**2+V**2)/((UM**2+V**2)*H-V)
          AM=AC*DCOS(UM*(ZF+H))*DCOS(UM*(ZP+H))
          AMT=DCOS(UMT*(ZF+H))*DCOS(UMT*(ZP+H))/H
          DAM=-UM*AC*DSIN(UM*(ZF+H))*DCOS(UM*(ZP+H))
          DAMT=-UMT*DSIN(UMT*(ZF+H))*DCOS(UMT*(ZP+H))/H

          RM(1)= AM*K0-AMT*K0T
          RM(2)= -UM*AM*K1+UMT*AMT*K1T
          RM(3)= DAM*K0-DAMT*K0T

          G(I-1)= G(I-2)+RM(1)
          GR(I-1)= GR(I-2)+RM(2)
          GZ(I-1)= GZ(I-2)+RM(3)

         ENDDO

! call the epsilon algorithm to approximate the limit of the infinite series
!
         CALL Limes (NT-1,G(0:NT-1),RL(1),I_PADE,K_PADE,ERR)
         CALL Limes (NT-1,GR(0:NT-1),RL(2),I_PADE,K_PADE,ERR)
         CALL Limes (NT-1,GZ(0:NT-1),RL(3),I_PADE,K_PADE,ERR)

         SM(1)= 4.D0*RL(1)
         SM(2)= 4.D0*RL(2)
         SM(3)= 4.D0*RL(3)

! calculate the sum of Rankine terms by Chebyshev approximations
!
         GRN(1)=GRN(1)+SM(1)+IMGS(R,ZF,ZP,H)
         GRN(2)=GRN(2)+SM(2)+DGSR(R,ZF,ZP,H)
         GRN(3)=GRN(3)+SM(3)+DGSZ(R,ZF,ZP,H)

! exclude the singular terms for the purpose of analytical integration over panels
!
         SR=DSQRT(R**2+(ZF-ZP)**2)
         SR1=DSQRT(R**2+(ZF+ZP)**2)

         DSRR=R/SR
         DSRZ=(ZF-ZP)/SR
         DSR1R=R/SR1
         DSR1Z=(ZF+ZP)/SR1

         GRN(1)=GRN(1)-(1.D0/SR+1.D0/SR1)
         GRN(2)=GRN(2)+(DSRR/SR**2+DSR1R/SR1**2)
         GRN(3)=GRN(3)+(DSRZ/SR**2+DSR1Z/SR1**2)

        RETURN
        END SUBROUTINE PIDCOCK


! ==================================================================================
!       Purpose: This program computes Green function and its derivatives
!                using Linton's method, with epsilon algorithm, in the region
!                R/H.LT.0.0005. The terms needed is about 3~10 to
!                10^-6 accuracy, with a maximum number of term 10.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                V --- wave number in deep water , i.e., V= w^2/g
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!                WVNO --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                NK --- number of elements in the array WVNO
!                H --- water depth (h>0)
!       Output:  GRN --- Green function value and its derivatives
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

        SUBROUTINE LINTON(R,ZF,ZP,V,WK,WVNO,NK,H,GRN)

         INTEGER NK,NT,I,FLAG
         REAL*8 PA,A,PI,EPS,SQPI
         REAL*8 SR,SR1,SR2,DSRR,DSRZ,DSR1R,DSR1Z,DSR2R,DSR2Z
         REAL*8 RO(4),DROR(4),DROZ(4),ERRSUM(3),BJ0,BJ1
         REAL*8 COF(NK),DCOF(NK)
         REAL*8,INTENT(IN)::R,ZF,ZP,H,V,WK,WVNO(NK)
         COMPLEX*16,INTENT(OUT):: GRN(3)
         COMPLEX*16 KM,RM(3),CI
         !REAL*8,EXTERNAL:: ERFCC,DERFCC,AQUADF,G3,G1,G2,FAC,F2
         !COMPLEX*16,EXTERNAL::NM

        DATA PI,EPS/3.141592653589793D0,1.E-6/
        DATA CI/(0.0D0, 1.0D0)/

        SQPI=DSQRT(PI)

!-----------------------------------------------------------------------------
!  I. Optimal selection of the parameter A
!-----------------------------------------------------------------------------

        FLAG=2

        IF (FLAG.EQ.1) THEN
          A=0.25D0
        ELSEIF(FLAG.EQ.2) THEN
          IF (V.LT.0.02D0) THEN
            A=3324.2D0*V**3-258.89D0*V**2+8.3958D0*V+1.3208D0
          ELSEIF (V.LT.0.1D0) THEN
            A=-30.303D0*V**3-2.8138D0*V**2+2.7740D0*V+0.05052D0
          ELSEIF (V.LT.1.0D0) THEN
            A=1.5699D0*V**3-2.5075D0*V**2+1.8316D0*V+0.1077D0
          ELSE
            A=-0.000069641D0*V**3-0.0017082D0*V**2+0.45566D0*V+0.80551D0
          ENDIF
           A=DABS(A)/(WK*H)
        ENDIF
!
!       PRINT*,A
!
!-----------------------------------------------------------------------------
!  II. Initialisation of various parameters
!-----------------------------------------------------------------------------

         PA=A*H
         SR=DSQRT(R**2+(ZF-ZP)**2)
         SR1=DSQRT(R**2+(2.D0*H+ZF+ZP)**2)
         SR2=DSQRT(R**2+(ZF+ZP)**2)

         CALL RCHI(R,ZF,ZP,H,RO,DROR,DROZ)

         DSRR=R/SR
         DSRZ=(ZF-ZP)/SR
         DSR1R=R/SR1
         DSR1Z=(2.D0*H+ZF+ZP)/SR1
         DSR2R=R/SR2
         DSR2Z=(ZF+ZP)/SR2
!
!-----------------------------------------------------------------------------
!  III. Calculating the part of evanescent modes
!-----------------------------------------------------------------------------

         GRN(:) = (0.0D0, 0.0D0)
         NT=20

         CALL COEF(R,PA,A,NT,WVNO,WK,COF)
         CALL DCOEF(R,PA,A,NT,WVNO,WK,DCOF)

         DO I=1,NT

         IF (I.EQ.1) THEN
          KM=-CI*WK
         ELSE
          KM=WVNO(I)
         ENDIF

         RM(1)= -COF(I)/NM(H,KM)*CDCOS(KM*(ZF+H))*CDCOS(KM*(ZP+H))
         RM(2)= -DCOF(I)/NM(H,KM)*CDCOS(KM*(ZF+H))*CDCOS(KM*(ZP+H))
         RM(3)= COF(I)*KM/NM(H,KM)*CDSIN(KM*(ZF+H))*CDCOS(KM*(ZP+H))

         GRN(1)= GRN(1)+RM(1)
         GRN(2)= GRN(2)+RM(2)
         GRN(3)= GRN(3)+RM(3)


         IF (I.GT.2.AND.CDABS(RM(1)).LT.EPS.AND.CDABS(RM(2)).LT.EPS.AND.CDABS(RM(3)).LT.EPS) THEN
         EXIT
         ENDIF

         ENDDO
!
!-----------------------------------------------------------------------------
!  IV. Calculating the part of Error functions
!-----------------------------------------------------------------------------

         ERRSUM(:)=0.D0

         DO I=1,4

         ERRSUM(1)=ERRSUM(1)+ERFCC(RO(I)/PA)/(4.D0*PI*RO(I))
         ERRSUM(2)=ERRSUM(2)+(DERFCC(RO(I)/PA)/PA*DROR(I)*RO(I)-DROR(I)*ERFCC(RO(I)/PA))/(4.D0*PI*RO(I)**2)
         ERRSUM(3)=ERRSUM(3)+(DERFCC(RO(I)/PA)/PA*DROZ(I)*RO(I)-DROZ(I)*ERFCC(RO(I)/PA))/(4.D0*PI*RO(I)**2)

         ENDDO


       IF (DABS(SR).GT.1.E-6) THEN

         ERRSUM(1)=ERRSUM(1)+(ERFCC(SR/PA)-1.D0)/(4.D0*PI*SR)+ERFCC(SR1/PA)/(4.D0*PI*SR1)-1.D0/(4.D0*PI*SR2)
         ERRSUM(2)=ERRSUM(2)-(ERFCC(SR/PA)-1.D0)/(4.D0*PI*SR**2)*DSRR+DERFCC(SR/PA)/(4.D0*PI*SR*PA)*DSRR-ERFCC(SR1/PA)    &
                   /(4.D0*PI*SR1**2)*DSR1R+DERFCC(SR1/PA)/(4.D0*PI*SR1*PA)*DSR1R+DSR2R/(4.D0*PI*SR2**2)
         ERRSUM(3)=ERRSUM(3)-(ERFCC(SR/PA)-1.D0)/(4.D0*PI*SR**2)*DSRZ+DERFCC(SR/PA)/(4.D0*PI*SR*PA)*DSRZ-ERFCC(SR1/PA)    &
                   /(4.D0*PI*SR1**2)*DSR1Z+DERFCC(SR1/PA)/(4.D0*PI*SR1*PA)*DSR1Z+DSR2Z/(4.D0*PI*SR2**2)

       ELSE

         ERRSUM(1)=ERRSUM(1)+ERFCC(SR1/PA)/(4.D0*PI*SR1)-1.D0/(4.D0*PI*SR2)
         ERRSUM(2)=ERRSUM(2)-ERFCC(SR1/PA)/(4.D0*PI*SR1**2)*DSR1R+DERFCC(SR1/PA)/(4.D0*PI*SR1*PA)*DSR1R+DSR2R/(4.D0*PI*SR2**2)
         ERRSUM(3)=ERRSUM(3)-ERFCC(SR1/PA)/(4.D0*PI*SR1**2)*DSR1Z+DERFCC(SR1/PA)/(4.D0*PI*SR1*PA)*DSR1Z+DSR2Z/(4.D0*PI*SR2**2)

       ENDIF
!
!-----------------------------------------------------------------------------
!  V. Calculating the part of integration
!-----------------------------------------------------------------------------

         GRN(1)= GRN(1)-ERRSUM(1)-V/2.D0/PI*AQUADF(V,R,ZF,ZP,H,0.D0,PA/2.D0,EPS,1)
         GRN(2)= GRN(2)-ERRSUM(2)+V/2.D0/PI*AQUADF(V,R,ZF,ZP,H,0.D0,PA/2.D0,EPS,2)
         GRN(3)= GRN(3)-ERRSUM(3)-V/2.D0/PI*AQUADF(V,R,ZF,ZP,H,0.D0,PA/2.D0,EPS,3)


         CALL JY01BJ(WK*R,BJ0,BJ1)


         KM=-CI*WK
         GRN(1)= GRN(1)-CI/4.D0/NM(H,KM)*BJ0*DCOSH(WK*(ZF+H))*DCOSH(WK*(ZP+H))
         GRN(2)= GRN(2)+CI*WK/4.D0/NM(H,KM)*BJ1*DCOSH(WK*(ZF+H))*DCOSH(WK*(ZP+H))
         GRN(3)= GRN(3)-CI*WK/4.D0/NM(H,KM)*BJ0*DSINH(WK*(ZF+H))*DCOSH(WK*(ZP+H))


         GRN(1)= -4.D0*PI*GRN(1)
         GRN(2)= -4.D0*PI*GRN(2)
         GRN(3)= -4.D0*PI*GRN(3)


        RETURN
        END SUBROUTINE LINTON

!!-------------------------------------------------------------------------------!!
!             Belows are Level-3 (low level) self-contained subroutines           !
!!-------------------------------------------------------------------------------!!

! ==================================================================================
!       Purpose: This program computes Rankine image source
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                H --- water depth (h>0)
!       Output:  IMGS --- value of the Rankine image source in Pidcock's method
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION IMGS(R,ZF,ZP,H)

       INTEGER L,M,N
       REAL*8 R,ZF,ZP,H,AMN(0:4,0:4)
       REAL*8 T1,T2,T3,SUM1,SUM2
       !REAL*8,EXTERNAL::RS

       DATA AMN /0.D0,-0.02525711D0,0.00086546D0,-0.00004063D0,        &
            0.00000193D0,0.05051418D0,-0.00692380D0,0.00073292D0,     &
            -0.00006636D0,0.00000398D0,0.00230838D0,-0.00097875D0,     &
            0.00020597D0,-0.00003333D0,0.00000524D0,0.00012934D0,      &
            -0.00010879D0,0.00003965D0,-0.00000891D0,0.0D0,          &
            0.00000913D0,-0.00001270D0,0.00000466D0,0.0D0,0.D0/

       T1=R/H
       T2=(ZF-ZP)/H
       T3=(ZF+ZP+2.D0*H)/H

       SUM1=0.D0
       DO L=-1,1
        SUM1=SUM1+1.D0/RS(T1,T2+2.D0*L)+1.D0/RS(T1,T3+2.D0*L)
       ENDDO

       SUM2=0.D0
       DO M=0,4
        DO N=0,4
        SUM2=SUM2+AMN(M,N)*T1**(2.D0*M)*(T2**(2.D0*N)+T3**(2.D0*N))
       ENDDO
       ENDDO

       IMGS=(SUM1-2.D0+SUM2)/H

       RETURN
       END FUNCTION IMGS


! ==================================================================================
!       Purpose: This program computes the derivative of Rankine image source
!                with respect to R
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                H --- water depth (h>0)
!       Output:  DGSR --- derivative of the Rankine image source with respect to R
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION DGSR(R,ZF,ZP,H)

       INTEGER L,M,N
       REAL*8 R,ZF,ZP,H,AMN(0:4,0:4)
       REAL*8 T1,T2,T3,SUM1,SUM2
       !REAL*8,EXTERNAL::RS

       DATA AMN /0.D0,-0.02525711D0,0.00086546D0,-0.00004063D0,        &
            0.00000193D0,0.05051418D0,-0.00692380D0,0.00073292D0,     &
            -0.00006636D0,0.00000398D0,0.00230838D0,-0.00097875D0,     &
            0.00020597D0,-0.00003333D0,0.00000524D0,0.00012934D0,      &
            -0.00010879D0,0.00003965D0,-0.00000891D0,0.0D0,          &
            0.00000913D0,-0.00001270D0,0.00000466D0,0.0D0,0.D0/

       T1=R/H
       T2=(ZF-ZP)/H
       T3=(ZF+ZP+2.D0*H)/H

       SUM1=0.D0
       DO L=-1,1
        SUM1=SUM1+T1/(RS(T1,T2+2.D0*L))**3+T1/(RS(T1,T3+2.D0*L))**3
       ENDDO

       SUM2=0.D0
       DO M=1,4
        DO N=0,4
        SUM2=SUM2+2.D0*M*AMN(M,N)*T1**(2.D0*M-1.D0)*(T2**(2.D0*N)+T3**(2.D0*N))
       ENDDO
       ENDDO

       DGSR=(-SUM1+SUM2)/H**2

       RETURN
       END FUNCTION DGSR

! ==================================================================================
!       Purpose: This program computes the derivative of Rankine image source
!                with respect to z
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                H --- water depth (h>0)
!       Output:  DGSZ --- derivative of the Rankine image source with respect to z
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION DGSZ(R,ZF,ZP,H)

       INTEGER L,M,N
       REAL*8 R,ZF,ZP,H,AMN(0:4,0:4)
       REAL*8 T1,T2,T3,SUM1,SUM2
       !REAL*8,EXTERNAL::RS

       DATA AMN /0.D0,-0.02525711D0,0.00086546D0,-0.00004063D0,        &
            0.00000193D0,0.05051418D0,-0.00692380D0,0.00073292D0,     &
            -0.00006636D0,0.00000398D0,0.00230838D0,-0.00097875D0,     &
            0.00020597D0,-0.00003333D0,0.00000524D0,0.00012934D0,      &
            -0.00010879D0,0.00003965D0,-0.00000891D0,0.0D0,          &
            0.00000913D0,-0.00001270D0,0.00000466D0,0.0D0,0.D0/

       T1=R/H
       T2=(ZF-ZP)/H
       T3=(ZF+ZP+2.D0*H)/H

       SUM1=0.D0
       DO L=-1,1
        SUM1=SUM1+(T2+2.D0*L)/(RS(T1,T2+2.D0*L))**3+(T3+2.D0*L)/(RS(T1,T3+2.D0*L))**3
       ENDDO

       SUM2=0.D0
       DO M=0,4
        DO N=1,4
        SUM2=SUM2+2.D0*N*AMN(M,N)*T1**(2.D0*M)*(T2**(2.D0*N-1.D0)+T3**(2.D0*N-1.D0))
       ENDDO
       ENDDO

       DGSZ=(-SUM1+SUM2)/H**2

       RETURN
       END FUNCTION DGSZ

!
!    ======================================================
!          Function Dsqrt(R^2+Z^2)
!    ======================================================

       REAL*8 FUNCTION RS(R,Z)

       REAL*8 R,Z

       RS=DSQRT(R**2+Z**2)


       RETURN
       END FUNCTION RS


! ==================================================================================
!       Purpose: This program computes the expansion coefficients in
!                Linton's method
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                PA --- a key parameter determining convergence, i.e., PA= a*h
!                A ---  a key parameter related with convergence
!                M --- number of elements in the array WVNO
!                WVNO --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!       Output:  COF --- expansion coefficients in Linton's expression
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       SUBROUTINE COEF(R,PA,A,M,WVNO,WK,COF)

        INTEGER I
        INTEGER,INTENT(IN)::M
        REAL*8,INTENT(IN)::R,PA,A,WVNO(M),WK
        REAL*8,INTENT(OUT)::COF(M)
        !REAL*8,EXTERNAL:: SA0,AQUAD,SAM,F1
        REAL*8 BY0,DNT,EPS,STEP,P1,E1,EI
        REAL*8 PI

        DATA  PI/3.141592653589793D0/

        EPS=1.E-6
        STEP=100.D0
        DNT=PA**2/4.D0

! calculate the first expansion coefficient A0
!
       IF (DABS(R).LT.1.E-6) THEN

         CALL EIX(WK**2*DNT,EI)
         COF(1)=-EI/4.D0/PI

       ELSEIF (R/A.LE.0.5D0) THEN

         COF(1)=SA0(R,PA,WK)

       ELSE

         CALL JY01BY0(WK*R,BY0)
         COF(1)=-BY0/4.D0-AQUAD(R,WK,1,0.0D0,DNT,EPS,1)

       ENDIF

! calculate the rest expansion coefficients Ai (i=2,m)
! the truncation terms number depends on whether the series
! converged to a specified accuracy or not

       DO I=2,M

        IF (DABS(R).LT.1.E-6) THEN

         CALL E1XA(WVNO(I)**2*DNT,E1)
         COF(I)=E1/4.D0/PI

        ELSEIF (R/A.LE.1.D0) THEN

         COF(I)=SAM(R,PA,WVNO(I))

        ELSE

         P1=DNT+STEP
         DO WHILE (DABS(F1(R,WVNO(I),I,P1)).GT.EPS)
         P1=P1+STEP
         ENDDO

         COF(I)=AQUAD(R,WVNO(I),I,DNT,P1,EPS,1)

        ENDIF

       ENDDO


       RETURN
       END SUBROUTINE COEF

! ==================================================================================
!       Purpose: This program computes derivative of the expansion coefficients
!                with respect to R in Linton's method
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                PA --- a key parameter determining convergence, i.e., PA= a*h
!                A ---  a key parameter related with convergence
!                M --- number of elements in the array WVNO
!                WVNO --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!       Output:  DCOEF --- derivative of expansion coefficients with respect to R
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       SUBROUTINE DCOEF(R,PA,A,M,WVNO,WK,DCOF)

        INTEGER I
        INTEGER,INTENT(IN)::M
        REAL*8,INTENT(IN)::R,PA,A,WVNO(M),WK
        REAL*8,INTENT(OUT)::DCOF(M)
        !REAL*8,EXTERNAL:: DSA0,DSAM,AQUAD,F2
        REAL*8 BY1,DNT,EPS,STEP,P1

        EPS=1.E-6
        STEP=100.D0
        DNT=PA**2/4.D0

! calculate the derivative of the first expansion coefficient A0
!
        IF (DABS(R).LT.1.E-6) THEN

          DCOF(1)=0.D0

        ELSEIF (R/A.LE.0.5D0) THEN

          DCOF(1)=DSA0(R,PA,WK)

        ELSE

          CALL JY01BY1(WK*R,BY1)
          DCOF(1)=WK*BY1/4.D0-AQUAD(R,WK,1,0.0D0,DNT,EPS,2)

        ENDIF

! calculate the derivative of the rest expansion coefficients Ai (i=2,m)
! the truncation terms number depends on whether the series
! converged to a specified accuracy or not

       DO I=2,M

        IF (DABS(R).LT.1.E-6) THEN

         DCOF(I)=0.D0

        ELSEIF (R/A.LE.1.D0) THEN

         DCOF(I)=DSAM(R,PA,WVNO(I))

        ELSE

         P1=DNT+STEP
         DO WHILE (DABS(F2(R,WVNO(I),I,P1)).GT.EPS)
         P1=P1+STEP
         ENDDO

         DCOF(I)=AQUAD(R,WVNO(I),I,DNT,P1,EPS,2)

        ENDIF

       ENDDO

       RETURN
       END SUBROUTINE DCOEF

! ==================================================================================
!       Purpose: This program computes the series representations of expansion
!                coefficients (m=0)
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 17, 2018
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                PA --- a key parameter determining convergence, i.e., PA= a*h
!                A ---  a key parameter related with convergence
!                M --- number of elements in the array WVNO
!                WVNO --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!       Output:  SA0 --- value of first expansion coefficient by series representation (m=0)
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================


       REAL*8 FUNCTION SA0(R,PA,WK)

       REAL*8,INTENT(IN)::R,PA,WK
       INTEGER N,P
       REAL*8 GA,PI,EPS,PSI,RM,EN,SGN,FACN
       !REAL*8,EXTERNAL::SYMB,FAC

       DATA GA,PI,EPS/0.5772156649015328D0 ,3.141592653589793D0,1.E-6/

       N=1
       RM=100.D0
       SA0=-GA-2.D0*DLOG(WK*PA/2.D0)
       SGN=-1.D0
       FACN=1.D0

! Loop: the summation stops at the condition when RM meets the tolerance
!
       DO WHILE (DABS(RM).GT.EPS)

        CALL ENXA(N+1,(R/PA)**2,EN)

        PSI=0.D0
        DO P=1,N
         PSI=PSI+1.D0/P
        ENDDO

! calculate the value of each term in the infinite series expansion
!
        RM=SGN*(R/PA)**(2.D0*N)/FACN/N-(WK*PA/2.D0)**(2.D0*N)/FACN*EN-2.D0*SGN     &
            /FACN**2*(WK*R/2.D0)**(2.D0*N)*(DLOG(WK*R/2.D0)+GA-PSI)

        !RM=-(WK*PA/2.D0)**(2.D0*N)/FACN*EN

        SA0=SA0+RM

        N=N+1
        SGN=-SGN   ! Sign function depends on the power n
        FACN=FACN*N   ! factorial of the numbers from 1 to n

       ENDDO

        SA0=SA0/4.D0/PI

       RETURN
       END FUNCTION SA0

! ==================================================================================
!       Purpose: This program computes the series representations of expansion
!                coefficients with respect to R in Linton's method (m=0)
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 17, 2018
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                PA --- a key parameter determining convergence, i.e., PA= a*h
!                A ---  a key parameter related with convergence
!                M --- number of elements in the array WVNO
!                WVNO --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!       Output:  DSA0 --- derivative value of first expansion coefficient by series
!                        representation (m=0)
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION DSA0(R,PA,WK)

       REAL*8,INTENT(IN)::R,PA,WK
       INTEGER N,P
       REAL*8 GA,PI,EPS,PSI,RM,EN,SGN,FACN
       !REAL*8,EXTERNAL::SYMB,FAC

       DATA GA,PI,EPS/0.5772156649015328D0 ,3.141592653589793D0,1.E-6/

       N=1
       RM=100.D0
       DSA0=0.D0
       SGN=-1.D0
       FACN=1.D0

! Loop: the summation stops at the condition when RM meets the tolerance
!
       DO WHILE (DABS(RM).GT.EPS)

        CALL ENXA(N,(R/PA)**2,EN)

        PSI=0.D0
        DO P=1,N
         PSI=PSI+1.D0/P
        ENDDO

! calculate the value of each term in the infinite series expansion
!
        RM=2.D0*SGN*(R/PA)**(2.D0*N-1.D0)/FACN/PA+(WK*PA/2.D0)**(2.D0*N)/FACN*EN*2.D0*R/PA**2-2.D0*SGN*N*WK     &
           /FACN**2*(WK*R/2.D0)**(2.D0*N-1.D0)*(DLOG(WK*R/2.D0)+GA-PSI)-2.D0*SGN/FACN**2*(WK*R/2.D0)**(2.D0*N)/R

        DSA0=DSA0+RM

        N=N+1
        SGN=-SGN   ! Sign function depends on the power n
        FACN=FACN*N   ! factorial of the numbers from 1 to n

       ENDDO

        DSA0=DSA0/4.D0/PI

       RETURN
       END FUNCTION DSA0

! ==================================================================================
!       Purpose: This program computes the series representations of expansion
!                coefficients (m>=1,m=1,2,3,4...)
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 17, 2018
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                PA --- a key parameter determining convergence, i.e., PA= a*h
!                A ---  a key parameter related with convergence
!                M --- number of elements in the array WVNO
!                WVNO --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!       Output:  SAM --- value of first expansion coefficient by series representation
!                       (m>=1,m=1,2,3,4...)
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION SAM(R,PA,WVN)

       REAL*8,INTENT(IN)::R,PA,WVN
       INTEGER N
       REAL*8 GA,PI,EPS,RM,EN,SGN,FACN
       !REAL*8,EXTERNAL::SYMB,FAC

       DATA GA,PI,EPS/0.5772156649015328D0 ,3.141592653589793D0,1.E-6/

       N=0
       RM=100.D0
       SAM=0.D0
       SGN=1.D0
       FACN=1.D0

! Loop: the summation stops at the condition when RM meets the tolerance
!
       DO WHILE (DABS(RM).GT.EPS)

        CALL ENXA(N+1,(WVN*PA/2.D0)**2,EN)

        RM=SGN*(R/PA)**(2.D0*N)/FACN*EN

        SAM=SAM+RM

        N=N+1
        SGN=-SGN   ! Sign function depends on the power n
        FACN=FACN*N   ! factorial of the numbers from 1 to n

       ENDDO

        SAM=SAM/4.D0/PI

       RETURN
       END FUNCTION SAM

! ==================================================================================
!       Purpose: This program computes the series representations of expansion
!                coefficients with respect to R in Linton's method (m>=1,m=1,2,3,4...)
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 17, 2018
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                PA --- a key parameter determining convergence, i.e., PA= a*h
!                A ---  a key parameter related with convergence
!                M --- number of elements in the array WVNO
!                WVNO --- The first elememnt is WK, the rest elements are
!                        the real roots of the equation um*tanh(um*h)= -V
!                WK --- positive root of the dispersion equation k*tanh(k*h)= V
!       Output:  DSAM --- derivative value of first expansion coefficient by series
!                        representation (m>=1,m=1,2,3,4...)
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION DSAM(R,PA,WVN)

       REAL*8,INTENT(IN)::R,PA,WVN
       INTEGER N
       REAL*8 GA,PI,EPS,RM,EN,SGN,FACN
       !REAL*8,EXTERNAL::SYMB,FAC

       DATA GA,PI,EPS/0.5772156649015328D0 ,3.141592653589793D0,1.E-6/

       N=1
       RM=100.D0
       DSAM=0.D0
       SGN=-1.D0
       FACN=1.D0

! Loop: the summation stops at the condition when RM meets the tolerance
!
       DO WHILE (DABS(RM).GT.EPS)

        CALL ENXA(N+1,(WVN*PA/2.D0)**2,EN)

        RM=2.D0*N*SGN*(R/PA)**(2.D0*N-1.D0)/FACN/PA*EN

        DSAM=DSAM+RM

        N=N+1
        SGN=-SGN   ! Sign function depends on the power n
        FACN=FACN*N   ! factorial of the numbers from 1 to n

       ENDDO

       DSAM=DSAM/4.D0/PI

       RETURN
       END FUNCTION DSAM

! ==================================================================================
!       Purpose: This program computes the expansion coefficients and its
!                derivative in Linton's method by integral form.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                WVN --- The input wave number
!                NO --- the term number to be calculated in Linton's expansion
!                T ---  integration variable
!                FUNTAG --- 1: calculate function value; 2: calculate derivative value
!       Output:  FUN --- value of expansion coefficient or its derivative by integral
!                        representation
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

        REAL*8 FUNCTION FUN(R,WVN,NO,T,FUNTAG)

        INTEGER,INTENT(IN)::NO,FUNTAG
        REAL*8,INTENT(IN)::R,WVN,T
        !REAL*8,EXTERNAL::F1,F2

        SELECT CASE(FUNTAG)


        CASE(1)
          FUN=F1(R,WVN,NO,T)

        CASE(2)
          FUN=F2(R,WVN,NO,T)


        END SELECT

        RETURN
        END FUNCTION FUN


! ==================================================================================
!       Purpose: This program computes the expansion coefficients and its
!                derivative in Linton's method by integral form.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                WVN --- The input wave number
!                NO --- the term number to be calculated in Linton's expansion
!                T ---  integration variable
!                FUNTAG --- 1: calculate function value; 2: calculate derivative value
!       Output:  FUN --- value of expansion coefficient or its derivative by integral
!                        representation
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

        REAL*8 FUNCTION FUNF(V,R,ZF,ZP,H,T,FUNTAG)

        INTEGER,INTENT(IN)::FUNTAG
        REAL*8,INTENT(IN)::V,R,ZF,ZP,H,T
        !REAL*8,EXTERNAL::G1,G2,G3

        SELECT CASE(FUNTAG)


!        INTEGRAND OF L1
        CASE(1)
          FUNF=G1(V,R,ZF,ZP,H,T)

!        INTEGRAND OF L1R
        CASE(2)
          FUNF=G2(V,R,ZF,ZP,H,T)

!        INTEGRAND OF L1Z
        CASE(3)
          FUNF=G3(V,R,ZF,ZP,H,T)


        END SELECT

        RETURN
        END FUNCTION FUNF

! ==================================================================================
!       Purpose: This program computes the value of expansion coefficients
!                in Linton's method by integral form.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                WVN --- The input wave number
!                NO --- the term number to be calculated in Linton's expansion
!                T ---  integration variable
!       Output:  F1 --- value of expansion coefficient by integral representation
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION F1(R,WVN,NO,T)

       INTEGER NO
       REAL*8,INTENT(IN)::R,WVN,T
       REAL*8 PI

       DATA  PI/3.141592653589793D0/

       IF (DABS(T).LT.1.D-8) THEN

        F1=0.D0

       ELSE

        IF (NO.EQ.1) THEN

        F1=DEXP(-R**2/4.D0/T+WVN**2*T)/4.D0/PI/T

        ELSE

        F1=DEXP(-R**2/4.D0/T-WVN**2*T)/4.D0/PI/T

        ENDIF

       ENDIF


       RETURN
       END FUNCTION F1

! ==================================================================================
!       Purpose: This program computes derivative of the expansion coefficients
!                in Linton's method by integral form.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   R --- horizontal distance of the source point and the field point
!                WVN --- The input wave number
!                NO --- the term number to be calculated in Linton's expansion
!                T ---  integration variable
!       Output:  F2 --- derivative value of the expansion coefficient by integral
!                        representation
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION F2(R,WVN,NO,T)


       INTEGER NO
       REAL*8,INTENT(IN)::R,WVN,T
       REAL*8 PI

       DATA  PI/3.141592653589793D0/

       IF (DABS(T).LT.1.D-8) THEN

        F2=0.D0

       ELSE

        IF (NO.EQ.1) THEN

         F2=-R*DEXP(-R**2/4.D0/T+WVN**2*T)/8.D0/PI/T**2

        ELSE

         F2=-R*DEXP(-R**2/4.D0/T-WVN**2*T)/8.D0/PI/T**2

        ENDIF

       ENDIF

       RETURN
       END FUNCTION F2

! ==================================================================================
!       Purpose: This program computes the value of the survival integral
!                in L1 function in Linton's method.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   V --- wave number in deep water , i.e., V= w^2/g
!                R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                H --- water depth (h>0)
!                T ---  integration variable
!       Output:  G1 --- value of the survival integral in L1 in Linton's
!                       representation
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION G1(V,R,ZF,ZP,H,T)

       REAL*8,INTENT(IN)::V,R,ZF,ZP,H,T
       INTEGER I
       REAL*8 SUM,VAL(4)
       !REAL*8,EXTERNAL::ERFCC

       IF (DABS(T).LT.1.D-8) THEN

        G1=0.D0

       ELSE

        CALL CHI(ZF,ZP,H,VAL)

        SUM=0.D0
        DO I=1,4
         SUM=SUM+DEXP(-V*VAL(I))*ERFCC(VAL(I)/2.D0/T-V*T)
        ENDDO

        G1=DEXP(V**2*T**2-R**2/4.D0/T**2)*SUM/T

       ENDIF

        RETURN
        END FUNCTION G1

! ==================================================================================
!       Purpose: This program computes derivative of the survival integral
!                in L1 function with respect to R in Linton's method.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   V --- wave number in deep water , i.e., V= w^2/g
!                R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                H --- water depth (h>0)
!                T ---  integration variable
!       Output:  G2 --- derivative value of the survival integral in L1 with respect
!                       to R in Linton's representation
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION G2(V,R,ZF,ZP,H,T)


       REAL*8,INTENT(IN)::V,R,ZF,ZP,H,T
       INTEGER I
       REAL*8 SUM,VAL(4)
       !REAL*8,EXTERNAL::ERFCC

       IF (DABS(T).LT.1.D-8) THEN

        G2=0.D0

       ELSE

        CALL CHI(ZF,ZP,H,VAL)

        SUM=0.D0
        DO I=1,4
         SUM=SUM+DEXP(-V*VAL(I))*ERFCC(VAL(I)/2.D0/T-V*T)
        ENDDO

        G2=R/2.D0/T**3*DEXP(V**2*T**2-R**2/4.D0/T**2)*SUM

       ENDIF

       RETURN
       END FUNCTION G2

! ==================================================================================
!       Purpose: This program computes derivative of the survival integral
!                in L1 function with respect to z in Linton's method.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on Sept 7, 2013
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!  Parameters:
!       Input:   V --- wave number in deep water , i.e., V= w^2/g
!                R --- horizontal distance of the source point and the field point
!                ZF,ZP --- Z coordinates of the source point and the field point
!                H --- water depth (h>0)
!                T ---  integration variable
!       Output:  G3 --- derivative value of the survival integral in L1 with respect
!                       to z in Linton's representation
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       REAL*8 FUNCTION G3(V,R,ZF,ZP,H,T)

       REAL*8,INTENT(IN)::V,R,ZF,ZP,H,T
       INTEGER I
       REAL*8 SUM,VAL(4),DVAL(4)
       !REAL*8,EXTERNAL::ERFCC,DERFCC

       IF (DABS(T).LT.1.D-8) THEN

        G3=0.D0

       ELSE

        CALL CHI(ZF,ZP,H,VAL)
        CALL DCHI(DVAL)

        SUM=0.D0
        DO I=1,4
         SUM=SUM-V*DVAL(I)*DEXP(-V*VAL(I))*ERFCC(VAL(I)/2.D0/T-V*T)    &
             +DEXP(-V*VAL(I))*DERFCC(VAL(I)/2.D0/T-V*T)*DVAL(I)/2.D0/T
        ENDDO

        G3=DEXP(V**2*T**2-R**2/4.D0/T**2)*SUM/T

       ENDIF


       RETURN
       END FUNCTION G3
!
!    ===========================================================
!      Functions 1/dsqrt(R^2+chi(1,i)^2) and their derivatives
!         Code Original Author: Yingyi Liu   2013.09.07
!    ===========================================================

       SUBROUTINE RCHI(R,ZF,ZP,H,RO,DROR,DROZ)

       INTEGER I
       REAL*8 R,ZF,ZP,H
       REAL*8 RO(4),DROR(4),DROZ(4),VAL(4)


       CALL CHI(ZF,ZP,H,VAL)

       DO I=1,4

       RO(I)=DSQRT(R**2+VAL(I)**2)
       DROR(I)=R/DSQRT(R**2+VAL(I)**2)
       DROZ(I)=VAL(I)*(-1.D0)**I/DSQRT(R**2+VAL(I)**2)

       ENDDO

       RETURN
       END SUBROUTINE RCHI
!
!    ===========================================================
!                        Function Chi(1,i)
!         Code Original Author: Yingyi Liu   2013.09.07
!    ===========================================================

       SUBROUTINE CHI(ZF,ZP,H,VAL)

       REAL*8 ZF,ZP,H,VAL(4)

       VAL(1)=-ZP-ZF
       VAL(2)=2.D0*H-ZP+ZF
       VAL(3)=2.D0*H+ZP-ZF
       VAL(4)=4.D0*H+ZP+ZF

       RETURN
       END SUBROUTINE CHI
!
!    ===========================================================
!       The derivative of function Chi(1,i) with respect to z
!         Code Original Author: Yingyi Liu   2013.09.07
!    ===========================================================

       SUBROUTINE DCHI(DVAL)

       REAL*8 DVAL(4)

       DVAL(1)=-1.D0
       DVAL(2)=1.D0
       DVAL(3)=-1.D0
       DVAL(4)=1.D0

       RETURN
       END SUBROUTINE DCHI

!
!    ===========================================================
!                         Function Nm
!         Code Original Author: Yingyi Liu   2013.09.07
!    ===========================================================

       FUNCTION NM(H,WVN)

       REAL*8 H
       COMPLEX*16 NM,WVN

       NM=H/2.D0*(1.D0+CDSIN(2.D0*WVN*H)/(2.D0*WVN*H))

       RETURN
       END FUNCTION NM
!
!    ===========================================================
!          Derivative of the complementary error function
!         Code Original Author: Yingyi Liu   2013.09.07
!    ===========================================================

       FUNCTION DERFCC(X)

       REAL*8 DERFCC,X
       REAL*8 PI

       DATA  PI/3.141592653589793D0/

       DERFCC=-2.D0/DSQRT(PI)*DEXP(-X**2.D0)

       RETURN
       END FUNCTION DERFCC

!
!    ===========================================================
!             The complementary error function erfc(x)
!         Code Original Author: Yingyi Liu   2013.09.07
!    ===========================================================

       FUNCTION ERFCC(X)
       REAL*8 ERFCC,X,ERR

       CALL ERROR(X,ERR)
       ERFCC=1.D0-ERR

       RETURN
       END FUNCTION ERFCC



! ==================================================================================
!       Purpose: This program computes the 1D integral value of an external
!                integrand function in a finite interval (A,B) using standard
!                Kronrod extension of Gauss-Lengendre rule,  here using the
!                commonly used standard pair (G7,K15).
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on June 2, 2012
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!    Yingyi Liu, Ying Gou, Bin Teng, Shigeo Yoshida
!    An Extremely Efficient Boundary Element Method for Wave Interaction with Long
!    Cylindrical Structures Based on Free-Surface Green's Functions.
!    Computation, 4(2016), 36
!
!  Parameters:
!       Input:   V,R,ZF,ZP,H --- variables of the integrated function, should be
!                        changed by the user when he/she uses this program separately
!                        from this library for other purpose.
!                A,B --- the two end-points of the interval (A,B).
!                FUNTAG --- a flag for indicating which function components to be integrated.
!  Ext. Routine: FUN --- the external subroutine of the function integrand to be integrated,
!                        this should be specified by the user when he/she uses this program
!                        separately from this library for other purpose.
!       Output:  GK_INT --- the integral value calculated by Gauss-Kronrod rule,
!                           which is the final output and more accurate.
!                ERR --- the error estimate of this integration within interval (A,B).
!
!  Passed Variables:
!                XGQ(7),WGQ(7) --- the abscissas and weights for the Gauss rule.
!                XKQ(15),WKQ(15) --- the abscissas and weights for the Gauss-Kronrod rule.
!                G_INT --- the integral value calculated by Gauss rule.
!                STF(7) ---  the stored integrand function value calculated by Gauss rule,
!                            which can be reused by the Gauss-Kronrod rule.
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       SUBROUTINE GK_INTEGF(V,R,ZF,ZP,H,A,B,GK_INT,ERR,FUNTAG)

       INTEGER,INTENT(IN)::FUNTAG
       REAL*8,INTENT(IN)::V,R,ZF,ZP,H,A,B
       REAL*8,INTENT(OUT)::GK_INT,ERR
       !REAL*8,EXTERNAL::FUNF
       INTEGER I
       REAL*8 XGQ(7),WGQ(7),XKQ(15),WKQ(15),STF(7),G_INT


! ** matrix XGQ store the Gauss-Legendre sampling points(7)
!
        DATA XGQ/-0.949107912342759D0,-0.741531185599394D0,     &
                 -0.405845151377397D0, 0.000000000000000D0,     &
                  0.405845151377397D0, 0.741531185599394D0,     &
                  0.949107912342759D0/
!
! ** matrix WGQ store the Gauss-Legendre weighting factors
!
        DATA WGQ/ 0.129484966168870D0, 0.279705391489277D0,     &
                  0.381830050505119D0, 0.417959183673469D0,     &
                  0.381830050505119D0, 0.279705391489277D0,     &
                  0.129484966168870D0/
!
! ** matrix XKQ store the Kronrod sampling points(15)
!
        DATA XKQ/-0.991455371120813D0,-0.949107912342759D0,     &
                 -0.864864423359769D0,-0.741531185599394D0,     &
                 -0.586087235467691D0,-0.405845151377397D0,     &
                 -0.207784955007898D0, 0.000000000000000D0,     &
                  0.207784955007898D0, 0.405845151377397D0,     &
                  0.586087235467691D0, 0.741531185599394D0,     &
                  0.864864423359769D0, 0.949107912342759D0,     &
                  0.991455371120813D0/
!
! ** matrix WKQ store the weighting factors for the Kronrod
!    sampling points
!
        DATA WKQ/ 0.022935322010529D0, 0.063092092629979D0,     &
                  0.104790010322250D0, 0.140653259715525D0,     &
                  0.169004726639267D0, 0.190350578064785D0,     &
                  0.204432940075298D0, 0.209482141084728D0,     &
                  0.204432940075298D0, 0.190350578064785D0,     &
                  0.169004726639267D0, 0.140653259715525D0,     &
                  0.104790010322250D0, 0.063092092629979D0,     &
                  0.022935322010529D0/

        G_INT=0.0D0
        DO I=1,7
         STF(I)=FUNF(V,R,ZF,ZP,H,1/2.0D0*(B+A+(B-A)*XGQ(I)),FUNTAG)
         G_INT=G_INT+WGQ(I)*(B-A)/2.0D0*STF(I)
        END DO

        GK_INT=0.0D0
        DO I=1,15
         IF (MOD(I,2)==0) THEN
           GK_INT=GK_INT+WKQ(I)*(B-A)/2.0D0*STF(I/2)
         ELSE
         GK_INT=GK_INT+WKQ(I)*(B-A)/2.0D0*FUNF(V,R,ZF,ZP,H,1/2.0D0*(B+A+(B-A)*XKQ(I)),FUNTAG)
         ENDIF
       END DO
          ERR=(200.0D0*DABS(GK_INT-G_INT))**(1.5D0)

       RETURN
      END SUBROUTINE GK_INTEGF


! ==================================================================================
!       Purpose: This program using an adaptive quadrature method to compute the
!                integral value of an external integrand function in a finite
!                interval (A,B) by automatically dividing the interval into halves
!                and continuously calling the Gauss-Kronrod subroutine in order
!                to finally meet the requested accuracy Eps.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on June 2, 2012
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!    Yingyi Liu, Ying Gou, Bin Teng, Shigeo Yoshida
!    An Extremely Efficient Boundary Element Method for Wave Interaction with Long
!    Cylindrical Structures Based on Free-Surface Green's Functions.
!    Computation, 4(2016), 36
!
!  Parameters:
!       Input:   V,R,ZF,ZP,H --- variables of the integrated function, should be
!                        changed by the user when he/she uses this program separately
!                        from this library for other purpose.
!                A,B --- the two end-points of the interval (A,B).
!                EPS --- the requested tolerance for the integration.
!                FUNTAG --- a flag for indicating which function components to be integrated.
!  Ext. Routine: GK_INTEG --- the external subroutine of Gauss-Kronrod rule, this should be
!                        modified a little by the user when he/she uses this program
!                        separately from this library for other purpose.
!       Output:  ANS --- the result of integration.
!
!  Passed Variables:
!                GK_INT --- the integral value calculated by subroutine GK_INTEG.
!                ERR ---  the error estimate calculated by subroutine GK_INTEG.
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       RECURSIVE REAL*8 FUNCTION AQUADF(V,R,ZF,ZP,H,A,B,EPS,FUNTAG) RESULT(ANS)

       REAL*8,INTENT(IN)::V,R,ZF,ZP,H,A,B,EPS
       INTEGER,INTENT(IN)::FUNTAG
       REAL*8 GK_INT,ERR

       ANS=0.0D0
       CALL GK_INTEGF(V,R,ZF,ZP,H,A,B,GK_INT,ERR,FUNTAG)

       IF (ERR>EPS.AND.DABS(A-B)>EPS) THEN
         ANS=ANS+AQUADF(V,R,ZF,ZP,H,A,(A+B)/2.0D0,EPS,FUNTAG)+AQUADF(V,R,ZF,ZP,H,(A+B)/2.0D0,B,EPS,FUNTAG)
       ELSE
          ANS=ANS+GK_INT
       ENDIF

       RETURN
       END FUNCTION AQUADF



! ==================================================================================
!       Purpose: This program computes the 1D integral value of an external
!                integrand function in a finite interval (A,B) using standard
!                Kronrod extension of Gauss-Lengendre rule,  here using the
!                commonly used standard pair (G7,K15).
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on June 2, 2012
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!    Yingyi Liu, Ying Gou, Bin Teng, Shigeo Yoshida
!    An Extremely Efficient Boundary Element Method for Wave Interaction with Long
!    Cylindrical Structures Based on Free-Surface Green's Functions.
!    Computation, 4(2016), 36
!
!  Parameters:
!       Input:   R,WVN,NO --- variables of the integrated function, should be
!                        changed by the user when he/she uses this program separately
!                        from this library for other purpose.
!                A,B --- the two end-points of the interval (A,B).
!                FUNTAG --- a flag for indicating which function components to be integrated.
!  Ext. Routine: FUN --- the external subroutine of the function integrand to be integrated,
!                        this should be specified by the user when he/she uses this program
!                        separately from this library for other purpose.
!       Output:  GK_INT --- the integral value calculated by Gauss-Kronrod rule,
!                           which is the final output and more accurate.
!                ERR --- the error estimate of this integration within interval (A,B).
!
!  Passed Variables:
!                XGQ(7),WGQ(7) --- the abscissas and weights for the Gauss rule.
!                XKQ(15),WKQ(15) --- the abscissas and weights for the Gauss-Kronrod rule.
!                G_INT --- the integral value calculated by Gauss rule.
!                STF(7) ---  the stored integrand function value calculated by Gauss rule,
!                            which can be reused by the Gauss-Kronrod rule.
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       SUBROUTINE GK_INTEG(R,WVN,NO,A,B,GK_INT,ERR,FUNTAG)

        INTEGER,INTENT(IN)::NO,FUNTAG
        REAL*8,INTENT(IN)::R,WVN,A,B
        REAL*8,INTENT(OUT)::GK_INT,ERR
        !REAL*8,EXTERNAL::FUN
        INTEGER I
        REAL*8 XGQ(7),WGQ(7),XKQ(15),WKQ(15),STF(7),G_INT


! ** matrix XGQ store the Gauss-Legendre sampling points(7)
!
        DATA XGQ/-0.949107912342759D0,-0.741531185599394D0,     &
                 -0.405845151377397D0, 0.000000000000000D0,     &
                  0.405845151377397D0, 0.741531185599394D0,     &
                  0.949107912342759D0/
!
! ** matrix WGQ store the Gauss-Legendre weighting factors
!
        DATA WGQ/ 0.129484966168870D0, 0.279705391489277D0,     &
                  0.381830050505119D0, 0.417959183673469D0,     &
                  0.381830050505119D0, 0.279705391489277D0,     &
                  0.129484966168870D0/
!
! ** matrix XKQ store the Kronrod sampling points(15)
!
        DATA XKQ/-0.991455371120813D0,-0.949107912342759D0,     &
                 -0.864864423359769D0,-0.741531185599394D0,     &
                 -0.586087235467691D0,-0.405845151377397D0,     &
                 -0.207784955007898D0, 0.000000000000000D0,     &
                  0.207784955007898D0, 0.405845151377397D0,     &
                  0.586087235467691D0, 0.741531185599394D0,     &
                  0.864864423359769D0, 0.949107912342759D0,     &
                  0.991455371120813D0/
!
! ** matrix WKQ store the weighting factors for the Kronrod
!    sampling points
!
        DATA WKQ/ 0.022935322010529D0, 0.063092092629979D0,     &
                  0.104790010322250D0, 0.140653259715525D0,     &
                  0.169004726639267D0, 0.190350578064785D0,     &
                  0.204432940075298D0, 0.209482141084728D0,     &
                  0.204432940075298D0, 0.190350578064785D0,     &
                  0.169004726639267D0, 0.140653259715525D0,     &
                  0.104790010322250D0, 0.063092092629979D0,     &
                  0.022935322010529D0/

        G_INT=0.0D0
        DO I=1,7
         STF(I)=FUN(R,WVN,NO,1/2.0D0*(B+A+(B-A)*XGQ(I)),FUNTAG)
         G_INT=G_INT+WGQ(I)*(B-A)/2.0D0*STF(I)
        END DO

        GK_INT=0.0D0
        DO I=1,15
         IF (MOD(I,2)==0) THEN
           GK_INT=GK_INT+WKQ(I)*(B-A)/2.0D0*STF(I/2)
         ELSE
         GK_INT=GK_INT+WKQ(I)*(B-A)/2.0D0*FUN(R,WVN,NO,1/2.0D0*(B+A+(B-A)*XKQ(I)),FUNTAG)
         ENDIF
       END DO

       ERR=(200.0D0*DABS(GK_INT-G_INT))**(1.5D0)

       RETURN
       END SUBROUTINE GK_INTEG


! ==================================================================================
!       Purpose: This program using an adaptive quadrature method to compute the
!                integral value of an external integrand function in a finite
!                interval (A,B) by automatically dividing the interval into halves
!                and continuously calling the Gauss-Kronrod subroutine in order
!                to finally meet the requested accuracy Eps.
!
!  License:
!
!    This routine is part of FinGreen3D.
!
!    FinGreen3D is a free software package: you can redistribute it and/or modify it
!    under the terms of the GNU Lesser General Public License as published by the
!    Free Software Foundation, either version 3 of the License, or (at your option)
!    any later version.
!
!    You should have received a copy of the GNU General Public License (either V3
!    or later), along with FinGreen3D. If not, see <http://www.gnu.org/licenses/>.
!
!  Code Original Author:
!
!    Yingyi Liu on June 2, 2012
!
!  Modified on:
!
!    July 21, 2016
!
!  Reference:
!
!    Yingyi Liu et al. A reliable open-source package for performance evaluation of
!    floating renewable energy systems in coastal and offshore regions. Energy Conversion
!    and management, 2018
!
!    Yingyi Liu, Ying Gou, Bin Teng, Shigeo Yoshida
!    An Extremely Efficient Boundary Element Method for Wave Interaction with Long
!    Cylindrical Structures Based on Free-Surface Green's Functions.
!    Computation, 4(2016), 36
!
!  Parameters:
!       Input:   R,WVN,NO --- variables of the integrated function, should be
!                        changed by the user when he/she uses this program separately
!                        from this library for other purpose.
!                A,B --- the two end-points of the interval (A,B).
!                EPS --- the requested tolerance for the integration.
!                FUNTAG --- a flag for indicating which function components to be integrated.
!  Ext. Routine: GK_INTEG --- the external subroutine of Gauss-Kronrod rule, this should be
!                        modified a little by the user when he/she uses this program
!                        separately from this library for other purpose.
!       Output:  ANS --- the result of integration.
!
!  Passed Variables:
!                GK_INT --- the integral value calculated by subroutine GK_INTEG.
!                ERR ---  the error estimate calculated by subroutine GK_INTEG.
!
!  Contributors list:
!         Yingyi Liu
!         to be continued...
!
! ==================================================================================

       RECURSIVE REAL*8 FUNCTION AQUAD(R,WVN,NO,A,B,EPS,FUNTAG) RESULT(ANS)

        REAL*8,INTENT(IN)::R,WVN,A,B,EPS
        INTEGER,INTENT(IN)::NO,FUNTAG
        REAL*8 GK_INT,ERR

       ANS=0.0D0
       CALL GK_INTEG(R,WVN,NO,A,B,GK_INT,ERR,FUNTAG)

       IF (ERR>EPS.AND.DABS(A-B)>EPS) THEN
         ANS=ANS+AQUAD(R,WVN,NO,A,(A+B)/2.0D0,EPS,FUNTAG)+AQUAD(R,WVN,NO,(A+B)/2.0D0,B,EPS,FUNTAG)
       ELSE
          ANS=ANS+GK_INT
       ENDIF

       RETURN
       END FUNCTION AQUAD

!!---------------------------------------------------------------------------!!
!        Belows are  third-party (external) Level-3 (low level) subroutines      !
!!---------------------------------------------------------------------------!!
!
!  ============================================================================
!        Purpose: This program computes the error function
!                 erf(x) using subroutine ERROR
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Parameters:
!        Input:   x   --- Argument of erf(x)
!        Output:  ERR --- erf(x)
!        Example:
!                   x         erf(x)
!                 ---------------------
!                  1.0       .84270079
!                  2.0       .99532227
!                  3.0       .99997791
!                  4.0       .99999998
!                  5.0      1.00000000
!   ============================================================================

        SUBROUTINE ERROR(X,ERR)

        IMPLICIT NONE
        INTEGER K
        REAL*8 EPS,PI,X,X2,ER,R,C0,ERR

        EPS=1.0D-15
        PI=3.141592653589793D0
        X2=X*X
        IF (DABS(X).LT.3.5D0) THEN
           ER=1.0D0
           R=1.0D0
           DO K=1,50
              R=R*X2/(K+0.5D0)
              ER=ER+R
              IF (DABS(R).LE.DABS(ER)*EPS) EXIT
           ENDDO
           C0=2.0D0/DSQRT(PI)*X*DEXP(-X2)
           ERR=C0*ER
        ELSE
           ER=1.0D0
           R=1.0D0
           DO K=1,12
              R=-R*(K-0.5D0)/X2
              ER=ER+R
           ENDDO
           C0=DEXP(-X2)/(DABS(X)*DSQRT(PI))
           ERR=1.0D0-C0*ER
           IF (X.LT.0.0) ERR=-ERR
        ENDIF
        RETURN
        END

!
!  ============================================================================
!        Purpose: This program computes the exponential integral
!                 En(x) using subroutine ENXB
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Parameters:
!        Input :  x --- Argument of En(x)
!                 n --- Order of En(x)  (n = 0,1,2,...)
!        Output:  EN --- En(x)
!        Example: x = 10.0
!                    n         En(x)
!                  ----------------------
!                    0     .45399930D-05
!                    1     .41569689D-05
!                    2     .38302405D-05
!                    3     .35487626D-05
!                    4     .33041014D-05
!                    5     .30897289D-05
!  ============================================================================
!
        SUBROUTINE ENXA(N,X,EN)

        IMPLICIT NONE
        INTEGER N,K
        REAL*8 X,E0,E1,EN

        E0=DEXP(-X)/X

        CALL E1XA(X,E1)

        IF (N.EQ.0) THEN
          EN=E0
        ELSEIF (N.EQ.1) THEN
          EN=E1
        ELSE
          DO K=2,N
             EN=(DEXP(-X)-X*E1)/(K-1.0D0)
             E1=EN
          ENDDO
        ENDIF

        RETURN
        END

!
!  ============================================================================
!        Purpose: This program computes the exponential integral
!                 E1(x) using subroutine E1XA
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Parameters:
!        Input :  x  --- Argument of E1(x)  ( x > 0 )
!        Output:  E1 --- E1(x)
!        Example:
!                   x        E1(x)
!                 ----------------------
!                  0.0     .1000000+301
!                  1.0     .2193839E+00
!                  2.0     .4890051E-01
!                  3.0     .1304838E-01
!                  4.0     .3779352E-02
!                  5.0     .1148296E-02
!  ============================================================================
!
        SUBROUTINE E1XA(X,E1)

        IMPLICIT NONE
        REAL*8 X,E1,ES1,ES2

        IF (X.EQ.0.0) THEN
           E1=1.0D+300
        ELSE IF (X.LE.1.0) THEN
           E1=-DLOG(X)+((((1.07857D-3*X-9.76004D-3)*X+5.519968D-2)*X-0.24991055D0)*X+0.99999193D0)*X-0.57721566D0
        ELSE
           ES1=(((X+8.5733287401D0)*X+18.059016973D0)*X+8.6347608925D0)*X+0.2677737343D0
           ES2=(((X+9.5733223454D0)*X+25.6329561486D0)*X+21.0996530827D0)*X+3.9584969228D0
           E1=DEXP(-X)/X*ES1/ES2
        ENDIF
        RETURN
        END

!
!  ============================================================================
!        Purpose: This program computes the exponential integral
!                 Ei(x) using subroutine EIX
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Parameters:
!        Input :  x  --- Argument of Ei(x)
!        Output:  EI --- Ei(x) ( x > 0 )
!        Example:
!                   x        Ei(x)
!                 -----------------------
!                   0    -.10000000+301
!                   1     .18951178E+01
!                   2     .49542344E+01
!                   3     .99338326E+01
!                   4     .19630874E+02
!                   5     .40185275E+02
!  ============================================================================

        SUBROUTINE EIX(X,EI)

        IMPLICIT NONE
        INTEGER K
        REAL*8 X,EI,R,GA

        IF (X.EQ.0.0) THEN
           EI=-1.0D+300
        ELSE IF (X.LE.40.0) THEN
           EI=1.0D0
           R=1.0D0
           DO K=1,100
              R=R*K*X/(K+1.0D0)**2
              EI=EI+R
              IF (DABS(R/EI).LE.1.0D-15) EXIT
           ENDDO
           GA=0.5772156649015328D0
           EI=GA+DLOG(X)+X*EI
        ELSE
           EI=1.0D0
           R=1.0D0
           DO K=1,20
              R=R*K/X
              EI=EI+R
           ENDDO
           EI=DEXP(X)/X*EI
        ENDIF
        RETURN
        END

!
!  ============================================================================
!        Purpose: This program computes the gamma function
!                 GAMMA(x) for x > 0 or its logarithm using
!                 subroutine LGAMA
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Parameters:
!        Purpose: Compute gamma function GAMMA(x) or ln[GAMMA(x)]
!        Input:   x  --- Argument of GAMMA(x) ( x > 0 )
!                 KF --- Function code
!                        KF=1 for GAMMA(x); KF=0 for ln[GAMMA(x)]
!        Output:  GL --- GAMMA(x) or ln[GAMMA(x)]
!        Examples:
!                   x           GAMMA(x)
!                 -------------------------
!                  0.5     .1772453851D+01
!                  2.5     .1329340388D+01
!                  5.0     .2400000000D+02
!                  7.5     .1871254306D+04
!                 10.0     .3628800000D+06
!  ============================================================================

        SUBROUTINE LGAMA(KF,X,GL)

        IMPLICIT NONE
        INTEGER K,KF,N
        REAL*8 X,X0,GL,X2,XP,GL0

        REAL*8 A(10)
        DATA A/8.333333333333333D-02,-2.777777777777778D-03,     &
               7.936507936507937D-04,-5.952380952380952D-04,     &
               8.417508417508418D-04,-1.917526917526918D-03,     &
               6.410256410256410D-03,-2.955065359477124D-02,     &
               1.796443723688307D-01,-1.39243221690590D+00/

        X0=X
        IF (X.EQ.1.0.OR.X.EQ.2.0) THEN
           GL=0.0D0
           IF (KF.EQ.1) GL=DEXP(GL)
        ELSE IF (X.LE.7.0) THEN
           N=INT(7-X)
           X0=X+N
           X2=1.0D0/(X0*X0)
           XP=6.283185307179586477D0
           GL0=A(10)
           DO K=9,1,-1
            GL0=GL0*X2+A(K)
           ENDDO
           GL=GL0/X0+0.5D0*DLOG(XP)+(X0-.5D0)*DLOG(X0)-X0
           IF (X.LE.7.0) THEN
              DO K=1,N
                 GL=GL-DLOG(X0-1.0D0)
                 X0=X0-1.0D0
              ENDDO
           ENDIF
           IF (KF.EQ.1) GL=DEXP(GL)
        ENDIF

        RETURN
        END




!-----------------------------------------------------------------------------
!+ Finds the limit of a series
      SUBROUTINE Limes      &
      (   N,        &      ! in
          S,        &      ! inout
          rLimes,      &      ! out
          i_Pade,      &      ! out
          k_Pade,     &       ! out
          err  )             ! out

! Description:
!   Finds the limit of a series in the case where only
!   the first N+1 terms are known.
!
! Method:
!   The subroutine operates by applying the epsilon-algorithm
!   to the sequence of partial sums of a seris supplied on input.
!   For description of the algorithm, please see:
!
!   [1] T. Mishonov and E. Penev, Int. J. Mod. Phys. B 14, 3831 (2000)
!
! Owners: Todor Mishonov & Evgeni Penev
!
! History:
! Version   Date         Comment
! =======   ====         =======
! 1.0       01/04/2000   Original code. T. Mishonov & E. Penev
!
! Code Description:
!   Language:           Fortran 90.
!   Software Standards: "European Standards for Writing and
!                        Documenting Exchangeable Fortran 90 Code".
!
! Declarations:
       IMPLICIT NONE

!* Subroutine arguments
!  Scalar arguments with intent(in):
       INTEGER,   INTENT (IN)    :: N       ! width of the epsilon-table

!  Array arguments with intent(inout):
       REAL*8, INTENT (INOUT) :: S(0:N)   ! sequential row of the epsilon-table

!  Scalar arguments with intent(out)
       REAL*8, INTENT (OUT)   :: rLimes  ! value of the series limes
       INTEGER,   INTENT (OUT)   :: i_Pade  ! power of the numerator
       INTEGER,   INTENT (OUT)   :: k_Pade  ! power of the denominator
       REAL*8, INTENT (OUT)   :: err     ! empirical error

!* End of Subroutine arguments

!  Local parameters                    ! these two need no description ;-)
       REAL*8,    PARAMETER   :: zero = 0.0
       REAL*8,    PARAMETER   :: one  = 1.0

!  Local scalars
       REAL*8                 :: A_max   ! maximum element of A
       INTEGER                   :: i       ! index variable for columns
       INTEGER                   :: k       ! index variable for rows

!  Local arrays
       REAL*8                 :: A(0:N)  ! auxiliary row of the epsilon-table

!- End of header --------------------------------------------------------------

!  Parse input: the algorithm cannot employ more elements than supplied on
!               input, i.e. N <= size(S)
!
      IF ( N > SIZE (S(:)) ) THEN
      WRITE (*, '(A)') '*** Illegal input to Limes: N > size(S)'
       STOP 1
      END IF

!  Algorithm not applicable for N < 2
!
      IF ( N < 2 ) THEN
      WRITE (*, '(A)') '*** Illegal input to Limes: N < 2'
       STOP 2
      END IF

!-----------------------------------------------------------------------------
!  I. Initialize with natural assignments
!-----------------------------------------------------------------------------

      rLimes = S(N)                    ! the N-th partial sum
      err    = ABS ( S(N) - S(N-1) )   ! error -> |S(N) - S(N-1)|
      i_Pade = N                       ! Pade approximant [N/0]
      k_Pade = 0                       !
      A(:)   = zero                ! auxiliary row initially set to zero
      A_max  = zero                ! max. element set to zero
      k      = 1                   ! algorithm starts from the first row

!-----------------------------------------------------------------------------
! II. Main loop: fill in the epsilon table, check for convergence ...
!     (provision against division by zero employs pseudo-inverse numbers)
!-----------------------------------------------------------------------------
      DO
       IF ( N - 2 * k + 1 < 0 ) EXIT

! Update the auxiliary row A(i) of the epsilon-table
! by applying the "cross rule".
!
      DO i=0, N - 2 * k + 1
       IF ( S(i+1) /= S(i) ) THEN
        A(i) = A(i+1) + one/(S(i+1) - S(i))
       ELSE
        A(i) = A(i+1)
       END IF
      END DO
      IF ( N - 2 * k < 0 ) EXIT

!  Update the sequential row S(i) of the epsilon-table
!  by applying the "cross rule".
!
      DO i=0, N - 2 * k
       IF ( A(i+1) /= A(i) ) THEN
        S(i) = S(i+1) + one/(A(i+1) - A(i))
       ELSE
        S(i) = S(i+1)
       END IF

!  Check for convergence, based on A_max; see Ref. [1]
!
       IF ( ABS ( A(i) ) > A_max ) THEN
        A_max  = ABS ( A(i) )
        rLimes = S(i)
        k_Pade = k
        i_Pade = i + k_Pade
        err    = one/A_max
        IF ( S(i+1) == S(i) ) RETURN
       END IF
      END DO
       k = k + 1      ! increment row index
      END DO

      END SUBROUTINE Limes


!
!  ============================================================================
!        Purpose: Compute modified Bessel functions I0(x), I1(1),
!                 K0(x) and K1(x), and their derivatives
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Parameters:
!        Input :  x   --- Argument ( x � 0 )
!        Output:  BK0 --- K0(x)
!                 BK1 --- K1(x)
!  ============================================================================
!

        SUBROUTINE IK01A(X,BK0,BK1)

        IMPLICIT NONE
        INTEGER K,K0
        REAL*8 PI,EL,X,X2,BI0,BI1,BK0,BK1,R,XR,CA,CT,W0,WW,CB,XR2
        REAL*8 A(12),B(12),A1(8)

        PI=3.141592653589793D0
        EL=0.5772156649015329D0
        X2=X*X
        IF (X.EQ.0.0D0) THEN
           BI0=1.0D0
           BI1=0.0D0
           BK0=1.0D+300
           BK1=1.0D+300
           RETURN
        ELSE IF (X.LE.18.0D0) THEN
           BI0=1.0D0
           R=1.0D0
           DO K=1,50
              R=0.25D0*R*X2/(K*K)
              BI0=BI0+R
              IF (DABS(R/BI0).LT.1.0D-15) EXIT
           ENDDO
           BI1=1.0D0
           R=1.0D0
           DO K=1,50
              R=0.25D0*R*X2/(K*(K+1))
              BI1=BI1+R
              IF (DABS(R/BI1).LT.1.0D-15) EXIT
           ENDDO
           BI1=0.5D0*X*BI1
        ELSE
           DATA A/0.125D0,7.03125D-2,                 &
                  7.32421875D-2,1.1215209960938D-1,     &
                  2.2710800170898D-1,5.7250142097473D-1,     &
                  1.7277275025845D0,6.0740420012735D0,     &
                  2.4380529699556D01,1.1001714026925D02,     &
                  5.5133589612202D02,3.0380905109224D03/
           DATA B/-0.375D0,-1.171875D-1,               &
                  -1.025390625D-1,-1.4419555664063D-1,     &
                  -2.7757644653320D-1,-6.7659258842468D-1,     &
                  -1.9935317337513D0,-6.8839142681099D0,     &
                  -2.7248827311269D01,-1.2159789187654D02,     &
                  -6.0384407670507D02,-3.3022722944809D03/
           K0=12
           IF (X.GE.35.0) K0=9
           IF (X.GE.50.0) K0=7
           CA=DEXP(X)/DSQRT(2.0D0*PI*X)
           BI0=1.0D0
           XR=1.0D0/X
           DO K=1,K0
              BI0=BI0+A(K)*XR**K
           ENDDO
           BI0=CA*BI0
           BI1=1.0D0
           DO K=1,K0
              BI1=BI1+B(K)*XR**K
           ENDDO
           BI1=CA*BI1
        ENDIF
        IF (X.LE.9.0D0) THEN
           CT=-(DLOG(X/2.0D0)+EL)
           BK0=0.0D0
           W0=0.0D0
           R=1.0D0
           DO K=1,50
              W0=W0+1.0D0/K
              R=0.25D0*R/(K*K)*X2
              BK0=BK0+R*(W0+CT)
              IF (DABS((BK0-WW)/BK0).LT.1.0D-15) EXIT
              WW=BK0
           ENDDO
           BK0=BK0+CT
        ELSE
           DATA A1/0.125D0,0.2109375D0,                &
                   1.0986328125D0,1.1775970458984D01,     &
                   2.1461706161499D02,5.9511522710323D03,     &
                   2.3347645606175D05,1.2312234987631D07/
           CB=0.5D0/X
           XR2=1.0D0/X2
           BK0=1.0D0
           DO K=1,8
            BK0=BK0+A1(K)*XR2**K
           ENDDO
           BK0=CB*BK0/BI0
        ENDIF
        BK1=(1.0D0/X-BI1*BK0)/BI0

        RETURN
        END

!
!  ============================================================================
!        Purpose: Compute Bessel functions J0(x), J1(x), Y0(x),
!                 Y1(x), and their derivatives
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Parameters:
!        Input :  x   --- Argument of Jn(x) & Yn(x) ( x � 0 )
!        Output:  BJ0 --- J0(x)
!                 BJ1 --- J1(x)
!                 BY0 --- Y0(x)
!                 BY1 --- Y1(x)
!  ============================================================================
!
        SUBROUTINE JY01B(X,BJ0,BJ1,BY0,BY1)

        IMPLICIT NONE
        REAL*8 PI,X,BJ0,BY0,T,T2,A0,P0,Q0,TA0,BJ1,BY1,P1,Q1,TA1

        PI=3.141592653589793D0
        IF (X.EQ.0.0D0) THEN
           BJ0=1.0D0
           BJ1=0.0D0
           BY0=-1.0D+300
           BY1=-1.0D+300
           RETURN
        ELSE IF (X.LE.4.0D0) THEN
           T=X/4.0D0
           T2=T*T
           BJ0=((((((-.5014415D-3*T2+.76771853D-2)*T2-.0709253492D0)*T2+.4443584263D0)    &
                *T2-1.7777560599D0)*T2+3.9999973021D0)*T2-3.9999998721D0)*T2+1.0D0
           BJ1=T*(((((((-.1289769D-3*T2+.22069155D-2)*T2-.0236616773D0)*T2+.1777582922D0)  &
                *T2-.8888839649D0)*T2+2.6666660544D0)*T2-3.9999999710D0)*T2+1.9999999998D0)
           BY0=(((((((-.567433D-4*T2+.859977D-3)*T2-.94855882D-2)*T2+.0772975809D0)*T2-.4261737419D0)  &
               *T2+1.4216421221D0)*T2-2.3498519931D0)*T2+1.0766115157)*T2+.3674669052D0
           BY0=2.0D0/PI*DLOG(X/2.0D0)*BJ0+BY0
           BY1=((((((((.6535773D-3*T2-.0108175626D0)*T2+.107657606D0)*T2-.7268945577D0)*T2+3.1261399273D0)  &
               *T2-7.3980241381D0)*T2+6.8529236342D0)*T2+.3932562018D0)*T2-.6366197726D0)/X
           BY1=2.0D0/PI*DLOG(X/2.0D0)*BJ1+BY1
        ELSE
           T=4.0D0/X
           T2=T*T
           A0=DSQRT(2.0D0/(PI*X))
           P0=((((-.9285D-5*T2+.43506D-4)*T2-.122226D-3)*T2+.434725D-3)*T2-.4394275D-2)*T2+.999999997D0
           Q0=T*(((((.8099D-5*T2-.35614D-4)*T2+.85844D-4)*T2-.218024D-3)*T2+.1144106D-2)*T2-.031249995D0)
           TA0=X-.25D0*PI
           BJ0=A0*(P0*DCOS(TA0)-Q0*DSIN(TA0))
           BY0=A0*(P0*DSIN(TA0)+Q0*DCOS(TA0))
           P1=((((.10632D-4*T2-.50363D-4)*T2+.145575D-3)*T2-.559487D-3)*T2+.7323931D-2)*T2+1.000000004D0
           Q1=T*(((((-.9173D-5*T2+.40658D-4)*T2-.99941D-4)*T2+.266891D-3)*T2-.1601836D-2)*T2+.093749994D0)
           TA1=X-.75D0*PI
           BJ1=A0*(P1*DCOS(TA1)-Q1*DSIN(TA1))
           BY1=A0*(P1*DSIN(TA1)+Q1*DCOS(TA1))
        ENDIF

        RETURN
        END

!
!  ============================================================================
!        Purpose: Compute Bessel functions J0(x), J1(x), Y0(x),
!                 Y1(x), and their derivatives
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Description:
!     This is a derived version from the subroutine JY01B.
!
!   Parameters:
!        Input :  x   --- Argument of Jn(x) & Yn(x) ( x � 0 )
!        Output:  BJ0 --- J0(x)
!                 BJ1 --- J1(x)
!  ============================================================================
!
        SUBROUTINE JY01BJ(X,BJ0,BJ1)

        IMPLICIT NONE
        REAL*8 PI,X,BJ0,BJ1,T,T2,A0,P0,Q0,TA0,P1,Q1,TA1

        PI=3.141592653589793D0
        IF (X.EQ.0.0D0) THEN
           BJ0=1.0D0
           BJ1=0.0D0
           RETURN
        ELSE IF (X.LE.4.0D0) THEN
           T=X/4.0D0
           T2=T*T
           BJ0=((((((-.5014415D-3*T2+.76771853D-2)*T2-.0709253492D0)*T2+.4443584263D0)    &
               *T2-1.7777560599D0)*T2+3.9999973021D0)*T2-3.9999998721D0)*T2+1.0D0
           BJ1=T*(((((((-.1289769D-3*T2+.22069155D-2)*T2-.0236616773D0)*T2+.1777582922D0)   &
               *T2-.8888839649D0)*T2+2.6666660544D0)*T2-3.9999999710D0)*T2+1.9999999998D0)
        ELSE
           T=4.0D0/X
           T2=T*T
           A0=DSQRT(2.0D0/(PI*X))
           P0=((((-.9285D-5*T2+.43506D-4)*T2-.122226D-3)*T2+.434725D-3)*T2-.4394275D-2)*T2+.999999997D0
           Q0=T*(((((.8099D-5*T2-.35614D-4)*T2+.85844D-4)*T2-.218024D-3)*T2+.1144106D-2)*T2-.031249995D0)
           TA0=X-.25D0*PI
           BJ0=A0*(P0*DCOS(TA0)-Q0*DSIN(TA0))
           P1=((((.10632D-4*T2-.50363D-4)*T2+.145575D-3)*T2-.559487D-3)*T2+.7323931D-2)*T2+1.000000004D0
           Q1=T*(((((-.9173D-5*T2+.40658D-4)*T2-.99941D-4)*T2+.266891D-3)*T2-.1601836D-2)*T2+.093749994D0)
           TA1=X-.75D0*PI
           BJ1=A0*(P1*DCOS(TA1)-Q1*DSIN(TA1))
        ENDIF

        RETURN
        END

!
!  ============================================================================
!        Purpose: Compute Bessel functions J0(x), J1(x), Y0(x),
!                 Y1(x), and their derivatives
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Description:
!     This is a derived version from the subroutine JY01B.
!
!   Parameters:
!        Input :  x   --- Argument of Jn(x) & Yn(x) ( x � 0 )
!        Output:  BJ0 --- J0(x)
!                 BJ1 --- J1(x)
!                 BY0 --- Y0(x)
!                 BY1 --- Y1(x)
!  ============================================================================
!
        SUBROUTINE JY01BY0(X,BY0)

        IMPLICIT NONE
        REAL*8 PI,X,BJ0,BY0,T,T2,A0,P0,Q0,TA0

        PI=3.141592653589793D0
        IF (X.EQ.0.0D0) THEN
           BJ0=1.0D0
           BY0=-1.0D+300
           RETURN
        ELSE IF (X.LE.4.0D0) THEN
           T=X/4.0D0
           T2=T*T
           BJ0=((((((-.5014415D-3*T2+.76771853D-2)*T2-.0709253492D0)*T2+.4443584263D0)   &
               *T2-1.7777560599D0)*T2+3.9999973021D0)*T2-3.9999998721D0)*T2+1.0D0
           BY0=(((((((-.567433D-4*T2+.859977D-3)*T2-.94855882D-2)*T2+.0772975809D0)*T2    &
                -.4261737419D0)*T2+1.4216421221D0)*T2-2.3498519931D0)*T2+1.0766115157)*T2+.3674669052D0
           BY0=2.0D0/PI*DLOG(X/2.0D0)*BJ0+BY0
        ELSE
           T=4.0D0/X
           T2=T*T
           A0=DSQRT(2.0D0/(PI*X))
           P0=((((-.9285D-5*T2+.43506D-4)*T2-.122226D-3)*T2+.434725D-3)*T2-.4394275D-2)*T2+.999999997D0
           Q0=T*(((((.8099D-5*T2-.35614D-4)*T2+.85844D-4)*T2-.218024D-3)*T2+.1144106D-2)*T2-.031249995D0)
           TA0=X-.25D0*PI
           BY0=A0*(P0*DSIN(TA0)+Q0*DCOS(TA0))
        ENDIF

        RETURN
        END

!
!  ============================================================================
!        Purpose: Compute Bessel functions J0(x), J1(x), Y0(x),
!                 Y1(x), and their derivatives
!   License:
!
!     This routine is copyrighted by Shanjie Zhang and Jianming Jin.  However,
!     they give permission to incorporate this routine into a user program
!     provided that the copyright is acknowledged.
!
!   Author:
!
!     Shanjie Zhang, Jianming Jin
!
!   Reference:
!
!     Shanjie Zhang, Jianming Jin,
!     Computation of Special Functions,
!     Wiley, 1996,
!     ISBN: 0-471-11963-6,
!     LC: QA351.C45.
!
!   Modified on:
!     25 July 2017, by Yingyi Liu
!
!   Description:
!     This is a derived version from the subroutine JY01B.
!
!   Parameters:
!        Input :  x   --- Argument of Jn(x) & Yn(x) ( x � 0 )
!        Output:  BY1 --- Y1(x)
!  ============================================================================
!
        SUBROUTINE JY01BY1(X,BY1)

        IMPLICIT NONE
        REAL*8 PI,X,BJ1,BY1,T,T2,A0,P1,Q1,TA1

        PI=3.141592653589793D0
        IF (X.EQ.0.0D0) THEN
           BJ1=0.0D0
           BY1=-1.0D+300
           RETURN
        ELSE IF (X.LE.4.0D0) THEN
           T=X/4.0D0
           T2=T*T
           BJ1=T*(((((((-.1289769D-3*T2+.22069155D-2)*T2-.0236616773D0)*T2+.1777582922D0)   &
               *T2-.8888839649D0)*T2+2.6666660544D0)*T2-3.9999999710D0)*T2+1.9999999998D0)
           BY1=((((((((.6535773D-3*T2-.0108175626D0)*T2+.107657606D0)*T2-.7268945577D0)*T2+3.1261399273D0)    &
                *T2-7.3980241381D0)*T2+6.8529236342D0)*T2+.3932562018D0)*T2-.6366197726D0)/X
           BY1=2.0D0/PI*DLOG(X/2.0D0)*BJ1+BY1
        ELSE
           T=4.0D0/X
           T2=T*T
           A0=DSQRT(2.0D0/(PI*X))
           P1=((((.10632D-4*T2-.50363D-4)*T2+.145575D-3)*T2-.559487D-3)*T2+.7323931D-2)*T2+1.000000004D0
           Q1=T*(((((-.9173D-5*T2+.40658D-4)*T2-.99941D-4)*T2+.266891D-3)*T2-.1601836D-2)*T2+.093749994D0)
           TA1=X-.75D0*PI
           BY1=A0*(P1*DSIN(TA1)+Q1*DCOS(TA1))
        ENDIF

        RETURN
        END

  end module fingreen3D_module

MODULE MATRICES

  USE ieee_arithmetic
  USE FLOATING_POINT_PRECISION, ONLY: PRE
  USE CONSTANTS

  USE GREEN_RANKINE
  USE GREEN_WAVE

  IMPLICIT NONE

CONTAINS

  ! =====================================================================

  PURE LOGICAL FUNCTION is_infinity(x)
    REAL(KIND=PRE), INTENT(IN) :: x
    is_infinity = (.NOT. ieee_is_finite(x))
  END FUNCTION

  ! =====================================================================

  SUBROUTINE BUILD_MATRICES(                          &
      nb_faces_1, centers_1, normals_1,               &
      nb_vertices_2, nb_faces_2, vertices_2, faces_2, &
      centers_2, normals_2, areas_2, radiuses_2,      &
      nb_quad_points, quad_points, quad_weights,      &
      wavenumber, depth,                              &
      coeffs,                                         &
      tabulation_method, tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      NEXP, AMBDA, AR,                                &
      same_body, adjoint_double_layer,                &
      S, K)

    ! Mesh data
    INTEGER,                                     INTENT(IN) :: nb_faces_1, nb_faces_2, nb_vertices_2
    REAL(KIND=PRE), DIMENSION(nb_faces_1, 3),    INTENT(IN) :: centers_1, normals_1
    REAL(KIND=PRE), DIMENSION(nb_vertices_2, 3), INTENT(IN) :: vertices_2
    INTEGER,        DIMENSION(nb_faces_2, 4),    INTENT(IN) :: faces_2
    REAL(KIND=PRE), DIMENSION(nb_faces_2, 3),    INTENT(IN) :: centers_2, normals_2
    REAL(KIND=PRE), DIMENSION(nb_faces_2),       INTENT(IN) :: areas_2, radiuses_2

    INTEGER,                                                  INTENT(IN) :: nb_quad_points
    REAL(KIND=PRE), DIMENSION(nb_faces_2, nb_quad_points, 3), INTENT(IN) :: quad_points
    REAL(KIND=PRE), DIMENSION(nb_faces_2, nb_quad_points),    INTENT(IN) :: quad_weights
    LOGICAL,                                  INTENT(IN) :: adjoint_double_layer

    LOGICAL,                                  INTENT(IN) :: same_body

    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber, depth

    REAL(KIND=PRE), DIMENSION(3)                         :: coeffs

    ! Tabulated data
    INTEGER,                                  INTENT(IN) :: tabulation_method
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_r_range
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_z_range
    REAL(KIND=PRE), DIMENSION(:, :, :, :),    INTENT(IN) :: tabulated_integrals

    ! Prony decomposition for finite depth
    INTEGER,                                  INTENT(IN) :: NEXP
    REAL(KIND=PRE), DIMENSION(NEXP),          INTENT(IN) :: AMBDA, AR

    ! Output
    COMPLEX(KIND=PRE), DIMENSION(:, :), INTENT(INOUT) :: S
    COMPLEX(KIND=PRE), DIMENSION(:, :, :), INTENT(INOUT) :: K

    ! Local variables
    INTEGER                         :: I, J, Q
    REAL(KIND=PRE), DIMENSION(3)    :: reflected_centers_1_I, reflected_VSP1
    REAL(KIND=PRE)                  :: SP1
    REAL(KIND=PRE), DIMENSION(3)    :: VSP1
    COMPLEX(KIND=PRE)               :: SP2
    COMPLEX(KIND=PRE), DIMENSION(3) :: VSP2_SYM, VSP2_ANTISYM
    LOGICAL :: use_symmetry_of_wave_part

    use_symmetry_of_wave_part = ((SAME_BODY) .AND. (nb_quad_points == 1))


#ifndef XIE_CORRECTION
    IF (is_infinity(depth)) THEN
      ! In infinite depth, for finite frequency,
      ! the original Delhommeau's method as in Nemoh uses coeffs(2) = -1.
      ! But by default, coeffs(2) is set to 1 in delhommeau.py.
      coeffs(2) = coeffs(2) - 2*coeffs(3)
    ENDIF
#endif

    coeffs(:) = coeffs(:)/(4*PI)


    !$OMP PARALLEL DO SCHEDULE(DYNAMIC) &
    !$OMP&  PRIVATE(J, I, SP1, VSP1, SP2, VSP2_SYM, VSP2_ANTISYM, reflected_centers_1_I, reflected_VSP1)
    DO J = 1, nb_faces_2

      !!!!!!!!!!!!!!!!!!!!
      !  Initialization  !
      !!!!!!!!!!!!!!!!!!!!
      S(:, J) = CMPLX(0.0, 0.0, KIND=PRE)
      K(:, J, :) = CMPLX(0.0, 0.0, KIND=PRE)

      !!!!!!!!!!!!!!!!!!
      !  Rankine part  !
      !!!!!!!!!!!!!!!!!!
      IF (coeffs(1) .NE. ZERO) THEN
        DO I = 1, nb_faces_1

          CALL COMPUTE_INTEGRAL_OF_RANKINE_SOURCE( &
            centers_1(I, :),                       &
            vertices_2(faces_2(J, :), :),          &
            centers_2(J, :),                       &
            normals_2(J, :),                       &
            areas_2(J),                            &
            radiuses_2(J),                         &
            SP1, VSP1                              &
            )

          ! Change the gradient terms to direct solver representation
          IF (.NOT. adjoint_double_layer) THEN
            VSP1(:) = -VSP1(:)
          END IF

          ! Store into influence matrix
          S(I, J) = S(I, J) - coeffs(1) * SP1                                ! Green function
          if (size(K, 3) == 1) then
            if (.NOT. adjoint_double_layer) then
              K(I, J, 1) = K(I, J, 1) - coeffs(1) * DOT_PRODUCT(normals_2(J, :), VSP1(:))
            else
              K(I, J, 1) = K(I, J, 1) - coeffs(1) * DOT_PRODUCT(normals_1(I, :), VSP1(:))
            endif
          else
            K(I, J, :) = K(I, J, :) - coeffs(1) * VSP1(:)
          endif

        END DO
      END IF


      !!!!!!!!!!!!!!!!!!!!!!!!!!!!
      !  Reflected Rankine part  !
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!

      IF (coeffs(2) .NE. ZERO) THEN
        DO I = 1, nb_faces_1

          IF (is_infinity(depth)) THEN
            ! Reflection through free surface
            reflected_centers_1_I(1:2) = centers_1(I, 1:2)
            reflected_centers_1_I(3)   = -centers_1(I, 3)
          ELSE
            ! Reflection through sea bottom
            reflected_centers_1_I(1:2) = centers_1(I, 1:2)
            reflected_centers_1_I(3)   = -centers_1(I, 3) - 2*depth
          END IF

          CALL COMPUTE_INTEGRAL_OF_RANKINE_SOURCE( &
            reflected_centers_1_I(:),                &
            vertices_2(faces_2(J, :), :),          &
            centers_2(J, :),                       &
            normals_2(J, :),                       &
            areas_2(J),                            &
            radiuses_2(J),                         &
            SP1, VSP1                              &
            )

          reflected_VSP1(1:2) = VSP1(1:2)
          reflected_VSP1(3) = -VSP1(3)

          ! Change the gradient terms to direct solver representation
          if (.NOT. adjoint_double_layer) THEN
             reflected_VSP1(1:2) = -reflected_VSP1(1:2)
          END IF

          ! Store into influence matrix
          S(I, J) = S(I, J) - coeffs(2) * SP1                                ! Green function
          if (size(K, 3) == 1) then
            if (.NOT. adjoint_double_layer) then
              K(I, J, 1) = K(I, J, 1) - coeffs(2) * DOT_PRODUCT(normals_2(J, :), reflected_VSP1(:))
            else
              K(I, J, 1) = K(I, J, 1) - coeffs(2) * DOT_PRODUCT(normals_1(I, :), reflected_VSP1(:))
            endif
          else
            K(I, J, :) = K(I, J, :) - coeffs(2) * reflected_VSP1(:)
          endif
        END DO
      END IF

      !!!!!!!!!!!!!!!
      !  Wave part  !
      !!!!!!!!!!!!!!!

      IF ((coeffs(3) .NE. ZERO) .AND. (.NOT. use_symmetry_of_wave_part)) THEN
        DO I = 1, nb_faces_1
          DO Q = 1, nb_quad_points
            IF (is_infinity(depth)) THEN
              CALL WAVE_PART_INFINITE_DEPTH &
                (centers_1(I, :),           &
                quad_points(J, Q, :),       & ! centers_2(J, :),
                wavenumber,                 &
                tabulation_method, tabulated_r_range, tabulated_z_range, tabulated_integrals, &
                SP2, VSP2_SYM, VSP2_ANTISYM &
                )
            ELSE
              CALL WAVE_PART_FINITE_DEPTH   &
                (centers_1(I, :),           &
                quad_points(J, Q, :),       & ! centers_2(J, :),
                wavenumber,                 &
                depth,                      &
                tabulation_method, tabulated_r_range, tabulated_z_range, tabulated_integrals, &
                NEXP, AMBDA, AR,            &
                SP2, VSP2_SYM, VSP2_ANTISYM &
                )
            END IF

           ! Change the gradient terms to direct solver representation
            IF (.NOT. adjoint_double_layer) THEN
              VSP2_ANTISYM = -VSP2_ANTISYM
            END IF

            S(I, J) = S(I, J) - coeffs(3) * SP2 * quad_weights(J, Q)

            if (size(K, 3) == 1) then
              if (.NOT. adjoint_double_layer) then
                K(I, J, 1) = K(I, J, 1) - coeffs(3) * &
                  DOT_PRODUCT(normals_2(J, :), VSP2_SYM + VSP2_ANTISYM) * quad_weights(J, Q)
              else
                K(I, J, 1) = K(I, J, 1) - coeffs(3) * &
                  DOT_PRODUCT(normals_1(I, :), VSP2_SYM + VSP2_ANTISYM) * quad_weights(J, Q)
              endif
            else
              K(I, J, :) = K(I, J, :) - coeffs(3) * (VSP2_SYM + VSP2_ANTISYM) * quad_weights(J, Q)
            endif

          END DO
        END DO
      END IF

      IF (SAME_BODY) THEN
        if (size(K, 3) == 1) then
          K(J, J, 1) = K(J, J, 1) + 0.5
        else
          if (.NOT. adjoint_double_layer) then
            K(J, J, :) = K(J, J, :) + 0.5 * normals_2(J, :)
          else
            K(J, J, :) = K(J, J, :) + 0.5 * normals_1(J, :)
          endif
        endif
      END IF

    END DO  ! parallelized loop on J


    IF ((coeffs(3) .NE. ZERO) .AND. use_symmetry_of_wave_part) THEN
      ! If we are computing the influence of some cells upon themselves, the resulting matrices have some symmetries.
      ! This is due to the symmetry of the Green function, and the way the integral on the face is approximated.
      ! (More precisely, the Green function is symmetric and its derivative is the sum of a symmetric part and an anti-symmetric
      ! part.)

      !$OMP PARALLEL DO SCHEDULE(DYNAMIC) PRIVATE(J, I, SP2, VSP2_SYM, VSP2_ANTISYM)
      DO J = 1, nb_faces_2
        DO I = J, nb_faces_1
          IF (is_infinity(depth)) THEN
            CALL WAVE_PART_INFINITE_DEPTH &
              (centers_1(I, :),           &
              quad_points(J, 1, :),       & ! centers_2(J, :),
              wavenumber,                 &
              tabulation_method, tabulated_r_range, tabulated_z_range, tabulated_integrals, &
              SP2, VSP2_SYM, VSP2_ANTISYM &
              )
          ELSE
            CALL WAVE_PART_FINITE_DEPTH   &
              (centers_1(I, :),           &
              quad_points(J, 1, :),       & ! centers_2(J, :),
              wavenumber,                 &
              depth,                      &
              tabulation_method, tabulated_r_range, tabulated_z_range, tabulated_integrals, &
              NEXP, AMBDA, AR,            &
              SP2, VSP2_SYM, VSP2_ANTISYM &
              )
          END IF

          ! Change the gradient terms to direct solver representation
          IF (.NOT. adjoint_double_layer) THEN
            VSP2_ANTISYM = -VSP2_ANTISYM
          END IF

          S(I, J) = S(I, J) - coeffs(3) * SP2 * quad_weights(J, 1)
          if (size(K, 3) == 1) then
            if (.NOT. adjoint_double_layer) then
              K(I, J, 1) = K(I, J, 1) - coeffs(3) * &
                DOT_PRODUCT(normals_2(J, :), VSP2_SYM + VSP2_ANTISYM) * quad_weights(J, 1)
            else
              K(I, J, 1) = K(I, J, 1) - coeffs(3) * &
                DOT_PRODUCT(normals_1(I, :), VSP2_SYM + VSP2_ANTISYM) * quad_weights(J, 1)
            endif
          else
            K(I, J, :) = K(I, J, :) - coeffs(3) * (VSP2_SYM + VSP2_ANTISYM) * quad_weights(J, 1)
          endif

          IF (.NOT. I==J) THEN
            S(J, I) = S(J, I) - coeffs(3) * SP2 * quad_weights(I, 1)
            if (size(K, 3) == 1) then
              if (.NOT. adjoint_double_layer) then
                K(J, I, 1) = K(J, I, 1) - coeffs(3) * &
                  DOT_PRODUCT(normals_2(I, :), VSP2_SYM - VSP2_ANTISYM) * quad_weights(I, 1)
              else
                K(J, I, 1) = K(J, I, 1) - coeffs(3) * &
                  DOT_PRODUCT(normals_1(J, :), VSP2_SYM - VSP2_ANTISYM) * quad_weights(I, 1)
              endif
            else
              K(J, I, :) = K(J, I, :) - coeffs(3) * (VSP2_SYM - VSP2_ANTISYM) * quad_weights(I, 1)
            endif
          END IF
        END DO
      END DO
    END IF

  END SUBROUTINE

END MODULE MATRICES

program benchmark_tabulation

use constants, only: pre  ! Floating point precision
use delhommeau_integrals

implicit none

integer, parameter :: n_tabulation = 4
integer, parameter :: n_samples = 1000
integer :: i_sample
integer :: i_tabulation
integer, dimension(n_tabulation) :: tabulation_nr
integer, dimension(n_tabulation) :: tabulation_nz

integer(kind=8) :: starting_time, final_time, clock_rate, clock_rate_in_ns

real(kind=pre), dimension(:), allocatable          :: r, z, tabulated_r, tabulated_z
real(kind=pre), dimension(:, :, :, :), allocatable :: tabulated_integrals
real(kind=pre), dimension(:, :, :), allocatable    :: integrals

print*, "-- Run libdelhommeau/benchmark/tabulations/benchmark_tabulation.f90"

call system_clock(count_rate=clock_rate)
clock_rate_in_ns = clock_rate / 1000000000

allocate(r(n_samples))
allocate(z(n_samples))
allocate(integrals(n_samples, 2, 2))

call random_number(r)
r = 100*r

call random_number(z)
z = -10*z


call system_clock(starting_time)
do i_sample = 1, n_samples
    integrals(i_sample, :, :) = numerical_integration(r(i_sample), z(i_sample), 2500)
enddo
call system_clock(final_time)
print*, "Integration (fine)  :", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"


call system_clock(starting_time)
do i_sample = 1, n_samples
    integrals(i_sample, :, :) = numerical_integration(r(i_sample), z(i_sample), 251)
enddo
call system_clock(final_time)
print*, "Integration (coarse):", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"


tabulation_nr = [32, 328, 656, 656]
tabulation_nz = [4, 48, 92, 184]

do i_tabulation = 1, n_tabulation

  allocate(tabulated_r(tabulation_nr(i_tabulation)))
  allocate(tabulated_z(tabulation_nz(i_tabulation)))
  allocate(tabulated_integrals(tabulation_nr(i_tabulation), tabulation_nz(i_tabulation), 2, 2))

  tabulated_r(:) = default_r_spacing(tabulation_nr(i_tabulation))
  tabulated_z(:) = default_z_spacing(tabulation_nz(i_tabulation))
  tabulated_integrals(:, :, :, :) = construct_tabulation(tabulated_r, tabulated_z, 251)

  call system_clock(starting_time)
  do i_sample = 1, n_samples
      integrals(i_sample, :, :) = pick_in_default_tabulation(r(i_sample), z(i_sample), &
        tabulated_r, tabulated_z, tabulated_integrals)
  enddo
  call system_clock(final_time)
  print*, "Interpolate         :", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"

  deallocate(tabulated_r, tabulated_z, tabulated_integrals)

enddo


call system_clock(starting_time)
do i_sample = 1, n_samples
    integrals(i_sample, :, :) = asymptotic_approximations(r(i_sample), z(i_sample))
enddo
call system_clock(final_time)
print*, "Asymptotic          :", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"


end program

! Copyright (C) 2017-2024 Matthieu Ancellin
! See LICENSE file at <https://github.com/capytaine/libDelhommeau>

module matrices

  use floating_point_precision, only: pre
  use constants

  use green_Rankine
  use green_wave

  implicit none

contains

  ! =====================================================================

  subroutine build_matrices(                                          &
      nb_collocation_points, collocation_points, dot_product_normals, &
      nb_vertices, nb_faces, vertices, faces,                         &
      centers, normals, areas, radiuses,                              &
      nb_quad_points, quad_points, quad_weights,                      &
      wavenumber, depth,                                              &
      tabulation_nb_integration_points,                               &
      tabulation_grid_shape,                                          &
      tabulated_r_range, tabulated_z_range,                           &
      tabulated_integrals,                                            &
      finite_depth_method, prony_decomposition, dispersion_roots,     &
      gf_singularities, adjoint_double_layer,                         &
      S, K)

    ! Mesh data
    integer,                                              intent(in) :: nb_collocation_points
    real(kind=pre), dimension(nb_collocation_points, 3),  intent(in) :: collocation_points
    real(kind=pre), dimension(:, :),           intent(in) :: dot_product_normals
    ! If adjoint_double_layer:     size(dot_product_normals) == (nb_collocation_points, 3)
    ! If not adjoint_double_layer: size(dot_product_normals) == (nb_faces, 3)

    ! dot_product_normals might be identical to normals, especially when adjoint_double_layer is False.
    ! The former is used when computing the dot product with the normal vector in the double layer or adjoint double layer operator
    ! (D or K matrices). The latter is only used when computing the exact formula to integrate the Rankine part of the Green
    ! function over a face.
    ! Hence, both variables fulfill different role, and may or may not be identical.

    integer, intent(in)                                   :: nb_vertices, nb_faces
    real(kind=pre), dimension(nb_vertices, 3), intent(in) :: vertices
    integer,        dimension(nb_faces, 4),    intent(in) :: faces
    real(kind=pre), dimension(nb_faces, 3),    intent(in) :: centers, normals
    real(kind=pre), dimension(nb_faces),       intent(in) :: areas, radiuses
    integer,                                                intent(in) :: nb_quad_points
    real(kind=pre), dimension(nb_faces, nb_quad_points, 3), intent(in) :: quad_points
    real(kind=pre), dimension(nb_faces, nb_quad_points),    intent(in) :: quad_weights

    ! Solver parameters
    integer,                                  intent(in) :: gf_singularities
    logical,                                  intent(in) :: adjoint_double_layer

    real(kind=pre),                           intent(in) :: wavenumber, depth

    ! Tabulated values for the wave part of the Green function
    integer,                                  intent(in) :: tabulation_grid_shape
    integer,                                  intent(in) :: tabulation_nb_integration_points
    real(kind=pre), dimension(:),             intent(in) :: tabulated_r_range
    real(kind=pre), dimension(:),             intent(in) :: tabulated_z_range
    real(kind=pre), dimension(:, :, :),       intent(in) :: tabulated_integrals

    integer,                                  intent(in) :: finite_depth_method
    real(kind=pre), dimension(:, :),          intent(in) :: prony_decomposition  ! For Delhommeau's finite depth, dummy otherwise
    real(kind=pre), dimension(:),             intent(in) :: dispersion_roots  ! For FinGreen3D, dummy otherwise

    ! Outputs
    complex(kind=pre), dimension(:, :),    intent(inout) :: S
    complex(kind=pre), dimension(:, :, :), intent(inout) :: K

    ! Local variables
    integer                         :: I, J
    real(kind=pre)                  :: sign_reflected_Rankine
    real(kind=pre)                  :: int_G_rankine, diagonal_coef
    real(kind=pre), dimension(3)    :: int_nablaG_rankine
    complex(kind=pre)               :: int_G, int_G_wave
    complex(kind=pre), dimension(3) :: int_nablaG, int_nablaG_wave
    logical :: derivative_with_respect_to_first_variable, finite_depth, finite_wavenumber

    derivative_with_respect_to_first_variable = adjoint_double_layer
    ! When computing the adjoint double layer operator (K), the derivative of the Green function is computed with respect to its
    ! first variable (field point, often written x, or sometimes M in this code).
    ! When computing the double layer operator (D), the derivative of the Green function is computed with respect to its second
    ! variable (source point, often written xi, or sometimes M' in this code).

    finite_depth = (.not. is_infinity(depth))

    finite_wavenumber = ((ZERO < wavenumber) .and. (.not. is_infinity(wavenumber)))

    if (gf_singularities == HIGH_FREQ) then
      sign_reflected_Rankine = -ONE
    else
      sign_reflected_Rankine = +ONE
    endif

    !$OMP PARALLEL DO SCHEDULE(DYNAMIC) &
    !$OMP&  PRIVATE(J, I, int_G, int_nablaG, int_G_Rankine, int_nablaG_Rankine, diagonal_coef, &
    !$OMP&          int_G_wave, int_nablaG_wave)
    do J = 1, nb_faces
      do I = 1, nb_collocation_points

        int_G = CZERO
        int_nablaG = CZERO

        !!!!!!!!!!!!!!!!!!
        !  Rankine part  !
        !!!!!!!!!!!!!!!!!!
        call integral_of_Rankine(                    &
          collocation_points(I, :),                  &
          vertices(faces(J, :), :),                  &
          centers(J, :),                             &
          normals(J, :),                             &
          areas(J),                                  &
          radiuses(J),                               &
          derivative_with_respect_to_first_variable, &
          int_G_Rankine, int_nablaG_Rankine          &
          )

        int_G = int_G + int_G_Rankine
        int_nablaG(:) = int_nablaG(:) + int_nablaG_Rankine(:)
        ! Not sign_reflected_Rankine!
        ! The sign of this term does not change in the high frequency limit.

        !!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !  Reflected Rankine part  !
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!
        if (finite_depth .and. (finite_depth_method == LEGACY_FINITE_DEPTH)) then
          ! Reproduce behavior of legacy finite depth method
          call one_point_integral_of_reflected_Rankine( &
            collocation_points(I, :),                   &
            centers(J, :),                              &
            areas(J),                                   &
            derivative_with_respect_to_first_variable,  &
            [-ONE, ZERO],                               &
            int_G_Rankine,                              &
            int_nablaG_Rankine                          &
          )
        else
          call integral_of_reflected_Rankine(          &
            collocation_points(I, :),                  &
            vertices(faces(J, :), :),                  &
            centers(J, :),                             &
            normals(J, :),                             &
            areas(J),                                  &
            radiuses(J),                               &
            derivative_with_respect_to_first_variable, &
            [-ONE, ZERO],                              &
            int_G_Rankine,                             &
            int_nablaG_Rankine                         &
            )
        endif
        int_G = int_G + sign_reflected_Rankine * int_G_Rankine
        int_nablaG(:) = int_nablaG(:) + sign_reflected_Rankine * int_nablaG_Rankine(:)

        if (gf_singularities == LOW_FREQ_WITH_RANKINE_PART) then
          int_nablaG(3) = int_nablaG(3) + 2*wavenumber * int_G_Rankine
        endif

        if (.not. finite_depth) then

          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          !  Infinite depth wave part  !
          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          if (finite_wavenumber) then
            call integral_of_wave_part_infinite_depth                    &
              (collocation_points(I, :),                                 &
              centers(J, :), areas(J),                                   &
              quad_points(J, :, :), quad_weights(J, :),                  &
              wavenumber,                                                &
              tabulation_nb_integration_points, tabulation_grid_shape,   &
              tabulated_r_range, tabulated_z_range, tabulated_integrals, &
              gf_singularities,                                          &
              derivative_with_respect_to_first_variable,                 &
              int_G_wave, int_nablaG_wave                                &
              )
              int_G = int_G + int_G_wave
              int_nablaG(:) = int_nablaG(:) + int_nablaG_wave(:)
          ! else zero, assuming gf_singularities has been set up correctly, that is
          ! low_freq for wavenumber = 0 and high_freq for wavenumber = inf
          endif

        else  ! Finite depth

          !!!!!!!!!!!!!!!!!!!!!!!!!!
          !  FinGreen3D wave part  !
          !!!!!!!!!!!!!!!!!!!!!!!!!!
          if (finite_depth_method == FINGREEN3D_METHOD) then
            call integral_of_wave_part_fingreen3D                 &
              (collocation_points(I, :),                          &
              quad_points(J, :, :), quad_weights(J, :),           &
              wavenumber, depth, dispersion_roots,                &
              derivative_with_respect_to_first_variable,          &
              int_G_wave, int_nablaG_wave                         &
              )
              int_G = int_G + int_G_wave
              int_nablaG(:) = int_nablaG(:) + int_nablaG_wave(:)

          else  ! Delhommeau's finite depth method

            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            !  Supplementary Rankine parts in finite depth  !
            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            ! 1. Reflection through sea bottom
            call integral_of_reflected_Rankine(          &
              collocation_points(I, :),                  &
              vertices(faces(J, :), :),                  &
              centers(J, :),                             &
              normals(J, :),                             &
              areas(J),                                  &
              radiuses(J),                               &
              derivative_with_respect_to_first_variable, &
              [-ONE, -2*depth],                          &
              int_G_Rankine, int_nablaG_Rankine          &
              )
            int_G = int_G + int_G_Rankine
            int_nablaG(:) = int_nablaG(:) + int_nablaG_Rankine(:)
            ! Not sign_reflected_Rankine!
            ! The sign of this term does not change in the high frequency limit.

            ! 2. Reflection through sea bottom and free surface
            call one_point_integral_of_reflected_Rankine( &
              collocation_points(I, :),                   &
              centers(J, :),                              &
              areas(J),                                   &
              derivative_with_respect_to_first_variable,  &
              [ONE, -2*depth],                            &
              int_G_Rankine, int_nablaG_Rankine           &
              )
            int_G = int_G + sign_reflected_Rankine * int_G_Rankine
            int_nablaG(:) = int_nablaG(:) + sign_reflected_Rankine * int_nablaG_Rankine(:)

            ! 3. Reflection through free surface and sea bottom
            call one_point_integral_of_reflected_Rankine( &
              collocation_points(I, :),                   &
              centers(J, :),                              &
              areas(J),                                   &
              derivative_with_respect_to_first_variable,  &
              [ONE, 2*depth],                             &
              int_G_Rankine, int_nablaG_Rankine           &
              )
            int_G = int_G + sign_reflected_Rankine * int_G_Rankine
            int_nablaG(:) = int_nablaG(:) + sign_reflected_Rankine * int_nablaG_Rankine(:)

            ! 4. Reflection through sea bottom and free surface and sea bottom again
            call one_point_integral_of_reflected_rankine( &
              collocation_points(I, :),                   &
              centers(J, :),                              &
              areas(J),                                   &
              derivative_with_respect_to_first_variable,  &
              [-ONE, -4*depth],                           &
              int_G_Rankine, int_nablaG_Rankine           &
              )
            int_G = int_G + sign_reflected_Rankine * int_G_Rankine
            int_nablaG(:) = int_nablaG(:) + sign_reflected_Rankine * int_nablaG_Rankine(:)

            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            !  Delhommeau's finite depth wave term  !
            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            if (finite_wavenumber) then
              call integral_of_wave_parts_finite_depth                     &
                (collocation_points(I, :),                                 &
                centers(J, :), areas(J),                                   &
                quad_points(J, :, :), quad_weights(J, :),                  &
                wavenumber, depth,                                         &
                tabulation_nb_integration_points, tabulation_grid_shape,   &
                tabulated_r_range, tabulated_z_range, tabulated_integrals, &
                gf_singularities,                                          &
                derivative_with_respect_to_first_variable,                 &
                int_G_wave, int_nablaG_wave                                &
                )
              int_G = int_G + int_G_wave
              int_nablaG(:) = int_nablaG(:) + int_nablaG_wave(:)
            ! else zero, assuming gf_singularities has been set up correctly, that is
            ! low_freq for wavenumber = 0 and high_freq for wavenumber = inf
            endif

            call integral_of_prony_decomp_finite_depth        &
              (collocation_points(I, :),                      &
              vertices(faces(J, :), :),                       &
              centers(J, :),                                  &
              normals(J, :),                                  &
              areas(J),                                       &
              radiuses(J),                                    &
              depth,                                          &
              prony_decomposition,                            &
              derivative_with_respect_to_first_variable,      &
              int_G_wave, int_nablaG_wave                     &
              )
            int_G = int_G + int_G_wave
            int_nablaG(:) = int_nablaG(:) + int_nablaG_wave(:)
          endif  ! if Delhommeau's finite depth
        endif  ! if finite depth

        !!!!!!!!!!!!!!!!!!!
        !  Add to matrix  !
        !!!!!!!!!!!!!!!!!!!
        S(I, J) = MINUS_ONE_OVER_FOURPI * int_G

        if (size(K, 3) == 1) then  ! early_dot_product=True
          if (adjoint_double_layer) then
            K(I, J, 1) = MINUS_ONE_OVER_FOURPI * DOT_PRODUCT(dot_product_normals(I, :), int_nablaG(:))
          else
            K(I, J, 1) = MINUS_ONE_OVER_FOURPI * DOT_PRODUCT(dot_product_normals(J, :), int_nablaG(:))
          endif
        else
          K(I, J, :) = MINUS_ONE_OVER_FOURPI * int_nablaG(:)
        endif

      end do  ! loop on I
    end do  ! parallelized loop on J
  end subroutine

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine add_diagonal_term(                               &
      nb_faces, centers, dot_product_normals, free_surface, K &
      )

    integer, intent(in)                                :: nb_faces
    real(kind=pre), dimension(nb_faces, 3), intent(in) :: centers
    real(kind=pre), dimension(nb_faces, 3), intent(in) :: dot_product_normals
    real(kind=pre),                         intent(in) :: free_surface
    complex(kind=pre), dimension(:, :, :),  intent(inout) :: K

    ! Local variables
    integer        :: i
    real(kind=pre) :: diagonal_coef

    !$OMP PARALLEL DO PRIVATE(i, diagonal_coef)
    do i = 1, nb_faces
      if (abs(centers(i, 3) - free_surface) < 1e-8) then  ! Panel on the free surface
        diagonal_coef = ONE
      else
        diagonal_coef = ONE/2
      endif

      if (size(K, 3) == 1) then  ! early_dot_product=True
        K(i, i, 1) = K(i, i, 1) + diagonal_coef
      else
        K(i, i, :) = K(i, i, :) + diagonal_coef * dot_product_normals(i, :)
        ! if (.not. adjoint_double_layer) then we should have used the jth normal instead of the i-th,
        ! such that later the dot product with dot_product_normals(j, :) gives 1.
        ! Except that on the diagonal, i==j, so there is no need to branch based on adjoint_double_layer.
      endif
    enddo

  end subroutine

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  subroutine add_rankine_term_only(                                   &
      nb_collocation_points, collocation_points, dot_product_normals, &
      nb_vertices, nb_faces, vertices, faces,                         &
      centers, normals, areas, radiuses,                              &
      nb_quad_points, quad_points, quad_weights,                      &
      adjoint_double_layer,                                           &
      S, K)

    integer,                                                intent(in) :: nb_collocation_points
    real(kind=pre), dimension(nb_collocation_points, 3),    intent(in) :: collocation_points
    real(kind=pre), dimension(:, :),                        intent(in) :: dot_product_normals
    ! If adjoint_double_layer:     size(dot_product_normals) == (nb_collocation_points, 3)
    ! If not adjoint_double_layer: size(dot_product_normals) == (nb_faces, 3)

    integer,                                                intent(in) :: nb_faces, nb_vertices
    real(kind=pre), dimension(nb_vertices, 3),              intent(in) :: vertices
    integer,        dimension(nb_faces, 4),                 intent(in) :: faces
    real(kind=pre), dimension(nb_faces, 3),                 intent(in) :: centers, normals
    real(kind=pre), dimension(nb_faces),                    intent(in) :: areas, radiuses
    integer,                                                intent(in) :: nb_quad_points
    real(kind=pre), dimension(nb_faces, nb_quad_points, 3), intent(in) :: quad_points
    real(kind=pre), dimension(nb_faces, nb_quad_points),    intent(in) :: quad_weights

    logical,                                                intent(in) :: adjoint_double_layer

    complex(kind=pre), dimension(:, :),                     intent(inout) :: S
    complex(kind=pre), dimension(:, :, :),                  intent(inout) :: K

    ! Local variables
    real(kind=pre)               :: int_G_Rankine
    real(kind=pre), dimension(3) :: int_nablaG_Rankine
    integer                      :: I, J
    logical                      :: derivative_with_respect_to_first_variable

    derivative_with_respect_to_first_variable = adjoint_double_layer

    !$OMP PARALLEL DO SCHEDULE(DYNAMIC) &
    !$OMP&  PRIVATE(J, I, int_G_Rankine, int_nablaG_Rankine)
    do J = 1, nb_faces
      do I = 1, nb_collocation_points
        call integral_of_Rankine(                    &
          collocation_points(I, :),                  &
          vertices(faces(J, :), :),                  &
          centers(J, :),                             &
          normals(J, :),                             &
          areas(J),                                  &
          radiuses(J),                               &
          derivative_with_respect_to_first_variable, &
          int_G_Rankine, int_nablaG_Rankine          &
          )

        S(I, J) = S(I, J) + MINUS_ONE_OVER_FOURPI * int_G_Rankine

        if (size(K, 3) == 1) then  ! early_dot_product=True
          if (adjoint_double_layer) then
            K(I, J, 1) = K(I, J, 1) + MINUS_ONE_OVER_FOURPI * dot_product(dot_product_normals(I, :), int_nablaG_Rankine(:))
          else
            K(I, J, 1) = K(I, J, 1) + MINUS_ONE_OVER_FOURPI * dot_product(dot_product_normals(J, :), int_nablaG_Rankine(:))
          endif
        else
          K(I, J, :) = K(I, J, :) + MINUS_ONE_OVER_FOURPI * int_nablaG_Rankine(:)
        endif
      enddo
    enddo
  end subroutine

end module matrices

! Copyright (C) 2017-2024 Matthieu Ancellin
! See LICENSE file at <https://github.com/capytaine/libDelhommeau>

module floating_point_precision

  implicit none

  integer, parameter :: pre = kind(1e0)

end module floating_point_precision

! Just test that the library compiles and run

program test
  use LiangWuNoblesseWaveTerm, only: HavelockGF
  implicit none

  integer, parameter :: n = 10

  real(8), dimension(n) :: r, z
  complex(8), dimension(n) :: gf, gf_r
  integer :: i

  do i = 1, n
    r(i) = real(i, kind=8)/n
  end do

  do i = 1, n
    z(i) = -real(i, kind=8)/n
  end do

  !$OMP PARALLEL DO PRIVATE(i)
  do i = 1, n
    call HavelockGF(r(i), z(i), gf(i), gf_r(i))
  end do

  print*, real(gf(:))

end program test

! Copyright (C) 2022 Matthieu Ancellin
! See LICENSE file at <https://github.com/mancellin/capytaine>
!
! This module contains functions to evaluate the following integrals
! D1 = Re[ ∫(-i cosθ)(J(ζ) - 1/ζ)dθ ]
! D2 = Re[ ∫(-i cosθ)(e^ζ)dθ ]
#ifdef XIE_CORRECTION
! Z1 = Re[ ∫(J(ζ))dθ ]
#else
! Z1 = Re[ ∫(J(ζ) - 1/ζ)dθ ]
#endif
! Z2 = Re[ ∫(e^ζ)dθ ]
! where ζ depends on θ, as well as two additional parameters `r ∈ [0, +∞)` and `z ∈ (-∞, 0]`.
!
! They are required for the evaluation of the Green function and its gradient.
!
module delhommeau_integrals

  use floating_point_precision, only: pre
  use constants

  implicit none

  integer, parameter :: LEGACY_METHOD = 0  ! Nemoh 2
  integer, parameter :: SCALED_NEMOH3_METHOD = 1

  public :: numerical_integration
  public :: asymptotic_approximations
  public :: construct_tabulation
  public :: default_r_spacing, default_z_spacing
  public :: pick_in_default_tabulation

contains

  pure function numerical_integration(r, z, nb_integration_points) result(integrals)
    ! Compute the integrals by numerical integration, with `nb_integration_points` points.

    ! input
    real(kind=pre), intent(in) :: r
    real(kind=pre), intent(in) :: z
    integer,        intent(in), optional :: nb_integration_points

    ! output
    real(kind=pre), dimension(2, 2) :: integrals

    ! local variables
    integer :: n, k
    real(kind=pre) :: theta, delta_theta, cos_theta
    complex(kind=pre) :: zeta, exp_zeta, jzeta

    if (present(nb_integration_points)) then
      n = nb_integration_points
    else
      n = 251
    endif

    ! initial values
    integrals(:, :) = 0.0

    do k = 1, n
      theta = -pi/2 + pi*(k-1.0)/(n-1.0)
      ! The 1.0 are here on purpose to force the recasting of k and n as floats.

      ! Step of the integration using Simpson rule
      if ((k == 1) .or. (k == n)) then
        delta_theta = pi/(3*(n-1.0))
      elseif (mod(k, 2) == 0) then
        delta_theta = 4*pi/(3*(n-1.0))
      else
        delta_theta = 2*pi/(3*(n-1.0))
      endif

      cos_theta = cos(theta)
      zeta = cmplx(z, r*cos_theta, kind=pre)
      IF (REAL(ZETA) <= -30.0) THEN
        exp_zeta = (0.0, 0.0)
      else
        exp_zeta = exp(zeta)
      endif
      jzeta = exp_e1(zeta) + ii*pi*exp_zeta
      integrals(1, 1) = integrals(1, 1) + delta_theta * cos_theta * aimag(jzeta - 1.0/zeta)
      integrals(2, 1) = integrals(2, 1) + delta_theta * cos_theta * aimag(exp_zeta)
#ifdef XIE_CORRECTION
      integrals(1, 2) = integrals(1, 2) + delta_theta * real(jzeta)
#else
      integrals(1, 2) = integrals(1, 2) + delta_theta * real(jzeta - 1.0/zeta)
#endif
      integrals(2, 2) = integrals(2, 2) + delta_theta * real(exp_zeta)
    enddo

    integrals(1, 1) = integrals(1, 1)/PI
    integrals(1, 2) = integrals(1, 2)/PI

  contains

    pure function exp_e1(zz)
      ! estimation of exp(z)·E1(z) where E1(z) = ∫_z^∞ exp(-t)/t dt
      ! see p.367 of G. Delhommeau thesis (referenced as [del]).
      ! the computation is done is single precision.

      complex(kind=pre), intent(in)  :: zz
      complex(kind=pre)              :: exp_e1
      complex(kind=kind(1e0))        :: g, y, z

      z = cmplx(zz, kind=kind(1e0))
      if (real(z) < -16.0) then                                      ! case 1 p. 368 in [del]
        y = 1./z
        g = y*(1.+y*(-1.+y*(2.+y*(-6.+y*(24.+y*(-120.))))))
      else if (abs(aimag(z)) > 10.0) then                            ! case 3 p. 368 in [del]
        g = 0.711093/(z+0.415775)+0.278518/(z+2.29428)+0.010389/(z+6.2900)
      else if (real(z) > -0.5) then                                  ! case 2 p. 368 in [del]
        g = -(log(z)*(.1e+01+z*(0.23721365e+00+z*(0.206543e-01+z*(0.763297e-03+     &
          z*0.97087007e-05))))+0.5772156649e+00*(0.99999207e+00+                    &
          z*(-0.149545886e+01+z*(0.41806426e-01+z*(-0.3000591e-01+                  &
          z*(0.19387339e-02+z*(-0.51801555e-03)))))))/(0.1e+01+                     &
          z*(-0.76273617e+00+z*(0.28388363e+00+z*(-0.66786033e-01+z*(0.12982719e-01 &
          +z*(-0.8700861e-03+z*0.2989204e-03))))))
      else                                                           ! case 4 p. 369 in [del]
        if (aimag(z) < 0) then
          g = ((((((( (1.000000, 1.3935496e-06)*z+ (15.82958, -20.14222))   &
            *z+ (-70.52863, -227.9511))*z+ (-985.4221, -226.6272))*z        &
            + (-1202.318, 1580.907))*z+ (953.2441, 1342.447))*z             &
            + (417.3716, -196.6665))*z+ (-9.881266, -24.24952))/            &
            (((((((( (1.000000, 0.0000000e+00)*z+ (16.83184, -20.14481))*z  &
            + (-55.66969, -248.1167))*z+ (-1068.640, -434.4707))*z          &
            + (-2082.250, 1522.471))*z+ (383.3455, 2730.378))*z             &
            + (1216.791, 351.7189))*z+ (115.3926, -161.2647))*z             &
            + (-3.777369, -4.510900))
        else
          g = ((((((( (1.000000, -1.3935496e-06)*z+ (15.82958, 20.14222))   &
            *z+ (-70.52863, 227.9511))*z+ (-985.4221, 226.6272))*z          &
            + (-1202.318, -1580.907))*z+ (953.2441, -1342.447))*z           &
            + (417.3716, 196.6665))*z+ (-9.881266, 24.24952))/              &
            (((((((( (1.000000, 0.0000000e+00)*z+ (16.83184, 20.14481))*z   &
            + (-55.66969, 248.1167))*z+ (-1068.640, 434.4707))*z            &
            + (-2082.250, -1522.471))*z+ (383.3455, -2730.378))*z           &
            + (1216.791, -351.7189))*z+ (115.3926, 161.2647))*z             &
            + (-3.777369, 4.510900))
        end if
      end if
      exp_e1 = cmplx(g, kind=pre)

    end function exp_e1

  end function numerical_integration

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function asymptotic_approximations(r, z) result(integrals)
    ! Compute the integrals using an approximate expression for large r and |z|
    real(kind=pre), intent(in) :: r
    real(kind=pre), intent(in) :: z

    real(kind=pre), dimension(2, 2) :: integrals

    real(kind=pre) :: r1, expz_sqr, sin_kr, cos_kr

    r1 = hypot(r, z)

    expz_sqr = exp(z) * sqrt(2*pi/r)
    cos_kr  = cos(r - pi/4)
    sin_kr  = sin(r - pi/4)

    integrals(1, 1) = expz_sqr*(cos_kr - sin_kr/(2*r)) - r/r1**3
    integrals(2, 1) = expz_sqr*(sin_kr + cos_kr/(2*r))
#ifdef XIE_CORRECTION
    integrals(1, 2) = -expz_sqr*sin_kr + z/r1**3 - one/r1
#else
    integrals(1, 2) = -expz_sqr*sin_kr + z/r1**3
#endif
    integrals(2, 2) =  expz_sqr*cos_kr

  end function asymptotic_approximations


  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function construct_tabulation(r_range, z_range, nb_integration_points) result(tabulation)
    integer,        intent(in) :: nb_integration_points
    real(kind=pre), dimension(:), intent(in) :: r_range
    real(kind=pre), dimension(:), intent(in) :: z_range
    real(kind=pre), dimension(size(r_range), size(z_range), 2, 2) :: tabulation

    integer :: i, j

    do concurrent (j = 1:size(z_range))
      do concurrent (i = 1:size(r_range))
        tabulation(i, j, :, :) = numerical_integration(r_range(i), z_range(j), nb_integration_points)
      enddo
    enddo

  end function construct_tabulation

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function default_r_spacing(nr, rmax, method)
    integer, intent(in) :: nr
    real(kind=pre), intent(in) :: rmax
    integer, intent(in) :: method
    real(kind=pre), dimension(nr) :: default_r_spacing
    real(kind=pre), dimension(nr) :: default_r_spacing2

    ! Reference parameters from Nemoh 3 model
    integer, parameter :: nr_ref = 676
    integer, parameter :: index_of_1_ref = 81  ! index of the change of slope

    ! local variables
    integer :: i, index_of_1
    real(kind=pre) :: r_logSpace

    default_r_spacing(1) = 0.0

    if (method == LEGACY_METHOD) then
      do concurrent (i = 2:nr)
        default_r_spacing(i) = min(                    &
                                 10**((i-1.0)/5.0 - 6.0), &
                                 abs(i-32)/3.0 + 4.0/3.0  &
                               )
      enddo
    else
      ! change of slope at r = 1.0 that is i=index_of_1
      index_of_1 = nint(nr*1.0/nr_ref*index_of_1_ref)
      r_logSpace = -LOG(10.0**(-10))/(index_of_1 - 1.0)
      do concurrent (i = 2:nr)
        if (i < index_of_1) then
          ! Exponential spacing
          default_r_spacing(i) =  (10.0**(-10))*(EXP(i*r_logSpace))
        else
          ! Linear spacing
          default_r_spacing(i) = (rmax-1)/(nr-index_of_1)*(i-index_of_1)+1.0
        endif
      enddo
    endif
  end function default_r_spacing

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function default_z_spacing(nz, zmin, method)
    integer, intent(in) :: nz
    real(kind=pre), intent(in) :: zmin
    integer, intent(in) :: method
    real(kind=pre), dimension(nz) :: default_z_spacing

    integer :: j
    real(kind=pre) :: dz

    if (method == LEGACY_METHOD) then
      do concurrent (j = 1:nz)
        default_z_spacing(j) = -min(10**(j/5.0-6.0), 10**(j/8.0-4.5))
        ! change of slope at z = -1e-2
      enddo
      if (nz == 46) then  ! For consistency with Nemoh 2...
        default_z_spacing(46) = -16.0
      endif
    else
      dz = (log10(abs(zmin))+10.0)/nz
      do concurrent (j = 1:nz)
        default_z_spacing(j) = -min(10**(dz*j-10.0), abs(zmin))
      enddo
    endif
  end function default_z_spacing

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function pick_in_default_tabulation(r, z, method, r_range, z_range, tabulation) result(integrals)
    ! inputs
    real(kind=pre), intent(in) :: r
    real(kind=pre), intent(in) :: z
    integer, intent(in) :: method
    real(kind=pre), dimension(:), intent(in) :: r_range
    real(kind=pre), dimension(:), intent(in) :: z_range
    real(kind=pre), dimension(size(r_range), size(z_range), 2, 2), intent(in) :: tabulation

    ! output
    real(kind=pre), dimension(2, 2) :: integrals

    ! local variables
    integer :: i, j

    i = max(2, min(size(r_range)-1, nearest_r_index(r, r_range, method)))
    j = max(2, min(size(z_range)-1, nearest_z_index(z, z_range, method)))

    integrals(:, :) = lagrange_polynomial_interpolation( &
      r, z,                                              &
      r_range(i-1:i+1), z_range(j-1:j+1),                &
      tabulation(i-1:i+1, j-1:j+1, :, :)                 &
      )

  contains

    pure function nearest_r_index(r, r_range, method)
      real(kind=pre), intent(in) :: r
      integer, intent(in) :: method
      real(kind=pre), dimension(:), intent(in) :: r_range
      integer :: nearest_r_index

      ! Reference parameters from Nemoh 3 model
      integer, parameter :: nr_ref = 676
      integer, parameter :: index_of_1_ref = 81  ! index of the change of slope

      ! local variables
      integer :: i, index_of_1
      real(kind=pre) :: rmax


      if (method == LEGACY_METHOD) then
        if (r < 1e-6) then
          nearest_r_index = 2
        else if (r < 1.0) then
          nearest_r_index = int(5*(log10(r) + 6) + 1)
        else
          nearest_r_index = int(3*r + 28)
        endif
      else
        index_of_1 = nint(size(r_range)/nr_ref*index_of_1_ref*1.0)
        rmax = r_range(size(r_range))

        if (r < 1e-9) then
          nearest_r_index = 2
        else if (r < 1.0) then
          nearest_r_index = int((log10(r) + FLOOR(index_of_1/10.0))*10.0 + MOD(index_of_1, 10))
        else
          nearest_r_index = int((r - 1)*(size(r_range) - index_of_1)/(rmax - 1) + index_of_1)
        endif
      endif
    end function

    pure function nearest_z_index(z, z_range, method)
      real(kind=pre), intent(in) :: z
      integer, intent(in) :: method
      real(kind=pre), dimension(:), intent(in) :: z_range
      integer :: nearest_z_index

      ! local parameters
      real(kind=pre) :: absz
      real(kind=pre) :: dz
      integer :: nz

      absz = abs(z)
      nz = size(z_range)

      if (method == LEGACY_METHOD) then
        if (absz > 1e-2) then
          nearest_z_index = int(8*(log10(absz) + 4.5))
        else
          nearest_z_index = int(5*(log10(absz) + 6))
        endif
      else
        dz = (log10(abs(z_range(nz)))+10.0)/nz
        nearest_z_index = int((log10(absz)+10)/dz)
      endif
    end function

    pure function lagrange_polynomial_interpolation(r, z, local_r_range, local_z_range, local_tabulation) result(integrals)
      ! inputs
      real(kind=pre),                        intent(in) :: r, z
      real(kind=pre), dimension(3),          intent(in) :: local_r_range
      real(kind=pre), dimension(3),          intent(in) :: local_z_range
      real(kind=pre), dimension(3, 3, 2, 2), intent(in) :: local_tabulation

      ! output
      real(kind=pre), dimension(2, 2) :: integrals

      ! local variable
      real(kind=pre), dimension(3) :: xl, zl

      xl(1) = pl2(local_r_range(2), local_r_range(3), local_r_range(1), r)
      xl(2) = pl2(local_r_range(3), local_r_range(1), local_r_range(2), r)
      xl(3) = pl2(local_r_range(1), local_r_range(2), local_r_range(3), r)
      zl(1) = pl2(local_z_range(2), local_z_range(3), local_z_range(1), z)
      zl(2) = pl2(local_z_range(3), local_z_range(1), local_z_range(2), z)
      zl(3) = pl2(local_z_range(1), local_z_range(2), local_z_range(3), z)

      integrals(1, 1) = dot_product(xl, matmul(local_tabulation(:, :, 1, 1), zl))
      integrals(2, 1) = dot_product(xl, matmul(local_tabulation(:, :, 2, 1), zl))
      integrals(1, 2) = dot_product(xl, matmul(local_tabulation(:, :, 1, 2), zl))
      integrals(2, 2) = dot_product(xl, matmul(local_tabulation(:, :, 2, 2), zl))
    end function lagrange_polynomial_interpolation

    pure function pl2(u1, u2, u3, xu)
      real(kind=pre), intent(in) :: u1, u2, u3, xu
      real(kind=pre) :: pl2
      pl2 = ((xu-u1)*(xu-u2))/((u3-u1)*(u3-u2))
    end function pl2

  end function pick_in_default_tabulation

end module delhommeau_integrals

program benchmark_profiling

use omp_lib
use ieee_arithmetic

use matrices, only: build_matrices
use delhommeau_integrals, only: default_r_spacing, default_z_spacing, construct_tabulation
use constants, only: pre  ! Floating point precision
use old_prony_decomposition, only: lisc

implicit none

integer(kind=8) :: starting_time, final_time, clock_rate

integer, parameter :: nb_faces = 4096
integer, parameter :: nb_vertices = 4*nb_faces
integer, parameter :: nb_quadrature_points = 1

real(kind=pre) :: wavenumber, depth

! Geometry of the mesh
real(kind=pre), dimension(nb_vertices, 3) :: vertices
integer, dimension(nb_faces, 4) :: faces
real(kind=pre), dimension(nb_faces, 3) :: face_center
real(kind=pre), dimension(nb_faces, 3) :: face_normal
real(kind=pre), dimension(nb_faces) :: face_area
real(kind=pre), dimension(nb_faces) :: face_radius
real(kind=pre), dimension(nb_faces, nb_quadrature_points, 3) :: quadrature_points
real(kind=pre), dimension(nb_faces, nb_quadrature_points) :: quadrature_weights

! Tabulation of the integrals used in the Green function
integer, parameter :: tabulation_nr = 328
integer, parameter :: tabulation_nz = 46
real(kind=pre), dimension(tabulation_nr)                       :: tabulated_r
real(kind=pre), dimension(tabulation_nz)                       :: tabulated_z
real(kind=pre), dimension(tabulation_nr, tabulation_nz, 2, 2)  :: tabulated_integrals

! Prony decomposition for the finite depth Green function
integer, parameter :: nexp_max = 31
integer :: nexp
real, dimension(nexp_max) :: ambda_f32, ar_f32
real(kind=pre), dimension(nexp_max) :: ambda, ar

integer i
real(kind=pre), dimension(3) :: coeffs

! The interaction matrices to be computed
complex(kind=pre), dimension(:, :), allocatable :: S
complex(kind=pre), dimension(:, :, :), allocatable :: K

print*, "-- Run libdelhommeau/benchmark/profiling/profiling.f90"

call RANDOM_INIT(.true.,.true.)

allocate(S(nb_faces, nb_faces))
allocate(K(nb_faces, nb_faces, 1))

tabulated_r(:) = default_r_spacing(tabulation_nr)
tabulated_z(:) = default_z_spacing(tabulation_nz)
tabulated_integrals(:, :, :, :) = construct_tabulation(tabulated_r, tabulated_z, 251)

wavenumber = 1.0

call random_panels(nb_faces, vertices, faces, face_center, face_normal, face_area, face_radius)
quadrature_points = reshape(face_center, shape(quadrature_points))
quadrature_weights = reshape(face_area, shape(quadrature_weights))

print'(a)', "depth kind           elapsed time (s)"

do i=1, 1

   if (i .eq. 1) then
      depth = ieee_value(depth, ieee_positive_inf)
   else
      depth = 50.
      call lisc(real(wavenumber*depth*tanh(wavenumber*depth)), real(wavenumber*depth), ambda_f32, ar_f32, nexp)
      ambda(:) = real(ambda_f32(:), kind=pre)
      ar(:) = real(ar_f32(:), kind=pre)
      nexp = nexp + 1
      ambda(nexp) = 0.0
      ar(nexp) = 2.0
   end if

   call system_clock(count_rate=clock_rate)

   coeffs = [1d0, 1d0, 1d0]
   call system_clock(starting_time)
   call build_matrices(                                           &
        nb_faces, face_center, face_normal,                          &
        nb_vertices, nb_faces, vertices, faces,                      &
        face_center, face_normal, face_area, face_radius,            &
        nb_quadrature_points, quadrature_points, quadrature_weights, &
        wavenumber, depth,                                           &
        coeffs,                                                      &
        tabulated_r, tabulated_z, tabulated_integrals,               &
        nexp, ambda, ar,                                             &
        .false., .true.,                                             &
        S, K)
   call system_clock(final_time)

   print'(1F5.0,a16,1ES16.6)', depth, " full ", real(final_time - starting_time)/clock_rate

   ! coeffs = [0d0, 0d0, 1d0]
   ! call system_clock(starting_time)
   ! call build_matrices(                                           &
   !      nb_faces, face_center, face_normal,                          &
   !      nb_vertices, nb_faces, vertices, faces,                      &
   !      face_center, face_normal, face_area, face_radius,            &
   !      nb_quadrature_points, quadrature_points, quadrature_weights, &
   !      wavenumber, depth,                                           &
   !      coeffs,                                                      &
   !      tabulated_r, tabulated_z, tabulated_integrals,               &
   !      nexp, ambda, ar,                                             &
   !      .false., .true.,                                             &
   !      S, K)
   ! call system_clock(final_time)

   ! print'(1F5.0,a16,1ES16.6)', depth, " wave_only ", real(final_time - starting_time)/clock_rate

   ! coeffs = [0d0, 0d0, 1d0]
   ! call system_clock(starting_time)
   ! call build_matrices(                                           &
   !      nb_faces, face_center, face_normal,                          &
   !      nb_vertices, nb_faces, vertices, faces,                      &
   !      face_center, face_normal, face_area, face_radius,            &
   !      nb_quadrature_points, quadrature_points, quadrature_weights, &
   !      wavenumber, depth,                                           &
   !      coeffs,                                                      &
   !      tabulated_r, tabulated_z, tabulated_integrals,               &
   !      nexp, ambda, ar,                                             &
   !      .true., .true.,                                              &
   !      S, K)
   ! call system_clock(final_time)

   ! print'(1F5.0,a16,1ES16.6)', depth, " half_wave_only ", real(final_time - starting_time)/clock_rate

end do

contains

  subroutine random_panels(nb_faces, vertices, faces, face_center, face_normal, face_area, face_radius)
    integer, intent(in) :: nb_faces

    integer, dimension(nb_faces, 4), intent(out) :: faces
    real(kind=pre), dimension(4*nb_faces, 3), intent(out) :: vertices
    real(kind=pre), dimension(nb_faces, 3), intent(out) :: face_center
    real(kind=pre), dimension(nb_faces, 3), intent(out) :: face_normal
    real(kind=pre), dimension(nb_faces), intent(out) :: face_area
    real(kind=pre), dimension(nb_faces), intent(out) :: face_radius

    real(kind=pre), dimension(3, 2) :: vertex_shifts
    integer :: i

    faces = transpose(reshape([(i, i=1,(nb_faces*4),1)], [4, nb_faces]))

    call random_number(face_area)
    face_area = 1.0 + face_area

    face_radius = face_area * sqrt(2.0)/2.0

    call random_number(face_center)
    face_center(:, 1) = 20*(face_center(:, 1) - 0.5)
    face_center(:, 2) = 20*(face_center(:, 2) - 0.5)
    face_center(:, 3) = -10*face_center(:, 3) - face_radius(:)

    call random_number(face_normal)
    face_normal(:, :) = face_normal(:, :) - 0.5
    do i = 1, nb_faces
      face_normal(i, :) = face_normal(i, :)/norm2(face_normal(i, :))
    enddo

    do i = 1, nb_faces
      vertex_shifts = face_radius(i) * two_orthogonal_vector(face_normal(i, :))
      vertices(4*(i-1)+1, :) = face_center(i, :) + vertex_shifts(:, 1)
      vertices(4*(i-1)+2, :) = face_center(i, :) + vertex_shifts(:, 2)
      vertices(4*(i-1)+3, :) = face_center(i, :) - vertex_shifts(:, 1)
      vertices(4*(i-1)+4, :) = face_center(i, :) - vertex_shifts(:, 2)
    enddo
  end subroutine

  pure function two_orthogonal_vector(n) result(vecs)
    ! Given a normal vector `n`, returns two other vectors
    ! such that the three of them is an orthonormal basis
    real(kind=pre), dimension(3), intent(in) :: n
    real(kind=pre), dimension(3, 2) :: vecs

    vecs(:, 1) = [n(2), -n(1), 0d0]
    if (norm2(vecs(:, 1)) < abs(1e-5)) then
      vecs(:, 1) = [n(3), 0d0, -n(1)]
    endif

    ! Cross product
    vecs(1, 2) = n(2) * vecs(3, 1) - n(3) * vecs(2, 1)
    vecs(2, 2) = n(3) * vecs(1, 1) - n(1) * vecs(3, 1)
    vecs(3, 2) = n(1) * vecs(2, 1) - n(2) * vecs(1, 1)

    vecs(:, 1) = vecs(:, 1)/norm2(vecs(:, 1))
    vecs(:, 2) = vecs(:, 2)/norm2(vecs(:, 2))
  end function

end program benchmark_profiling

program benchmark_omp

use omp_lib
use ieee_arithmetic

use matrices, only: build_matrices
use delhommeau_integrals, only: default_r_spacing, default_z_spacing, construct_tabulation
use constants, only: pre  ! Floating point precision
use constants, only: nb_tabulated_values
use old_prony_decomposition, only: lisc

implicit none

integer(kind=8) :: starting_time, final_time, clock_rate

integer, parameter :: nb_faces = 8192
integer, parameter :: nb_vertices = 4*nb_faces
integer, parameter :: nb_quadrature_points = 1

real(kind=pre) :: wavenumber, depth

! Geometry of the mesh
real(kind=pre), dimension(nb_vertices, 3) :: vertices
integer, dimension(nb_faces, 4) :: faces
real(kind=pre), dimension(nb_faces, 3) :: face_center
real(kind=pre), dimension(nb_faces, 3) :: face_normal
real(kind=pre), dimension(nb_faces) :: face_area
real(kind=pre), dimension(nb_faces) :: face_radius
real(kind=pre), dimension(nb_faces, nb_quadrature_points, 3) :: quadrature_points
real(kind=pre), dimension(nb_faces, nb_quadrature_points) :: quadrature_weights

! Tabulation of the integrals used in the Green function
integer, parameter :: tabulation_grid_shape = 1
integer, parameter :: tabulation_nb_integration_points = 1000
integer, parameter :: tabulation_nr = 328
integer, parameter :: tabulation_nz = 46
real(kind=pre), dimension(tabulation_nr)                       :: tabulated_r
real(kind=pre), dimension(tabulation_nz)                       :: tabulated_z
real(kind=pre), dimension(tabulation_nr, tabulation_nz, nb_tabulated_values)  :: tabulated_integrals

integer, parameter :: gf_singularities = 1  ! low_freq

integer, parameter :: finite_depth_method = 1
! Prony decomposition for the finite depth Green function
integer :: nexp
real(kind=pre), dimension(2, 31) :: prony_decomposition
real(kind=pre), dimension(1) :: dispersion_roots  ! Dummy, only for FinGreen3D

integer n_threads

! The interaction matrices to be computed
complex(kind=pre), dimension(:, :), allocatable :: S
complex(kind=pre), dimension(:, :, :), allocatable :: K

print*, "-- Run libdelhommeau/benchmark/openmp/benchmark_omp.f90"

call RANDOM_INIT(.true.,.true.)

allocate(S(nb_faces, nb_faces))
allocate(K(nb_faces, nb_faces, 1))

tabulated_r(:) = default_r_spacing(tabulation_nr, 100d0, tabulation_grid_shape)
tabulated_z(:) = default_z_spacing(tabulation_nz, -251d0, tabulation_grid_shape)
tabulated_integrals(:, :, :) = construct_tabulation(tabulated_r, tabulated_z, tabulation_nb_integration_points)

wavenumber = 1.0

if (.true.) then
   depth = ieee_value(depth, ieee_positive_inf)
else
   depth = 50.
   call lisc(real(wavenumber*depth*tanh(wavenumber*depth)), real(wavenumber*depth), nexp, prony_decomposition)
end if

call random_panels(nb_faces, vertices, faces, face_center, face_normal, face_area, face_radius)
quadrature_points = reshape(face_center, shape(quadrature_points))
quadrature_weights = reshape(face_area, shape(quadrature_weights))

! ! For debugging
! open (unit=4, file='vertices.dat', form='formatted')
! do i = 1, 4*nb_faces
!    write (4, *) vertices(i, :)
! end do

call system_clock(count_rate=clock_rate)

open(unit=210, file="benchmark_omp.csv")
print'(a)', "           kind num. thread(s) elapsed time (s)"
write(210, '(a)') "n_threads,elapsed_time,kind"

do n_threads = 1, OMP_GET_MAX_THREADS()
  call omp_set_num_threads(n_threads)

  call system_clock(starting_time)
  call build_matrices(                                           &
    nb_faces, face_center, face_normal,                          &
    nb_vertices, nb_faces, vertices, faces,                      &
    face_center, face_normal, face_area, face_radius,            &
    nb_quadrature_points, quadrature_points, quadrature_weights, &
    wavenumber, depth,                                           &
    tabulation_nb_integration_points, tabulation_grid_shape,     &
    tabulated_r, tabulated_z, tabulated_integrals,               &
    finite_depth_method, prony_decomposition, dispersion_roots,  &
    gf_singularities, .true.,                                    &
    S, K)
  call system_clock(final_time)

  print'(a15,1i15,a,1ES16.6)', " full", n_threads, ' ', real(final_time - starting_time)/clock_rate
  write(210,'(1i3,a,1ES12.6,a)') n_threads, ",", real(final_time - starting_time)/clock_rate, ",full"
enddo

contains

  subroutine random_panels(nb_faces, vertices, faces, face_center, face_normal, face_area, face_radius)
    integer, intent(in) :: nb_faces

    integer, dimension(nb_faces, 4), intent(out) :: faces
    real(kind=pre), dimension(4*nb_faces, 3), intent(out) :: vertices
    real(kind=pre), dimension(nb_faces, 3), intent(out) :: face_center
    real(kind=pre), dimension(nb_faces, 3), intent(out) :: face_normal
    real(kind=pre), dimension(nb_faces), intent(out) :: face_area
    real(kind=pre), dimension(nb_faces), intent(out) :: face_radius

    real(kind=pre), dimension(3, 2) :: vertex_shifts
    integer :: i

    faces = transpose(reshape([(i, i=1,(nb_faces*4),1)], [4, nb_faces]))

    call random_number(face_area)
    face_area = 1.0 + face_area

    face_radius = face_area * sqrt(2.0)/2.0

    call random_number(face_center)
    face_center(:, 1) = 20*(face_center(:, 1) - 0.5)
    face_center(:, 2) = 20*(face_center(:, 2) - 0.5)
    face_center(:, 3) = -10*face_center(:, 3) - face_radius(:)

    call random_number(face_normal)
    face_normal(:, :) = face_normal(:, :) - 0.5
    do i = 1, nb_faces
      face_normal(i, :) = face_normal(i, :)/norm2(face_normal(i, :))
    enddo

    do i = 1, nb_faces
      vertex_shifts = face_radius(i) * two_orthogonal_vector(face_normal(i, :))
      vertices(4*(i-1)+1, :) = face_center(i, :) + vertex_shifts(:, 1)
      vertices(4*(i-1)+2, :) = face_center(i, :) + vertex_shifts(:, 2)
      vertices(4*(i-1)+3, :) = face_center(i, :) - vertex_shifts(:, 1)
      vertices(4*(i-1)+4, :) = face_center(i, :) - vertex_shifts(:, 2)
    enddo
  end subroutine

  pure function two_orthogonal_vector(n) result(vecs)
    ! Given a normal vector `n`, returns two other vectors
    ! such that the three of them is an orthonormal basis
    real(kind=pre), dimension(3), intent(in) :: n
    real(kind=pre), dimension(3, 2) :: vecs

    vecs(:, 1) = [n(2), -n(1), 0d0]
    if (norm2(vecs(:, 1)) < abs(1e-5)) then
      vecs(:, 1) = [n(3), 0d0, -n(1)]
    endif

    ! Cross product
    vecs(1, 2) = n(2) * vecs(3, 1) - n(3) * vecs(2, 1)
    vecs(2, 2) = n(3) * vecs(1, 1) - n(1) * vecs(3, 1)
    vecs(3, 2) = n(1) * vecs(2, 1) - n(2) * vecs(1, 1)

    vecs(:, 1) = vecs(:, 1)/norm2(vecs(:, 1))
    vecs(:, 2) = vecs(:, 2)/norm2(vecs(:, 2))
  end function

end program benchmark_omp

! Just test that the library compiles and run

program test
  use fingreen3d_module, only: fingreen3d_routine, dispersion

  implicit none

  integer, parameter :: n = 10
  integer, parameter :: nk = 200
  real(8), parameter :: g = 9.81

  real(8) :: omega, water_depth

  real(8), dimension(nk) :: roots_of_dispersion_relationship
  real(8), dimension(n) :: r, x3, xi3
  complex(8), dimension(n, 3) :: gf
  integer :: i

  omega = 1d0
  water_depth = 10d0

  call dispersion(roots_of_dispersion_relationship, nk, omega, water_depth)

  do i = 1, n
    r(i) = real(i, kind=8)/n
    x3(i) = -real(i, kind=8)/n
    xi3(i) = -2*real(i, kind=8)/n
  end do

  !$OMP PARALLEL DO PRIVATE(i)
  do i = 1, n
    call fingreen3d_routine(r(i), x3(i), xi3(i), sqrt(g*omega), roots_of_dispersion_relationship, nk, water_depth, gf(i, :))
  end do

  print*, real(gf(:, 1))
  print*, real(gf(:, 2))
  print*, real(gf(:, 3))

end program test

! Copyright (C) 2017-2025 Matthieu Ancellin
! See LICENSE file at <https://github.com/capytaine/libDelhommeau>
module Green_Wave

  use floating_point_precision, only: pre
  use constants
  use delhommeau_integrals
#ifdef LIANGWUNOBLESSE_OPTIONAL_DEPENDENCY
    use liangwunoblessewaveterm, only: havelockgf
#endif
#ifdef FINGREEN3D_OPTIONAL_DEPENDENCY
    use fingreen3d_module, only: fingreen3d_routine, dispersion
#endif
  use green_rankine, only: integral_of_reflected_rankine

  implicit none

  ! Dependencies between the functions of this module:
  ! (from top to bottom: "is called by")
  !
  !                                            (Delhommeau_integrals.f90 or LiangWuNoblesseWaveTerm.f90)
  !                                                                       |
  !                integral_of_singularity_on_free_surface          wave_part_infinite_depth
  !                                                       \               |
  !                    integral_of_reflected_Rankine      integral_of_wave_part_infinite_depth
  !                                             |         /          |
  !                     integral_of_wave_part_finite_depth           |
  !                                              \                   /
  !                                              integral_of_wave_part
  !                                                       |
  !                                                 (matrices.f90)
  !                                                       |
  !                                                 (python code)

CONTAINS

  ! =====================================================================

  subroutine integral_of_wave_part_infinite_depth                &
      (x,                                                        &
      face_center, face_area,                                    &
      face_quadrature_points, face_quadrature_weights,           &
      wavenumber,                                                &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      derivative_with_respect_to_first_variable,                 &
      int_G, int_nablaG                                          &
      )

    real(kind=pre), dimension(3),          intent(in) :: x
    real(kind=pre), dimension(3),          intent(in) :: face_center
    real(kind=pre),                        intent(in) :: face_area
    real(kind=pre), dimension(:),          intent(in) :: face_quadrature_weights
    real(kind=pre), dimension(:, :),       intent(in) :: face_quadrature_points
    real(kind=pre),                        intent(in) :: wavenumber
    integer,                               intent(in) :: gf_singularities
    integer,                               intent(in) :: tabulation_nb_integration_points
    integer,                               intent(in) :: tabulation_grid_shape
    real(kind=pre), dimension(:),          intent(in) :: tabulated_r_range
    real(kind=pre), dimension(:),          intent(in) :: tabulated_z_range
    real(kind=pre), dimension(:, :, :),    intent(in) :: tabulated_integrals
    logical,                               intent(in) :: derivative_with_respect_to_first_variable

    complex(kind=pre),                     intent(out) :: int_G
    complex(kind=pre), dimension(3),       intent(out) :: int_nablaG

    ! Local variables
    real(kind=pre)                  :: r, z
    complex(kind=pre)               :: G_at_point
    complex(kind=pre), dimension(3) :: nablaG_at_point
    integer                         :: nb_quad_points, Q

    r = wavenumber * norm2(x(1:2) - face_center(1:2))
    z = wavenumber * (x(3) + face_center(3))

    if ((abs(r) < 1e-10) .and. (abs(z) < 1e-10)) then
      if (gf_singularities == HIGH_FREQ) then
        print*, "WARNING: support of free surface panels not implemented for the high_freq Green function"
        ! Delhommeau().evaluate() should not permit this to happen.
      endif

      ! Interaction of a panel on the free surface with itself
      call integral_of_singularity_on_free_surface( &
        face_area, wavenumber, int_G, int_nablaG)

    else
      ! Numerical integration
      int_G = zero
      int_nablaG = zero

      nb_quad_points = size(face_quadrature_weights)

      do q = 1, nb_quad_points
        call wave_part_infinite_depth                                &
          (x,                                                        &
          face_quadrature_points(q, :),                              &
          wavenumber,                                                &
          tabulation_nb_integration_points, tabulation_grid_shape,   &
          tabulated_r_range, tabulated_z_range, tabulated_integrals, &
          gf_singularities,                                          &
          G_at_point, nablaG_at_point                                &
          )
        int_G = int_G + G_at_point * face_quadrature_weights(q)
        int_nablaG(:) = int_nablaG(:) + nablaG_at_point(:) * face_quadrature_weights(q)
      end do
    end if

    if (.not. derivative_with_respect_to_first_variable) then
      int_nablaG(1:2) = -int_nablaG(1:2)
    endif

  end subroutine

  ! =====================================================================

  subroutine integral_of_singularity_on_free_surface(face_area, wavenumber, int_G, int_nablaG)
  ! Integrating the wave term by approximating the panel by a circle of same area.
  ! The singularities are integrated analytically. The rest is integrated with a 1-point integral.

  ! G_w^+ = - 2 k log(k r) + rest
  ! ∫_Γ G_w^+ dξ ∼ - 2 k ∫_Γ log(k r) dξ + |Γ| rest(0)
  ! with
  ! ∫_Γ log(k r) dξ = |Γ|/2 (log(k^2 Γ/π) - 1)
  ! and
  ! rest(0) = 2 k ( γ - log(2) ) - 2ikπ
  !
  ! Also
  ! dG_w^+/dz = G_w^+ + 2/r
  ! with
  ! ∫_Γ 1/r dξ ∼ 2 √( π |Γ| )
  ! TODO: replace the latter with the actual integral since we computed it anyway for the Rankine term.

  ! TODO: only low_freq singularities are implemented here
    real(kind=pre),                        intent(in) :: wavenumber
    real(kind=pre),                        intent(in) :: face_area

    complex(kind=pre),                     intent(out) :: int_G
    complex(kind=pre), dimension(3),       intent(out) :: int_nablaG

    int_G = wavenumber * face_area * (                      &
                  (1 - log(wavenumber**2 * face_area / pi)) &
                  + 2 * (euler_gamma - log_2) - 2*pi*ii     &
                )
    int_nablaG(1:2) = cmplx(zero, zero, kind=pre)  ! TODO: might be needed for velocity reconstruction.
    int_nablaG(3) = wavenumber * (int_G + 4 * sqrt(pi*face_area))
  end subroutine

  ! =====================================================================

  SUBROUTINE WAVE_PART_INFINITE_DEPTH                            &
      (X0I, X0J, wavenumber,                                     &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      G, nablaG)
      ! Returns
      ! (G^-, nabla G^-)                    if gf_singularities == HIGH_FREQ
      ! (G^+, nabla G^+)                    if gf_singularities == LOW_FREQ
      ! (G^+, nabla G^+ - (0, 0, 2*k**2/r1) if gf_singularities == LOW_FREQ_WITH_RANKINE_PART
      ! In the last case, the missing term will be computed with the reflected Rankine term

    ! Inputs
    REAL(KIND=PRE), DIMENSION(3),             INTENT(IN) :: X0I, X0J
    REAL(KIND=PRE),                           INTENT(IN) :: wavenumber
    integer,                                  intent(in) :: gf_singularities

    ! Tabulated data
    integer,                                  intent(in) :: tabulation_nb_integration_points
    INTEGER,                                  INTENT(IN) :: tabulation_grid_shape
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_r_range
    REAL(KIND=PRE), DIMENSION(:),             INTENT(IN) :: tabulated_z_range
    REAL(KIND=PRE), DIMENSION(:, :, :),       INTENT(IN) :: tabulated_integrals

    ! Outputs
    COMPLEX(KIND=PRE),                        INTENT(OUT) :: G
    COMPLEX(KIND=PRE), DIMENSION(3),          INTENT(OUT) :: nablaG

    ! Local variables
    REAL(KIND=PRE) :: r, r1, z, drdx1, drdx2, dzdx3
    complex(kind=pre) :: G_, dGdr_, dGdr
    REAL(KIND=PRE), dimension(nb_tabulated_values) :: integrals

    r = wavenumber * NORM2(X0I(1:2) - X0J(1:2))
    z = wavenumber * (X0I(3) + X0J(3))
    r1 = hypot(r, z)

    IF (ABS(r) > 16*EPSILON(r)) THEN
      drdx1 = wavenumber**2 * (X0I(1) - X0J(1))/r
      drdx2 = wavenumber**2 * (X0I(2) - X0J(2))/r
    ELSE
      ! Limit when r->0 is not well defined...
      drdx1 = ZERO
      drdx2 = ZERO
    END IF
    dzdx3 = wavenumber

    IF (tabulation_grid_shape == LIANG_WU_NOBLESSE) THEN
#ifdef LIANGWUNOBLESSE_OPTIONAL_DEPENDENCY
        call HavelockGF(r, z, G_, dGdr_)
        G = - G_
        dGdr = - dGdr_
        nablaG(1) = drdx1 * dGdr
        nablaG(2) = drdx2 * dGdr
        nablaG(3) = dzdx3 * (G + 2/r1)
#endif
    ELSE

    !=======================================================
    ! Evaluate the elementary integrals depending on z and r
    !=======================================================
      IF ((size(tabulated_z_range) <= 1) .or. (size(tabulated_r_range) <= 1)) THEN
        ! No tabulation, fully recompute the Green function each time.
        integrals = numerical_integration(r, z, tabulation_nb_integration_points)
      ELSE
        IF ((abs(z) < abs(tabulated_z_range(size(tabulated_z_range)))) &
          .AND. (r < tabulated_r_range(size(tabulated_r_range)))) THEN
          ! Within the range of tabulated data
          integrals = pick_in_default_tabulation( &
            r, z, tabulation_grid_shape, tabulated_r_range, tabulated_z_range, tabulated_integrals &
            )
        ELSE
          ! Delhommeau's asymptotic expression of Green function for distant panels
          integrals = asymptotic_approximations(MAX(r, 1e-10), z)
        ENDIF
      ENDIF

    !===================================================
    ! Add the elementary integrals to build G and nablaG
    !===================================================

    if ((gf_singularities == LOW_FREQ) .or. (gf_singularities == LOW_FREQ_WITH_RANKINE_PART)) then
      ! G is G^+, nablaG is nablaG^+
      G = CMPLX(integrals(1), integrals(3), KIND=PRE)
      dGdr = CMPLX(integrals(4), integrals(5), KIND=PRE)
      nablaG(1) = drdx1 * dGdr
      nablaG(2) = drdx2 * dGdr
      if (gf_singularities == LOW_FREQ) then
        nablaG(3) = dzdx3 * (G + 2/r1)
      else
        nablaG(3) = dzdx3 * G
        ! The missing Rankine term is integrated as a Rankine term
      endif
    else if (gf_singularities == HIGH_FREQ) then
      ! G is G^-, nablaG is nablaG^-
      G = CMPLX(integrals(2), integrals(3), KIND=PRE)
      dGdr = CMPLX(integrals(4), integrals(5), KIND=PRE)
      nablaG(1) = drdx1 * dGdr - 2*drdx1*r/r1**3
      nablaG(2) = drdx2 * dGdr - 2*drdx2*r/r1**3
      nablaG(3) = dzdx3 * G    - 2*dzdx3*z/r1**3
    endif
    ENDIF

    G = wavenumber * G
    nablaG = wavenumber * nablaG

  END SUBROUTINE WAVE_PART_INFINITE_DEPTH

  ! =====================================================================

  pure function symmetric_of_vector(n) result(n_sym)
    complex(kind=pre), dimension(3), intent(in) :: n
    complex(kind=pre), dimension(3) :: n_sym

    n_sym(1:2) = n(1:2)
    n_sym(3)   = -n(3)
  end function

  pure function sea_bottom_symmetric_of_point(x, depth) result(x_sym)
    real(kind=pre), dimension(3), intent(in) :: x
    real(kind=pre),               intent(in) :: depth
    real(kind=pre), dimension(3) :: x_sym

    x_sym(1:2) = x(1:2)
    x_sym(3) = -x(3) - 2*depth
  end function

  pure subroutine sea_bottom_symmetric_of_face( &
    face_center, face_quadrature_points,        &
    depth,                                      &
    face_center_sym, face_quadrature_points_sym &
    )
    real(kind=pre), dimension(3),    intent(in) :: face_center
    real(kind=pre), dimension(:, :), intent(in) :: face_quadrature_points
    real(kind=pre),                  intent(in) :: depth
    real(kind=pre), dimension(3),    intent(out) :: face_center_sym
    real(kind=pre), dimension(:, :), intent(out) :: face_quadrature_points_sym

    integer :: i

    face_center_sym = sea_bottom_symmetric_of_point(face_center, depth)
    do i = 1, size(face_quadrature_points, 1)
      face_quadrature_points_sym(i, :) = sea_bottom_symmetric_of_point(face_quadrature_points(i, :), depth)
    end do
  end subroutine

  subroutine integral_of_wave_parts_finite_depth                 &
      (x,                                                        &
      face_center, face_area,                                    &
      face_quadrature_points, face_quadrature_weights,           &
      wavenumber, depth,                                         &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      derivative_with_respect_to_first_variable,                 &
      int_G, int_nablaG                                          &
      )

    ! Inputs
    real(kind=pre), dimension(3),             intent(in) :: x
    real(kind=pre), dimension(3),             intent(in) :: face_center
    real(kind=pre),                           intent(in) :: face_area
    real(kind=pre), dimension(:),             intent(in) :: face_quadrature_weights
    real(kind=pre), dimension(:, :),          intent(in) :: face_quadrature_points
    real(kind=pre),                           intent(in) :: wavenumber, depth
    logical,                                  intent(in) :: derivative_with_respect_to_first_variable

    ! Tabulated data
    integer,                                  intent(in) :: tabulation_nb_integration_points
    integer,                                  intent(in) :: tabulation_grid_shape
    real(kind=pre), dimension(:),             intent(in) :: tabulated_r_range
    real(kind=pre), dimension(:),             intent(in) :: tabulated_z_range
    real(kind=pre), dimension(:, :, :),       intent(in) :: tabulated_integrals

    integer,                                  intent(in) :: gf_singularities

    ! Outputs
    complex(kind=pre),               intent(out) :: int_G  ! integral of the Green function over the panel.
    complex(kind=pre), dimension(3), intent(out) :: int_nablaG ! Gradient of the integral of the Green function with respect to X0I.

    ! Local variables
    real(kind=pre), dimension(3)    :: x_sym, face_center_sym
    real(kind=pre), dimension(size(face_quadrature_points, 1), size(face_quadrature_points, 2)) :: face_quadrature_points_sym
    real(kind=pre)                  :: amh, akh, a
    complex(kind=pre)               :: int_G_term
    complex(kind=pre), dimension(3) :: int_nablaG_term

    int_G = czero
    int_nablaG = czero

    x_sym = sea_bottom_symmetric_of_point(x, depth)
    call sea_bottom_symmetric_of_face(            &
      face_center, face_quadrature_points, depth, &
      face_center_sym, face_quadrature_points_sym)

    ! 1.a First infinite depth problem
    CALL integral_of_wave_part_infinite_depth                    &
      (x,                                                        &
      face_center, face_area,                                    &
      face_quadrature_points, face_quadrature_weights,           &
      wavenumber,                                                &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      derivative_with_respect_to_first_variable,                 &
      int_G_term, int_nablaG_term                                &
      )
    int_G = int_G + int_G_term
    int_nablaG = int_nablaG + int_nablaG_term

    ! 1.b Reflect X and compute another value of the Green function
    CALL integral_of_wave_part_infinite_depth                    &
      (x_sym,                                                    &
      face_center, face_area,                                    &
      face_quadrature_points, face_quadrature_weights,           &
      wavenumber,                                                &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      derivative_with_respect_to_first_variable,                 &
      int_G_term, int_nablaG_term                                &
      )
    int_G = int_G + int_G_term
    if (derivative_with_respect_to_first_variable) then
      int_nablaG = int_nablaG + symmetric_of_vector(int_nablaG_term)
    else
      int_nablaG = int_nablaG + int_nablaG_term
    endif

    ! 1.c Reflect face and compute another value of the Green function
    CALL integral_of_wave_part_infinite_depth                    &
      (x,                                                        &
      face_center_sym, face_area,                                &
      face_quadrature_points_sym, face_quadrature_weights,       &
      wavenumber,                                                &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      derivative_with_respect_to_first_variable,                 &
      int_G_term, int_nablaG_term                                &
      )
    int_G = int_G + int_G_term
    if (derivative_with_respect_to_first_variable) then
      int_nablaG = int_nablaG + int_nablaG_term
    else
      int_nablaG = int_nablaG + symmetric_of_vector(int_nablaG_term)
    endif

    ! 1.d Reflect both x and face and compute another value of the Green function
    CALL integral_of_wave_part_infinite_depth                    &
      (x_sym,                                                    &
      face_center_sym, face_area,                                &
      face_quadrature_points_sym, face_quadrature_weights,       &
      wavenumber,                                                &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      derivative_with_respect_to_first_variable,                 &
      int_G_term, int_nablaG_term                                &
      )
    int_G = int_G + int_G_term
    int_nablaG = int_nablaG + symmetric_of_vector(int_nablaG_term)

    ! Some coefficient
    AMH  = wavenumber*depth
    AKH  = AMH*TANH(AMH)
    A    = (AMH+AKH)**2/(4*AMH*(AMH**2-AKH**2+AKH))

    int_G = A * int_G
    int_nablaG = A * int_nablaG

  end subroutine

  subroutine integral_of_prony_decomp_finite_depth               &
      (x,                                                        &
      face_nodes,                                                &
      face_center, face_normal, face_area, face_radius,          &
      depth,                                                     &
      prony_decomposition,                                       &
      derivative_with_respect_to_first_variable,                 &
      int_G, int_nablaG                                          &
      )

    ! Inputs
    real(kind=pre), dimension(3),             intent(in) :: x
    real(kind=pre), dimension(4, 3),          intent(in) :: face_nodes
    real(kind=pre), dimension(3),             intent(in) :: face_center, face_normal
    real(kind=pre),                           intent(in) :: face_area, face_radius
    real(kind=pre),                           intent(in) :: depth
    logical,                                  intent(in) :: derivative_with_respect_to_first_variable

    real(kind=pre), dimension(:, :),          intent(in) :: prony_decomposition

    ! Outputs
    complex(kind=pre),               intent(out) :: int_G
    complex(kind=pre), dimension(3), intent(out) :: int_nablaG

    ! Local variables
    real(kind=pre)                  :: lambda_k, a_k
    real(kind=pre)                  :: int_G_term_Rankine
    real(kind=pre), dimension(3)    :: int_nablaG_term_Rankine
    integer                         :: ke

    int_G = czero
    int_nablaG = czero

    do ke = 1, size(prony_decomposition, 2)
      lambda_k = prony_decomposition(1, ke)
      a_k = prony_decomposition(2, ke)

      ! 2.a
      call integral_of_reflected_Rankine(          &
        x,                                         &
        face_nodes, face_center, face_normal,      &
        face_area, face_radius,                    &
        derivative_with_respect_to_first_variable, &
        [ONE, depth*lambda_k - 2*depth],           &
        int_G_term_Rankine, int_nablaG_term_Rankine)
      int_G = int_G + a_k/2 * int_G_term_Rankine
      int_nablaG = int_nablaG + a_k/2 * int_nablaG_term_Rankine

      ! 2.b
      call integral_of_reflected_Rankine(          &
        x,                                         &
        face_nodes, face_center, face_normal,      &
        face_area, face_radius,                    &
        derivative_with_respect_to_first_variable, &
        [-ONE, -depth*lambda_k],                   &
        int_G_term_Rankine, int_nablaG_term_Rankine)
      int_G = int_G + a_k/2 * int_G_term_Rankine
      int_nablaG = int_nablaG + a_k/2 * int_nablaG_term_Rankine

      ! 2.c
      call integral_of_reflected_Rankine(          &
        x,                                         &
        face_nodes, face_center, face_normal,      &
        face_area, face_radius,                    &
        derivative_with_respect_to_first_variable, &
        [-ONE, depth*lambda_k - 4*depth],          &
        int_G_term_Rankine, int_nablaG_term_Rankine)
      int_G = int_G + a_k/2 * int_G_term_Rankine
      int_nablaG = int_nablaG + a_k/2 * int_nablaG_term_Rankine

      ! 2.d
      call integral_of_reflected_Rankine(          &
        x,                                         &
        face_nodes, face_center, face_normal,      &
        face_area, face_radius,                    &
        derivative_with_respect_to_first_variable, &
        [ONE, -depth*lambda_k + 2*depth],          &
        int_G_term_Rankine, int_nablaG_term_Rankine)
      int_G = int_G + a_k/2 * int_G_term_Rankine
      int_nablaG = int_nablaG + a_k/2 * int_nablaG_term_Rankine
    end do
  end subroutine

  ! =====================================================================


  function compute_dispersion_roots(nk, omega2_over_g, depth) result(roots_of_dispersion_relationship)
    integer, intent(in) :: nk
    real(kind=pre), intent(in) :: omega2_over_g, depth
    real(kind=pre), dimension(nk) :: roots_of_dispersion_relationship

    real(kind=8) :: omega, depth_f64
    real(kind=8), dimension(nk) :: roots_of_dispersion_relationship_f64
    depth_f64 = depth
    omega = sqrt(omega2_over_g * 9.81d0)

#ifdef FINGREEN3D_OPTIONAL_DEPENDENCY
    ! Calls FinGreen3D.f90
    call dispersion(roots_of_dispersion_relationship_f64, nk, omega, depth_f64)
#else
    print*, "The library has not been compiled with FinGreen3D.f90 optional dependency"
    error stop
#endif

    roots_of_dispersion_relationship = roots_of_dispersion_relationship_f64
  end function

  subroutine integral_of_wave_part_fingreen3D                  &
    (x,                                                        &
    face_quadrature_points, face_quadrature_weights,           &
    wavenumber, depth, dispersion_roots,                       &
    derivative_with_respect_to_first_variable,                 &
    int_G, int_nablaG                                          &
    )

    real(kind=pre), dimension(3),          intent(in) :: x
    real(kind=pre), dimension(:),          intent(in) :: face_quadrature_weights
    real(kind=pre), dimension(:, :),       intent(in) :: face_quadrature_points
    real(kind=pre),                        intent(in) :: wavenumber, depth
    real(kind=pre), dimension(:),          intent(in) :: dispersion_roots
    logical,                               intent(in) :: derivative_with_respect_to_first_variable

    complex(kind=pre),                     intent(out) :: int_G
    complex(kind=pre), dimension(3),       intent(out) :: int_nablaG

    integer, parameter :: nk = 200
    integer :: q, nb_quad_points
    real(kind=pre) :: omega2_over_g, r, drdx1, drdx2
    real(kind=pre), dimension(3) :: xi_q
    real(kind=pre), dimension(nk) :: roots_of_dispersion_relationship
    complex(kind=pre) :: G_at_point
    complex(kind=pre), dimension(3) :: reduced_G_nablaG, nablaG_at_point

    omega2_over_g  = wavenumber*TANH(wavenumber*depth)

    int_G = czero
    int_nablaG = czero

    nb_quad_points = size(face_quadrature_weights)

    do q = 1, nb_quad_points
      xi_q = face_quadrature_points(q, :)
      r = norm2(x(1:2) - xi_q(1:2))
#ifdef FINGREEN3D_OPTIONAL_DEPENDENCY
      if (.not. derivative_with_respect_to_first_variable) then
        ! For direct method as implemented in HAMS
        call fingreen3d_routine(r, x(3), xi_q(3), omega2_over_g, dispersion_roots, nk, depth, reduced_G_nablaG)
      else
        ! Switched inputs
        call fingreen3d_routine(r, xi_q(3), x(3), omega2_over_g, dispersion_roots, nk, depth, reduced_G_nablaG)
      endif
#else
    print*, "The library has not been compiled with FinGreen3D.f90 optional dependency"
    error stop
#endif

      G_at_point = reduced_G_nablaG(1)

      if (abs(r) > 16*epsilon(r)) then
        if (derivative_with_respect_to_first_variable) then
          drdx1 = (x(1) - xi_q(1))/r
          drdx2 = (x(2) - xi_q(2))/r
        else
          drdx1 = -(x(1) - xi_q(1))/r
          drdx2 = -(x(2) - xi_q(2))/r
        endif
      else
        ! Limit when r->0 is not well defined...
        drdx1 = ZERO
        drdx2 = ZERO
      end if
      nablaG_at_point(1) = drdx1 * reduced_G_nablaG(2)
      nablaG_at_point(2) = drdx2 * reduced_G_nablaG(2)
      nablaG_at_point(3) = reduced_G_nablaG(3)

      int_G = int_G + G_at_point * face_quadrature_weights(q)
      int_nablaG(:) = int_nablaG(:) + nablaG_at_point(:) * face_quadrature_weights(q)
    enddo
  end subroutine

end module Green_Wave

! Copyright (C) 2017-2025 Matthieu Ancellin
! See LICENSE file at <https://github.com/capytaine/libDelhommeau>
module Green_Rankine

  use floating_point_precision, only: pre
  use constants

  implicit none

  ! The index of the following node when going around a face.
  integer, private, dimension(4), parameter :: next_node = (/ 2, 3, 4, 1 /)

contains

  ! =================================================================

  pure subroutine integral_of_Rankine            &
      (M,                                        &
      face_nodes, face_center, face_normal,      &
      face_area, face_radius,                    &
      derivative_with_respect_to_first_variable, &
      int_G, int_nabla_G)

    real(kind=pre), dimension(3),    intent(in) :: M
    real(kind=pre), dimension(4, 3), intent(in) :: face_nodes
    real(kind=pre), dimension(3),    intent(in) :: face_center, face_normal
    real(kind=pre),                  intent(in) :: face_area, face_radius
    logical,                         intent(in) :: derivative_with_respect_to_first_variable

    ! Outputs
    real(kind=pre),               intent(out) :: int_G
    real(kind=pre), dimension(3), intent(out) :: int_nabla_G

    ! Local
    real(kind=pre) :: r0

    r0 = norm2(M(1:3) - face_center(1:3))

    if (r0 > 7*face_radius) then
      call one_point_integral_of_Rankine           &
        (M,                                        &
        face_center, face_area,                    &
        derivative_with_respect_to_first_variable, &
        int_G, int_nabla_G)
    else
      call exact_integral_of_Rankine               &
        (M,                                        &
        face_nodes, face_center, face_normal,      &
        face_area, face_radius,                    &
        derivative_with_respect_to_first_variable, &
        int_G, int_nabla_G)
    end if
  end subroutine

  ! =================================================================

  pure subroutine exact_integral_of_Rankine      &
      (M,                                        &
      face_nodes, face_center, face_normal,      &
      face_area, face_radius,                    &
      derivative_with_respect_to_first_variable, &
      int_G, int_nabla_G)
    ! Estimate the integral S0 = ∫∫ 1/MM' dS(M') over a face
    ! and its derivative VS0 with respect to M.

    ! Based on formulas A6.1 and A6.3 (p. 381 to 383)
    ! in G. Delhommeau thesis (referenced below as [Del]).

    ! Inputs
    real(kind=pre), dimension(3),    intent(in) :: M
    real(kind=pre), dimension(4, 3), intent(in) :: face_nodes
    real(kind=pre), dimension(3),    intent(in) :: face_center, face_normal
    real(kind=pre),                  intent(in) :: face_area, face_radius
    logical,                         intent(in) :: derivative_with_respect_to_first_variable

    ! Outputs
    real(kind=pre),               intent(out) :: int_G
    real(kind=pre), dimension(3), intent(out) :: int_nabla_G

    ! Local variables
    integer                         :: L
    real(kind=pre)                  :: GZ, DK, GY
    real(kind=pre), dimension(4)    :: RR
    real(kind=pre), dimension(3, 4) :: DRX
    real(kind=pre)                  :: ANT, DNT, ANL, DNL, ALDEN, AT
    real(kind=pre), dimension(3)    :: PJ, GYX, ANTX, ANLX, DNTX

    GZ = dot_product(M(1:3) - face_center(1:3), face_normal(1:3)) ! Called Z in [Del]

    do concurrent (L = 1:4)
      RR(L) = norm2(M(1:3) - face_nodes(L, 1:3))       ! Distance from vertices of face to M.
      DRX(:, L) = (M(1:3) - face_nodes(L, 1:3))/RR(L)  ! Normed vector from vertices of face to M.
    end do

    int_G = ZERO
    int_nabla_G(:) = ZERO

    do L = 1, 4
      DK = norm2(face_nodes(next_node(L), :) - face_nodes(L, :))    ! Distance between two consecutive points, called d_k in [Del]
      if (DK >= real(1e-3, PRE)*face_radius) then
        PJ(:) = (face_nodes(next_node(L), :) - face_nodes(L, :))/DK ! Normed vector from one corner to the next
        ! The following GYX(1:3) are called (a,b,c) in [Del]
        GYX(1) = face_normal(2)*PJ(3) - face_normal(3)*PJ(2)
        GYX(2) = face_normal(3)*PJ(1) - face_normal(1)*PJ(3)
        GYX(3) = face_normal(1)*PJ(2) - face_normal(2)*PJ(1)
        GY = dot_product(M - face_nodes(L, :), GYX)                                    ! Called Y_k in  [Del]

        ANT = 2*GY*DK                                                                  ! Called N^t_k in [Del]
        DNT = (RR(NEXT_NODE(L))+RR(L))**2 - DK*DK + 2*abs(GZ)*(RR(NEXT_NODE(L))+RR(L)) ! Called D^t_k in [Del]
        ANL = RR(NEXT_NODE(L)) + RR(L) + DK                                            ! Called N^l_k in [Del]
        DNL = RR(NEXT_NODE(L)) + RR(L) - DK                                            ! Called D^l_k in [Del]
        ALDEN = log(ANL/DNL)

        if (abs(GZ) >= real(1e-4, PRE)*face_radius) then
          AT = atan(ANT/DNT)
        else
          AT = 0.
        endif

        ANLX(:) = DRX(:, NEXT_NODE(L)) + DRX(:, L)                    ! Called N^l_k_{x,y,z} in [Del]

        ANTX(:) = 2*DK*GYX(:)                                         ! Called N^t_k_{x,y,z} in [Del]
        DNTX(:) = 2*(RR(NEXT_NODE(L)) + RR(L) + abs(GZ))*ANLX(:)      &
          + 2*sign(ONE, GZ)*(RR(NEXT_NODE(L)) + RR(L))*face_normal(:) ! Called D^t_k_{x,y,z} in [Del]

        if (abs(GY) < 1e-5) then
          ! Edge case where the singularity is on the boundary of the face (GY = 0, ALDEN = infty).
          ! This case seems to only occur when computating the free surface elevation,
          ! so no fix has been implemented for nabla_G, which is not needed then.
          int_G = int_G - 2*AT*abs(GZ)
        else
          ! General case
          int_G = int_G + GY*ALDEN - 2*AT*abs(GZ)
        end if

        int_nabla_G(:) = int_nabla_G(:) + ALDEN*GYX(:) &
          - 2*sign(ONE, GZ)*AT*face_normal(:)          &
          + GY*(DNL-ANL)/(ANL*DNL)*ANLX(:)             &
          - 2*abs(GZ)*(ANTX(:)*DNT - DNTX(:)*ANT)/(ANT*ANT+DNT*DNT)
      end if
    end do

    if (.not. derivative_with_respect_to_first_variable) then
      int_nabla_G(:) = - int_nabla_G(:)
    end if
  end subroutine exact_integral_of_rankine

  ! =================================================================

  pure subroutine one_point_integral_of_Rankine  &
      (M,                                        &
      face_center, face_area,                    &
      derivative_with_respect_to_first_variable, &
      int_G, int_nabla_G)
    ! Same as above, but always use the approximate aymptotic value.

    ! Inputs
    real(kind=pre), dimension(3), intent(in) :: M
    real(kind=pre), dimension(3), intent(in) :: face_center
    real(kind=pre),               intent(in) :: face_area
    logical,                      intent(in) :: derivative_with_respect_to_first_variable

    ! Outputs
    real(kind=pre),               intent(out) :: int_G
    real(kind=pre), dimension(3), intent(out) :: int_nabla_G

    ! Local variables
    real(kind=pre) :: ro
    real(kind=pre), dimension(3) :: vo

    vo = face_center - m
    ro = norm2(vo) ! distance from center of mass of the face to m.

    if (ro > real(1e-7, kind=pre)) then
      ! Asymptotic value if face far away from M
      int_G            = face_area/ro
      int_nabla_G(1:3) = vo*int_G/ro**2
    ELSE
      ! Singularity...
      int_G = ZERO
      int_nabla_G(1:3) = ZERO
    END IF

    if (.not. derivative_with_respect_to_first_variable) then
      int_nabla_G(:) = -int_nabla_G(:)
    endif
  end subroutine one_point_integral_of_Rankine

  ! =================================================================

  pure subroutine integral_of_reflected_Rankine  &
      (M,                                        &
      face_nodes, face_center, face_normal,      &
      face_area, face_radius,                    &
      derivative_with_respect_to_first_variable, &
      reflection_coefs,                          &
      int_G, int_nabla_G)

    real(kind=pre), dimension(3),    intent(in) :: M
    real(kind=pre), dimension(4, 3), intent(in) :: face_nodes
    real(kind=pre), dimension(3),    intent(in) :: face_center, face_normal
    real(kind=pre),                  intent(in) :: face_area, face_radius
    logical,                         intent(in) :: derivative_with_respect_to_first_variable
    real(kind=pre), dimension(2),    intent(in) :: reflection_coefs

    ! Outputs
    real(kind=pre),               intent(out) :: int_G
    real(kind=pre), dimension(3), intent(out) :: int_nabla_G

    ! Local
    real(kind=pre) :: r1

    r1 = hypot(norm2(M(1:2) - face_center(1:2)),  &
               reflection_coefs(1) * M(3) + reflection_coefs(2) - face_center(3))

    if (r1 > 7*face_radius) then
      call one_point_integral_of_reflected_Rankine &
        (M,                                        &
        face_center, face_area,                    &
        derivative_with_respect_to_first_variable, &
        reflection_coefs,                          &
        int_G, int_nabla_G)
    else
      call exact_integral_of_reflected_Rankine     &
        (M,                                        &
        face_nodes, face_center, face_normal,      &
        face_area, face_radius,                    &
        derivative_with_respect_to_first_variable, &
        reflection_coefs,                          &
        int_G, int_nabla_G)
    end if
  end subroutine integral_of_reflected_Rankine

  ! =================================================================

  pure subroutine exact_integral_of_reflected_Rankine &
      (M,                                             &
      face_nodes, face_center, face_normal,           &
      face_area, face_radius,                         &
      derivative_with_respect_to_first_variable,      &
      reflection_coefs,                               &
      int_g, int_nabla_g)
    ! Reflecting with respect to the free surface

    ! Inputs
    real(kind=pre), dimension(3),    intent(in) :: M
    real(kind=pre), dimension(4, 3), intent(in) :: face_nodes
    real(kind=pre), dimension(3),    intent(in) :: face_center, face_normal
    real(kind=pre),                  intent(in) :: face_area, face_radius
    logical,                         intent(in) :: derivative_with_respect_to_first_variable
    real(kind=pre), dimension(2),    intent(in) :: reflection_coefs

    ! Outputs
    real(kind=pre),               intent(out) :: int_g
    real(kind=pre), dimension(3), intent(out) :: int_nabla_g

    ! local
    real(kind=pre), dimension(3)              :: reflected_M

    reflected_M(1:2) = M(1:2)
    reflected_M(3)   = reflection_coefs(1) * M(3) + reflection_coefs(2)

    ! For instance
    ! reflection_coefs = [-1.0, 0.0] for free surface symmetry
    ! reflection_coefs = [-1.0, -2*h] for sea bottom symmetry

    call exact_integral_of_Rankine &
      (reflected_M,                &
      face_nodes, face_center,     &
      face_normal, face_area,      &
      face_radius,                 &
      .true.,                      &
      int_g, int_nabla_g)

    ! If we mirrored M, we mirror the gradient
    int_nabla_g(3) = reflection_coefs(1) * int_nabla_g(3)

    if (.not. derivative_with_respect_to_first_variable) then
      int_nabla_g(1:2) = -int_nabla_g(1:2)
      if (reflection_coefs(1) > 0) then
        int_nabla_G(3) = -int_nabla_g(3)
      endif
    end if

  end subroutine exact_integral_of_reflected_Rankine

  ! =================================================================

  pure subroutine one_point_integral_of_reflected_Rankine &
      (M,                                                 &
      face_center, face_area,                             &
      derivative_with_respect_to_first_variable,          &
      reflection_coefs,                                   &
      int_G, int_nabla_G)

    ! Inputs
    real(kind=pre), dimension(3), intent(in) :: M
    real(kind=pre), dimension(3), intent(in) :: face_center
    real(kind=pre),               intent(in) :: face_area
    logical,                      intent(in) :: derivative_with_respect_to_first_variable
    real(kind=pre), dimension(2), intent(in) :: reflection_coefs

    ! outputs
    real(kind=pre),               intent(out) :: int_G
    real(kind=pre), dimension(3), intent(out) :: int_nabla_G

    ! local
    real(kind=pre), dimension(3)              :: reflected_M

    reflected_M(1:2) = M(1:2)
    reflected_M(3)   = reflection_coefs(1) * M(3) + reflection_coefs(2)

    call one_point_integral_of_Rankine(    &
      reflected_M, face_center, face_area, &
      .true.,                              &
      int_G, int_nabla_G)

    int_nabla_G(3) = reflection_coefs(1) * int_nabla_G(3)

    if (.not. derivative_with_respect_to_first_variable) then
      int_nabla_G(1:2) = -int_nabla_G(1:2)
      if (reflection_coefs(1) > 0) then
        int_nabla_G(3) = -int_nabla_G(3)
      endif
    end if

  end subroutine one_point_integral_of_reflected_Rankine

  ! =================================================================

end module Green_Rankine

module interface
  ! This module is meant to keep functions that are only meant to be used for Python interfacing.

  use floating_point_precision, only: pre
  use constants
  use green_wave, only: wave_part_infinite_depth

  implicit none

  public

contains

  ! =====================================================================

  SUBROUTINE VECTORIZED_WAVE_PART_INFINITE_DEPTH                 &
      (nb_points_pairs, x0i, x0j, wavenumber,                    &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      g, nablag)
    ! Vectorized version of the WAVE_PART_INFINITE_DEPTH, taking as input two lists of points and computing the Green
    ! function in a Fortran loop.
    ! Meant for testing and debugging, not currently used otherwise.

    ! Inputs
    integer,                                          intent(in) :: nb_points_pairs
    real(kind=pre), dimension(nb_points_pairs, 3),    intent(in) :: x0i, x0j
    real(kind=pre),                                   intent(in) :: wavenumber
    integer,                                          intent(in) :: gf_singularities

    ! tabulated data
    integer,                                          intent(in) :: tabulation_nb_integration_points
    integer,                                          intent(in) :: tabulation_grid_shape
    real(kind=pre), dimension(:),                     intent(in) :: tabulated_r_range
    real(kind=pre), dimension(:),                     intent(in) :: tabulated_z_range
    real(kind=pre), dimension(:, :, :),               intent(in) :: tabulated_integrals

    ! outputs
    complex(kind=pre), dimension(nb_points_pairs),    intent(out) :: g
    complex(kind=pre), dimension(nb_points_pairs, 3), intent(out) :: nablag

    ! local variables
    integer :: i

    do i = 1, nb_points_pairs
      call wave_part_infinite_depth(                               &
        x0i(i, :), x0j(i, :), wavenumber,                          &
        tabulation_nb_integration_points, tabulation_grid_shape,   &
        tabulated_r_range, tabulated_z_range, tabulated_integrals, &
        gf_singularities,                                          &
        g(i), nablag(i, :))
    enddo
  END SUBROUTINE VECTORIZED_WAVE_PART_INFINITE_DEPTH

  ! =====================================================================


end module

! Copyright (C) 2017-2019 Matthieu Ancellin
! See LICENSE file at <https://github.com/mancellin/libDelhommeau>
MODULE GREEN_RANKINE

  USE FLOATING_POINT_PRECISION, ONLY: PRE
  USE CONSTANTS

  IMPLICIT NONE

  ! The index of the following node when going around a face.
  INTEGER, PRIVATE, DIMENSION(4), PARAMETER :: NEXT_NODE = (/ 2, 3, 4, 1 /)

CONTAINS

  PURE SUBROUTINE COMPUTE_INTEGRAL_OF_RANKINE_SOURCE                &
      (M,                                                           &
      Face_nodes, Face_center, Face_normal, Face_area, Face_radius, &
      S0, VS0)
    ! Estimate the integral S0 = ∫∫ 1/MM' dS(M') over a face
    ! and its derivative VS0 with respect to M.

    ! Based on formulas A6.1 and A6.3 (p. 381 to 383)
    ! in G. Delhommeau thesis (referenced below as [Del]).

    ! Inputs
    REAL(KIND=PRE), DIMENSION(3),    INTENT(IN) :: M
    REAL(KIND=PRE), DIMENSION(4, 3), INTENT(IN) :: Face_nodes
    REAL(KIND=PRE), DIMENSION(3),    INTENT(IN) :: Face_center, Face_normal
    REAL(KIND=PRE),                  INTENT(IN) :: Face_area, Face_radius

    ! Outputs
    REAL(KIND=PRE),               INTENT(OUT) :: S0
    REAL(KIND=PRE), DIMENSION(3), INTENT(OUT) :: VS0

    ! Local variables
    INTEGER                         :: L
    REAL(KIND=PRE)                  :: RO, GZ, DK, GY
    REAL(KIND=PRE), DIMENSION(4)    :: RR
    REAL(KIND=PRE), DIMENSION(3, 4) :: DRX
    REAL(KIND=PRE)                  :: ANT, DNT, ANL, DNL, ALDEN, AT
    REAL(KIND=PRE), DIMENSION(3)    :: PJ, GYX, ANTX, ANLX, DNTX

    RO = NORM2(M(1:3) - Face_center(1:3)) ! Distance from center of mass of the face to M.

    IF (RO > 7*Face_radius) THEN
      ! Asymptotic value if face far away from M
      S0       = Face_area/RO
      VS0(1:3) = (Face_center(1:3) - M)*S0/RO**2

    ELSE

      GZ = DOT_PRODUCT(M(1:3) - Face_center(1:3), Face_normal(1:3)) ! Called Z in [Del]

      DO CONCURRENT (L = 1:4)
        RR(L) = NORM2(M(1:3) - Face_nodes(L, 1:3))       ! Distance from vertices of Face to M.
        DRX(:, L) = (M(1:3) - Face_nodes(L, 1:3))/RR(L)  ! Normed vector from vertices of Face to M.
      END DO

      S0 = ZERO
      VS0(:) = ZERO

      DO L = 1, 4
        DK = NORM2(Face_nodes(NEXT_NODE(L), :) - Face_nodes(L, :))    ! Distance between two consecutive points, called d_k in [Del]
        IF (DK >= REAL(1e-3, PRE)*Face_radius) THEN
          PJ(:) = (Face_nodes(NEXT_NODE(L), :) - Face_nodes(L, :))/DK ! Normed vector from one corner to the next
          ! The following GYX(1:3) are called (a,b,c) in [Del]
          GYX(1) = Face_normal(2)*PJ(3) - Face_normal(3)*PJ(2)
          GYX(2) = Face_normal(3)*PJ(1) - Face_normal(1)*PJ(3)
          GYX(3) = Face_normal(1)*PJ(2) - Face_normal(2)*PJ(1)
          GY = DOT_PRODUCT(M - Face_nodes(L, :), GYX)                                    ! Called Y_k in  [Del]

          ANT = 2*GY*DK                                                                  ! Called N^t_k in [Del]
          DNT = (RR(NEXT_NODE(L))+RR(L))**2 - DK*DK + 2*ABS(GZ)*(RR(NEXT_NODE(L))+RR(L)) ! Called D^t_k in [Del]
          ANL = RR(NEXT_NODE(L)) + RR(L) + DK                                            ! Called N^l_k in [Del]
          DNL = RR(NEXT_NODE(L)) + RR(L) - DK                                            ! Called D^l_k in [Del]
          ALDEN = LOG(ANL/DNL)

          IF (ABS(GZ) >= REAL(1e-4, PRE)*Face_radius) THEN
            AT = ATAN(ANT/DNT)
          ELSE
            AT = 0.
          ENDIF

          ANLX(:) = DRX(:, NEXT_NODE(L)) + DRX(:, L)                    ! Called N^l_k_{x,y,z} in [Del]

          ANTX(:) = 2*DK*GYX(:)                                         ! Called N^t_k_{x,y,z} in [Del]
          DNTX(:) = 2*(RR(NEXT_NODE(L)) + RR(L) + ABS(GZ))*ANLX(:) &
            + 2*SIGN(ONE, GZ)*(RR(NEXT_NODE(L)) + RR(L))*Face_normal(:) ! Called D^t_k_{x,y,z} in [Del]

          IF (ABS(GY) < 1e-5) THEN
            ! Edge case where the singularity is on the boundary of the face (GY = 0, ALDEN = infty).
            ! This case seems to only occur when computating the free surface elevation,
            ! so no fix has been implemented for VS0, which is not needed then.
            S0 = S0 - 2*AT*ABS(GZ)
          ELSE
            ! General case
            S0 = S0 + GY*ALDEN - 2*AT*ABS(GZ)
          END IF

          VS0(:) = VS0(:) + ALDEN*GYX(:)     &
            - 2*SIGN(ONE, GZ)*AT*Face_normal(:)   &
            + GY*(DNL-ANL)/(ANL*DNL)*ANLX(:) &
            - 2*ABS(GZ)*(ANTX(:)*DNT - DNTX(:)*ANT)/(ANT*ANT+DNT*DNT)
        END IF
      END DO
    END IF

  END SUBROUTINE COMPUTE_INTEGRAL_OF_RANKINE_SOURCE

  ! =========================

  PURE SUBROUTINE COMPUTE_ASYMPTOTIC_RANKINE_SOURCE &
      (M,                                      &
      Face_center, Face_area,                  &
      S0, VS0)
    ! Same as above, but always use the approximate aymptotic value.

    ! Inputs
    REAL(KIND=PRE), DIMENSION(3), INTENT(IN) :: M
    REAL(KIND=PRE), DIMENSION(3), INTENT(IN) :: Face_center
    REAL(KIND=PRE),               INTENT(IN) :: Face_area

    ! Outputs
    REAL(KIND=PRE),               INTENT(OUT) :: S0
    REAL(KIND=PRE), DIMENSION(3), INTENT(OUT) :: VS0

    ! Local variables
    REAL(KIND=PRE) :: RO
    REAL(KIND=PRE), DIMENSION(3) :: VO

    VO = Face_center - M
    RO = NORM2(VO) ! Distance from center of mass of the face to M.

    IF (RO > REAL(1e-7, KIND=PRE)) THEN
      ! Asymptotic value if face far away from M
      S0       = Face_area/RO
      VS0(1:3) = VO*S0/RO**2
    ELSE
      ! Singularity...
      S0 = ZERO
      VS0(1:3) = ZERO
    END IF

  END SUBROUTINE COMPUTE_ASYMPTOTIC_RANKINE_SOURCE

  ! ====================================

END MODULE GREEN_RANKINE

program test

  use ieee_arithmetic

  use matrices, only: build_matrices, is_infinity
  use delhommeau_integrals, only: default_r_spacing, default_z_spacing, construct_tabulation
  use floating_point_precision, only: pre
  use constants, only: zero
  use old_prony_decomposition, only: lisc

  implicit none

  integer, parameter :: nb_faces = 2
  integer, parameter :: nb_vertices = 4*nb_faces
  integer, parameter :: nb_quadrature_points = 1

  real(kind=pre) :: wavenumber, depth

  ! Geometry of the mesh
  real(kind=pre), dimension(nb_vertices, 3) :: vertices
  integer, dimension(nb_faces, 4) :: faces
  real(kind=pre), dimension(nb_faces, 3) :: face_center
  real(kind=pre), dimension(nb_faces, 3) :: face_normal
  real(kind=pre), dimension(nb_faces) :: face_area
  real(kind=pre), dimension(nb_faces) :: face_radius
  real(kind=pre), dimension(nb_faces, nb_quadrature_points, 3) :: quadrature_points
  real(kind=pre), dimension(nb_faces, nb_quadrature_points) :: quadrature_weights

  ! Tabulation of the integrals used in the Green function
  integer, parameter :: tabulation_nr = 328
  integer, parameter :: tabulation_nz = 46
  real(kind=pre), dimension(tabulation_nr)                       :: tabulated_r
  real(kind=pre), dimension(tabulation_nz)                       :: tabulated_z
  real(kind=pre), dimension(tabulation_nr, tabulation_nz, 2, 2)  :: tabulated_integrals

  ! Prony decomposition for the finite depth Green function
  integer, parameter :: nexp_max = 31
  integer :: nexp
  real, dimension(nexp_max) :: ambda_f32, ar_f32
  real(kind=pre), dimension(nexp_max) :: ambda, ar

  ! The interaction matrices to be computed
  complex(kind=pre), dimension(nb_faces, nb_faces) :: S
  complex(kind=pre), dimension(nb_faces, nb_faces, 1) :: K

  integer :: i
  real(kind=pre), dimension(3) :: coeffs

  tabulated_r(:) = default_r_spacing(tabulation_nr)
  tabulated_z(:) = default_z_spacing(tabulation_nz)
  tabulated_integrals(:, :, :, :) = construct_tabulation(tabulated_r, tabulated_z, 251)

  depth = ieee_value(depth, ieee_positive_inf)

  vertices = reshape([  &
    0.0,  1.0,  1.0,  0.0,  1.0,  2.0,  2.0,  1.0,  &
    0.0,  0.0,  1.0,  1.0,  0.0,  0.0,  1.0,  1.0,  &
    -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0, -1.0  &
    ], shape(vertices))

  faces = reshape([  &
    1, 5, &
    2, 6, &
    3, 7, &
    4, 8  &
    ], shape(faces))

  face_center = reshape([  &
    0.5,  1.5,  &
    0.5,  0.5,  &
    -1.0, -1.0  &
    ], shape(face_center))

  face_normal = reshape([  &
    0.0, 0.0,  &
    0.0, 0.0,  &
    1.0, 1.0   &
    ], shape(face_normal))

  face_area = [1.0, 1.0]
  face_radius = [0.71, 0.71]

  quadrature_points = reshape(face_center, shape(quadrature_points))
  quadrature_weights = reshape(face_area, shape(quadrature_weights))

  print*, "-- Run libdelhommeau/examples/minimal/minimal_example.f90"

  coeffs = [1d0, 0d0, 0d0]
  call build_matrices(                                           &
    nb_faces, face_center, face_normal,                          &
    nb_vertices, nb_faces, vertices, faces,                      &
    face_center, face_normal, face_area, face_radius,            &
    nb_quadrature_points, quadrature_points, quadrature_weights, &
    ZERO, depth, coeffs,                                         &
    tabulated_r, tabulated_z, tabulated_integrals,               &
    nexp, ambda, ar,                                             &
    .true., .true.,                                              &
    S, K)
  print*, "Rankine part: S"
  do i = 1, nb_faces
    print"(4ES20.12)", S(i, :)
  enddo
  print*, "Rankine part: K"
  do i = 1, nb_faces
    print"(4ES20.12)", K(i, :, 1)
  enddo

  wavenumber = 1d0
  coeffs = [1d0, 1d0, 1d0]
  call build_matrices(                                           &
    nb_faces, face_center, face_normal,                          &
    nb_vertices, nb_faces, vertices, faces,                      &
    face_center, face_normal, face_area, face_radius,            &
    nb_quadrature_points, quadrature_points, quadrature_weights, &
    wavenumber, depth, coeffs,                                   &
    tabulated_r, tabulated_z, tabulated_integrals,               &
    nexp, ambda, ar,                                             &
    .true., .true.,                                              &
    S, K)
  print*, "k=1.0, h=infty: S"
  do i = 1, nb_faces
    print"(4ES20.12)", S(i, :)
  enddo
  print*, "k=1.0, h=infty: K"
  do i = 1, nb_faces
    print"(4ES20.12)", K(i, :, 1)
  enddo

  wavenumber = 2d0
  coeffs = [1d0, 1d0, 1d0]
  call build_matrices(                                           &
    nb_faces, face_center, face_normal,                          &
    nb_vertices, nb_faces, vertices, faces,                      &
    face_center, face_normal, face_area, face_radius,            &
    nb_quadrature_points, quadrature_points, quadrature_weights, &
    wavenumber, depth, coeffs,                                   &
    tabulated_r, tabulated_z, tabulated_integrals,               &
    nexp, ambda, ar,                                             &
    .true., .true.,                                              &
    S, K)
  print*, "k=2.0, h=infty: S"
  do i = 1, nb_faces
    print"(4ES20.12)", S(i, :)
  enddo
  print*, "k=2.0, h=infty: K"
  do i = 1, nb_faces
    print"(4ES20.12)", K(i, :, 1)
  enddo

  ! finite depth

  depth = 2.0
  wavenumber = 1d0
  coeffs = [1d0, 1d0, 1d0]

  call lisc(real(wavenumber*depth*tanh(wavenumber*depth)), real(wavenumber*depth), ambda_f32, ar_f32, nexp)
  ambda(:) = real(ambda_f32(:), kind=pre)
  ar(:) = real(ar_f32(:), kind=pre)
  nexp = nexp + 1
  ambda(nexp) = 0.0
  ar(nexp) = 2.0

  call build_matrices(                                           &
    nb_faces, face_center, face_normal,                          &
    nb_vertices, nb_faces, vertices, faces,                      &
    face_center, face_normal, face_area, face_radius,            &
    nb_quadrature_points, quadrature_points, quadrature_weights, &
    wavenumber, depth, coeffs,                                   &
    tabulated_r, tabulated_z, tabulated_integrals,               &
    nexp, ambda, ar,                                             &
    .true., .true.,                                              &
    S, K)
  print*, "k=1.0, h=2.0: S"
  do i = 1, nb_faces
    print"(4ES20.12)", S(i, :)
  enddo
  print*, "k=1.0, h=2.0: K"
  do i = 1, nb_faces
    print"(4ES20.12)", K(i, :, 1)
  enddo


  depth = 2.0
  wavenumber = 2d0
  coeffs = [1d0, 1d0, 1d0]

  call lisc(real(wavenumber*depth*tanh(wavenumber*depth)), real(wavenumber*depth), ambda_f32, ar_f32, nexp)
  ambda(:) = real(ambda_f32(:), kind=pre)
  ar(:) = real(ar_f32(:), kind=pre)
  nexp = nexp + 1
  ambda(nexp) = 0.0
  ar(nexp) = 2.0

  call build_matrices(                                           &
    nb_faces, face_center, face_normal,                          &
    nb_vertices, nb_faces, vertices, faces,                      &
    face_center, face_normal, face_area, face_radius,            &
    nb_quadrature_points, quadrature_points, quadrature_weights, &
    wavenumber, depth, coeffs,                                   &
    tabulated_r, tabulated_z, tabulated_integrals,               &
    nexp, ambda, ar,                                             &
    .true., .true.,                                              &
    S, K)
  print*, "k=2.0, h=2.0: S"
  do i = 1, nb_faces
    print"(4ES20.12)", S(i, :)
  enddo
  print*, "k=2.0, h=2.0: K"
  do i = 1, nb_faces
    print"(4ES20.12)", K(i, :, 1)
  enddo

end program test

! Copyright (C) 2017-2024 Matthieu Ancellin
! See LICENSE file at <https://github.com/capytaine/libDelhommeau>

MODULE CONSTANTS

  USE ieee_arithmetic
  USE FLOATING_POINT_PRECISION, ONLY: PRE

  IMPLICIT NONE

  REAL(KIND=PRE), PARAMETER    :: ZERO = 0
  COMPLEX(KIND=PRE), PARAMETER :: CZERO = CMPLX(ZERO, ZERO, KIND=PRE)
  REAL(KIND=PRE), PARAMETER    :: ONE = 1

  REAL(KIND=PRE), PARAMETER    :: PI = 3.141592653588979 ! π
  REAL(KIND=PRE), PARAMETER    :: MINUS_ONE_OVER_FOURPI = -ONE/(4*PI)
  REAL(KIND=PRE), PARAMETER    :: EULER_GAMMA = 0.5772156649
  REAL(KIND=PRE), PARAMETER    :: LOG_2 = LOG(REAL(2d0, kind=pre))
  COMPLEX(KIND=PRE), PARAMETER :: II = (ZERO, ONE) ! Imaginary unit

  integer, parameter :: nb_tabulated_values = 5

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! Parameters for different variants of the Green function.
  ! The actual number should be irrelevant as long as they are different.

  ! Values for "tabulation_grid_shape", which could be generalized to "infinite_depth_method"
  integer, parameter :: LIANG_WU_NOBLESSE = -1
  integer, parameter :: LEGACY_GRID = 0  ! Nemoh 2
  integer, parameter :: SCALED_NEMOH3_GRID = 1

  ! Values for "finite_depth_method"
  integer, parameter :: FINGREEN3D_METHOD = -1
  integer, parameter :: LEGACY_FINITE_DEPTH = 0
  integer, parameter :: NEWER_FINITE_DEPTH = 1

  ! Values for "gf_singularities"
  integer, parameter :: HIGH_FREQ = 0  ! legacy from Nemoh
  integer, parameter :: LOW_FREQ = 1  ! aka XieDelhommeau
  integer, parameter :: LOW_FREQ_WITH_RANKINE_PART = 2  ! like LOW_FREQ but with a term integrated exactly

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

contains

  PURE LOGICAL FUNCTION is_infinity(x)
    REAL(KIND=PRE), INTENT(IN) :: x
    is_infinity = (.NOT. ieee_is_finite(x))
  END FUNCTION

END MODULE CONSTANTS

program benchmark_tabulation

use constants, only: pre  ! Floating point precision
use constants, only: nb_tabulated_values
use delhommeau_integrals

implicit none

integer, parameter :: tabulation_grid_shape = 1
integer, parameter :: n_tabulation = 4
integer, parameter :: n_samples = 1000
integer :: i_sample
integer :: i_tabulation
integer, dimension(n_tabulation) :: tabulation_nr
integer, dimension(n_tabulation) :: tabulation_nz


integer(kind=8) :: starting_time, final_time, clock_rate, clock_rate_in_ns

real(kind=pre), dimension(:), allocatable          :: r, z, tabulated_r, tabulated_z
real(kind=pre), dimension(:, :, :), allocatable    :: tabulated_integrals
real(kind=pre), dimension(:, :), allocatable       :: integrals

print*, "-- Run libDelhommeau/benchmarks/tabulations/benchmark_tabulation.f90"

call system_clock(count_rate=clock_rate)
clock_rate_in_ns = clock_rate / 1000000000

allocate(r(n_samples))
allocate(z(n_samples))
allocate(integrals(n_samples, nb_tabulated_values))

call random_number(r)
r = 100*r

call random_number(z)
z = -10*z


call system_clock(starting_time)
do i_sample = 1, n_samples
    integrals(i_sample, :) = numerical_integration(r(i_sample), z(i_sample), 2501)
enddo
call system_clock(final_time)
print*, "Integration (fine)  :", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"


call system_clock(starting_time)
do i_sample = 1, n_samples
    integrals(i_sample, :) = numerical_integration(r(i_sample), z(i_sample), 251)
enddo
call system_clock(final_time)
print*, "Integration (coarse):", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"


tabulation_nr = [32, 328, 656, 656]
tabulation_nz = [4, 48, 92, 184]

do i_tabulation = 1, n_tabulation

  allocate(tabulated_r(tabulation_nr(i_tabulation)))
  allocate(tabulated_z(tabulation_nz(i_tabulation)))
  allocate(tabulated_integrals(tabulation_nr(i_tabulation), tabulation_nz(i_tabulation), nb_tabulated_values))

  tabulated_r(:) = default_r_spacing(tabulation_nr(i_tabulation), 100d0, tabulation_grid_shape)
  tabulated_z(:) = default_z_spacing(tabulation_nz(i_tabulation), -251d0, tabulation_grid_shape)
  tabulated_integrals(:, :, :) = construct_tabulation(tabulated_r, tabulated_z, 1001)

  call system_clock(starting_time)
  do i_sample = 1, n_samples
      integrals(i_sample, :) = pick_in_default_tabulation(r(i_sample), z(i_sample), &
        tabulation_grid_shape, tabulated_r, tabulated_z, tabulated_integrals)
  enddo
  call system_clock(final_time)
  print*, "Interpolate         :", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"

  deallocate(tabulated_r, tabulated_z, tabulated_integrals)

enddo


call system_clock(starting_time)
do i_sample = 1, n_samples
    integrals(i_sample, :) = asymptotic_approximations(r(i_sample), z(i_sample))
enddo
call system_clock(final_time)
print*, "Asymptotic          :", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"


end program

! Copyright (C) 2022-2024 Matthieu Ancellin
! See LICENSE file at <https://github.com/capytaine/libDelhommeau>
!
! This module contains functions to evaluate the following integrals
! for a given range of values of `r ∈ [0, +∞)` and `z ∈ (-∞, 0]`.
! I(1) = Re[ 𝒢^+ ] = 2/π Re[ ∫ e^ζ (E(ζ) + iπ) dθ ]
! I(2) = Re[ 𝒢^- ] = 2/π Re[ ∫ (e^ζ (E(ζ) + iπ) - 1/ζ) dθ ]
! I(3) = Im[ 𝒢^+ ] = Im[ 𝒢^- ] =  2/π Re[ ∫(e^ζ) dθ ]
! I(4) = Re[ ∂𝒢^+/∂r ] = 2 Re[ ∫ (i cosθ) (e^ζ (E(ζ) + iπ) - 1/ζ) dθ ]
! I(5) = Im[ ∂𝒢^+/∂r ] = 2 Re[ ∫ (i cosθ) (e^ζ) dθ ]
! where ζ = z + i r cos θ.
!
! They are required for the evaluation of the Green function and its gradient.
!
module delhommeau_integrals

  use floating_point_precision, only: pre
  use constants

  implicit none

  public :: numerical_integration
  public :: asymptotic_approximations
  public :: construct_tabulation
  public :: default_r_spacing, default_z_spacing
  public :: pick_in_default_tabulation

  !private  ! Other functions are private by default

contains

  pure function numerical_integration(r, z, nb_integration_points) result(integrals)
    ! Compute the integrals by numerical integration, with `nb_integration_points` points.

    ! input
    real(kind=pre), intent(in) :: r
    real(kind=pre), intent(in) :: z
    integer,        intent(in) :: nb_integration_points

    ! output
    real(kind=pre), dimension(nb_tabulated_values) :: integrals

    ! local variables
    integer :: k, n
    real(kind=pre) :: theta, delta_theta, cos_theta
    complex(kind=pre) :: zeta, exp_zeta, jzeta

    ! initial values
    integrals(:) = 0.0

    ! Should have an odd number of points for Simpson rule
    if (mod(nb_integration_points, 2) == 0) then
      n = nb_integration_points + 1
    else
      n = nb_integration_points
    endif

    do k = 1, n
      theta = -pi/2 + pi*(k-1.0)/(n-1.0)
      ! The 1.0 are here on purpose to force the recasting of k and n as floats.

      ! Step of the integration using Simpson rule
      if ((k == 1) .or. (k == n)) then
        delta_theta = pi/(3*(n-1.0))
      elseif (mod(k, 2) == 0) then
        delta_theta = 4*pi/(3*(n-1.0))
      else
        delta_theta = 2*pi/(3*(n-1.0))
      endif

      cos_theta = cos(theta)
      zeta = cmplx(z, r*cos_theta, kind=pre)
      IF (REAL(ZETA) <= -30.0) THEN
        exp_zeta = (0.0, 0.0)
      else
        exp_zeta = exp(zeta)
      endif
      jzeta = exp_e1(zeta) + ii*pi*exp_zeta
      integrals(1) = integrals(1) + delta_theta * real(jzeta)
      integrals(2) = integrals(2) + delta_theta * real(jzeta - 1.0/zeta)
      integrals(3) = integrals(3) + delta_theta * real(exp_zeta)
      integrals(4) = integrals(4) - delta_theta * cos_theta * aimag(jzeta - 1.0/zeta)
      integrals(5) = integrals(5) - delta_theta * cos_theta * aimag(exp_zeta)
    enddo

    integrals(1) = integrals(1)/PI
    integrals(2) = integrals(2)/PI
    integrals(4) = integrals(4)/PI
    integrals(:) = 2*integrals(:)

  contains

    pure function exp_e1(zz)
      ! estimation of exp(z)·E1(z) where E1(z) = ∫_z^∞ exp(-t)/t dt
      ! see p.367 of G. Delhommeau thesis (referenced as [del]).
      ! the computation is done is single precision.

      complex(kind=pre), intent(in)  :: zz
      complex(kind=pre)              :: exp_e1
      complex(kind=kind(1e0))        :: g, y, z

      z = cmplx(zz, kind=kind(1e0))
      if (real(z) < -16.0) then                                      ! case 1 p. 368 in [del]
        y = 1./z
        g = y*(1.+y*(-1.+y*(2.+y*(-6.+y*(24.+y*(-120.))))))
      else if (abs(aimag(z)) > 10.0) then                            ! case 3 p. 368 in [del]
        g = 0.711093/(z+0.415775)+0.278518/(z+2.29428)+0.010389/(z+6.2900)
      else if (real(z) > -0.5) then                                  ! case 2 p. 368 in [del]
        g = -(log(z)*(.1e+01+z*(0.23721365e+00+z*(0.206543e-01+z*(0.763297e-03+     &
          z*0.97087007e-05))))+0.5772156649e+00*(0.99999207e+00+                    &
          z*(-0.149545886e+01+z*(0.41806426e-01+z*(-0.3000591e-01+                  &
          z*(0.19387339e-02+z*(-0.51801555e-03)))))))/(0.1e+01+                     &
          z*(-0.76273617e+00+z*(0.28388363e+00+z*(-0.66786033e-01+z*(0.12982719e-01 &
          +z*(-0.8700861e-03+z*0.2989204e-03))))))
      else                                                           ! case 4 p. 369 in [del]
        if (aimag(z) < 0) then
          g = ((((((( (1.000000, 1.3935496e-06)*z+ (15.82958, -20.14222))   &
            *z+ (-70.52863, -227.9511))*z+ (-985.4221, -226.6272))*z        &
            + (-1202.318, 1580.907))*z+ (953.2441, 1342.447))*z             &
            + (417.3716, -196.6665))*z+ (-9.881266, -24.24952))/            &
            (((((((( (1.000000, 0.0000000e+00)*z+ (16.83184, -20.14481))*z  &
            + (-55.66969, -248.1167))*z+ (-1068.640, -434.4707))*z          &
            + (-2082.250, 1522.471))*z+ (383.3455, 2730.378))*z             &
            + (1216.791, 351.7189))*z+ (115.3926, -161.2647))*z             &
            + (-3.777369, -4.510900))
        else
          g = ((((((( (1.000000, -1.3935496e-06)*z+ (15.82958, 20.14222))   &
            *z+ (-70.52863, 227.9511))*z+ (-985.4221, 226.6272))*z          &
            + (-1202.318, -1580.907))*z+ (953.2441, -1342.447))*z           &
            + (417.3716, 196.6665))*z+ (-9.881266, 24.24952))/              &
            (((((((( (1.000000, 0.0000000e+00)*z+ (16.83184, 20.14481))*z   &
            + (-55.66969, 248.1167))*z+ (-1068.640, 434.4707))*z            &
            + (-2082.250, -1522.471))*z+ (383.3455, -2730.378))*z           &
            + (1216.791, -351.7189))*z+ (115.3926, 161.2647))*z             &
            + (-3.777369, 4.510900))
        end if
      end if
      exp_e1 = cmplx(g, kind=pre)

    end function exp_e1

  end function numerical_integration

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function asymptotic_approximations(r, z) result(integrals)
    ! Evaluate the wave part of legacy's Delhommeau Green function
    ! using an approximate expression for large r and |z|
    real(kind=pre), intent(in) :: r
    real(kind=pre), intent(in) :: z

    real(kind=pre), dimension(nb_tabulated_values) :: integrals

    real(kind=pre) :: r1, expz_sqr, sin_kr, cos_kr

    r1 = hypot(r, z)

    expz_sqr = exp(z) * sqrt(2*pi/r)
    cos_kr  = cos(r - pi/4)
    sin_kr  = sin(r - pi/4)

    integrals(1) = -expz_sqr*sin_kr + z/r1**3 - 1/r1
    integrals(2) = -expz_sqr*sin_kr + z/r1**3
    integrals(3) =  expz_sqr*cos_kr
    integrals(4) = -expz_sqr*(cos_kr - sin_kr/(2*r)) + r/r1**3
    integrals(5) = -expz_sqr*(sin_kr + cos_kr/(2*r))
    integrals(:) = 2*integrals(:)

  end function asymptotic_approximations

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function construct_tabulation(r_range, z_range, nb_integration_points) result(tabulation)
    real(kind=pre), dimension(:), intent(in) :: r_range
    real(kind=pre), dimension(:), intent(in) :: z_range
    integer,        intent(in) :: nb_integration_points
    real(kind=pre), dimension(size(r_range), size(z_range), nb_tabulated_values) :: tabulation

    integer :: i, j

    do concurrent (j = 1:size(z_range))
      do concurrent (i = 1:size(r_range))
        tabulation(i, j, :) = numerical_integration(r_range(i), z_range(j), nb_integration_points)
      enddo
    enddo

  end function construct_tabulation

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function default_r_spacing(nr, rmax, method)
    integer, intent(in) :: nr
    real(kind=pre), intent(in) :: rmax
    integer, intent(in) :: method
    real(kind=pre), dimension(nr) :: default_r_spacing

    ! Reference parameters from Nemoh 3 model
    integer, parameter :: nr_ref = 676
    integer, parameter :: index_of_1_ref = 81  ! index of the change of slope

    ! local variables
    integer :: i, index_of_1

    default_r_spacing(1) = 0.0

    if (method == LEGACY_GRID) then
      do concurrent (i = 2:nr)
        default_r_spacing(i) = min(                    &
                                 10**((i-1.0)/5.0 - 6.0), &
                                 abs(i-32)/3.0 + 4.0/3.0  &
                               )
      enddo
    else
      ! change of slope at r = 1.0 that is i=index_of_1
      index_of_1 = nint(nr*1.0/nr_ref*index_of_1_ref)
      do concurrent (i = 1:nr)
        if (i < index_of_1) then
          ! Exponential spacing
          default_r_spacing(i) = 10.0**(-10*(1-real(i-1)/(index_of_1-1)))
        else
          ! Linear spacing
          default_r_spacing(i) = (rmax-1.0)/(nr-index_of_1)*(i-index_of_1)+1.0
        endif
      enddo
    endif
  end function default_r_spacing

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function default_z_spacing(nz, zmin, method)
    integer, intent(in) :: nz
    real(kind=pre), intent(in) :: zmin
    integer, intent(in) :: method
    real(kind=pre), dimension(nz) :: default_z_spacing

    integer :: j
    real(kind=pre) :: dz

    if (method == LEGACY_GRID) then
      do concurrent (j = 1:nz)
        default_z_spacing(j) = -min(10**(j/5.0-6.0), 10**(j/8.0-4.5))
        ! change of slope at z = -1e-2
      enddo
      if (nz == 46) then  ! For consistency with Nemoh 2...
        default_z_spacing(46) = -16.0
      endif
    else
      dz = (log10(abs(zmin))+10.0)/nz
      do concurrent (j = 1:nz)
        default_z_spacing(j) = -min(10**(dz*j-10.0), abs(zmin))
      enddo
    endif
  end function default_z_spacing

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function pick_in_default_tabulation(r, z, method, r_range, z_range, tabulation) result(interpolated_values)
    ! inputs
    real(kind=pre), intent(in) :: r
    real(kind=pre), intent(in) :: z
    integer, intent(in) :: method
    real(kind=pre), dimension(:), intent(in) :: r_range
    real(kind=pre), dimension(:), intent(in) :: z_range
    real(kind=pre), dimension(size(r_range), size(z_range), nb_tabulated_values), intent(in) :: tabulation

    ! output
    real(kind=pre), dimension(nb_tabulated_values) :: interpolated_values

    ! local variables
    integer :: i, j

    i = max(2, min(size(r_range)-1, nearest_r_index(r, r_range, method)))
    j = max(2, min(size(z_range)-1, nearest_z_index(z, z_range, method)))

    interpolated_values(:) = lagrange_polynomial_interpolation( &
      r, z,                                                     &
      r_range(i-1:i+1), z_range(j-1:j+1),                       &
      tabulation(i-1:i+1, j-1:j+1, :)                           &
      )
  end function pick_in_default_tabulation

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function nearest_r_index(r, r_range, method)
    real(kind=pre), intent(in) :: r
    integer, intent(in) :: method
    real(kind=pre), dimension(:), intent(in) :: r_range
    integer :: nearest_r_index

    ! Reference parameters from Nemoh 3 model
    integer, parameter :: nr_ref = 676
    integer, parameter :: index_of_1_ref = 81  ! index of the change of slope

    ! local variables
    integer :: index_of_1
    real(kind=pre) :: rmax

    if (method == LEGACY_GRID) then
      if (r < 1e-6) then
        nearest_r_index = 1
      else if (r < 1.0) then
        nearest_r_index = int(5*(log10(r) + 6) + 1)
      else
        nearest_r_index = int(3*r + 28)
      endif
    else
      index_of_1 = nint(real(size(r_range)*index_of_1_ref)/nr_ref)
      rmax = r_range(size(r_range))

      if (r < 1e-10) then
        nearest_r_index = 1
      else if (r < 1.0) then
        nearest_r_index = nint((log10(r)/10.0 + 1.0)*(index_of_1-1) + 1)
      else
        nearest_r_index = nint((r - 1)*(size(r_range) - index_of_1)/(rmax - 1) + index_of_1)
      endif
    endif
  end function

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function nearest_z_index(z, z_range, method)
    real(kind=pre), intent(in) :: z
    integer, intent(in) :: method
    real(kind=pre), dimension(:), intent(in) :: z_range
    integer :: nearest_z_index

    ! local parameters
    real(kind=pre) :: absz
    real(kind=pre) :: dz
    integer :: nz

    absz = abs(z)
    nz = size(z_range)

    if (method == LEGACY_GRID) then
      if (absz > 1e-2) then
        nearest_z_index = int(8*(log10(absz) + 4.5))
      else
        nearest_z_index = int(5*(log10(absz) + 6))
      endif
    else
      dz = (log10(abs(z_range(nz)))+10.0)/nz
      nearest_z_index = nint((log10(absz)+10)/dz)
    endif
  end function

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pure function lagrange_polynomial_interpolation(         &
      r, z, local_r_range, local_z_range, local_tabulation &
      ) result(interpolated_values)
    ! inputs
    real(kind=pre),                        intent(in) :: r, z
    real(kind=pre), dimension(3),          intent(in) :: local_r_range
    real(kind=pre), dimension(3),          intent(in) :: local_z_range
    real(kind=pre), dimension(3, 3, nb_tabulated_values), intent(in) :: local_tabulation

    ! output
    real(kind=pre), dimension(nb_tabulated_values) :: interpolated_values

    ! local variable
    integer :: k
    real(kind=pre), dimension(3) :: xl, zl

    xl(1) = pl2(local_r_range(2), local_r_range(3), local_r_range(1), r)
    xl(2) = pl2(local_r_range(3), local_r_range(1), local_r_range(2), r)
    xl(3) = pl2(local_r_range(1), local_r_range(2), local_r_range(3), r)
    zl(1) = pl2(local_z_range(2), local_z_range(3), local_z_range(1), z)
    zl(2) = pl2(local_z_range(3), local_z_range(1), local_z_range(2), z)
    zl(3) = pl2(local_z_range(1), local_z_range(2), local_z_range(3), z)

    do concurrent (k=1:nb_tabulated_values)
      interpolated_values(k) = dot_product(xl, matmul(local_tabulation(:, :, k), zl))
    enddo

    contains

    pure function pl2(u1, u2, u3, xu)
      real(kind=pre), intent(in) :: u1, u2, u3, xu
      real(kind=pre) :: pl2
      pl2 = ((xu-u1)*(xu-u2))/((u3-u1)*(u3-u2))
    end function pl2

  end function lagrange_polynomial_interpolation

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

end module delhommeau_integrals

program benchmark_waves

use, intrinsic :: ieee_arithmetic
use constants
use ieee_arithmetic
use old_prony_decomposition, only: lisc
use delhommeau_integrals, only: default_r_spacing, default_z_spacing, construct_tabulation
use green_wave

implicit none

integer, parameter :: n_samples = 1000
integer :: i_sample

integer(kind=8) :: starting_time, final_time, clock_rate, clock_rate_in_ns

real(kind=pre) :: wavenumber, depth

integer, parameter :: tabulation_nb_integration_points = 500
integer, parameter :: tabulation_nr = 676
integer, parameter :: tabulation_nz = 372
integer, parameter :: tabulation_grid_shape = SCALED_NEMOH3_GRID
real(kind=pre), dimension(tabulation_nr) :: tabulated_r_range
real(kind=pre), dimension(tabulation_nz) :: tabulated_z_range
real(kind=pre), dimension(:, :, :), allocatable :: tabulated_integrals

integer, parameter :: gf_singularities = LOW_FREQ

integer :: finite_depth_method
integer :: nexp
real(kind=pre), dimension(2, 31) :: prony_decomposition
real(kind=pre), dimension(200) :: dispersion_roots

real(kind=pre), dimension(:, :), allocatable  :: points
real(kind=pre), dimension(4, 3) :: face_nodes
real(kind=pre), dimension(1, 3) :: face_quadrature_points
real(kind=pre), dimension(1) :: face_quadrature_weights
real(kind=pre), dimension(3) :: face_center
real(kind=pre), dimension(3) :: face_normal
real(kind=pre) :: face_area
real(kind=pre) :: face_radius
logical, parameter :: derivative_with_respect_to_first_variable = .true.

complex(kind=pre) :: int_G_wave
complex(kind=pre), dimension(3) :: int_nablaG_wave

complex(kind=pre), dimension(:), allocatable :: S
complex(kind=pre), dimension(:, :), allocatable :: VS

print*, "-- Run libDelhommeau/benchmarks/waves/benchmark_waves.f90"

dispersion_roots(:) = 0d0
prony_decomposition(:, :) = 0d0

call system_clock(count_rate=clock_rate)
clock_rate_in_ns = clock_rate / 1000000000

allocate(points(3, n_samples))
call random_number(points)
points(3, :) = - points(3, :)

face_nodes(1, :) = [0d0, 0d0, -1d0]
face_nodes(2, :) = [1d0, 0d0, -1d0]
face_nodes(3, :) = [1d0, 1d0, -1d0]
face_nodes(4, :) = [0d0, 1d0, -1d0]
face_center(:) = [0.5d0, 0.5d0, -1d0]
face_quadrature_points(1, :) = [0.5d0, 0.5d0, -1d0]
face_quadrature_weights(1) = 1d0
face_normal(:) = [0d0, 0d0, 1d0]
face_area = 1d0
face_radius = sqrt(2d0)/2

tabulated_r_range(:) = default_r_spacing(tabulation_nr, 100d0, tabulation_grid_shape)
tabulated_z_range(:) = default_z_spacing(tabulation_nz, -251d0, tabulation_grid_shape)
allocate(tabulated_integrals(tabulation_nr, tabulation_nz, nb_tabulated_values))
tabulated_integrals(:, :, :) = construct_tabulation(tabulated_r_range, tabulated_z_range, tabulation_nb_integration_points)

allocate(S(n_samples))
allocate(VS(3, n_samples))

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

depth = ieee_value(1d0, ieee_positive_inf)
wavenumber = 1d0
call system_clock(starting_time)
do i_sample = 1, n_samples
  call integral_of_wave_part_infinite_depth                      &
      (points(:, i_sample),                                      &
      face_center, face_area,                                    &
      face_quadrature_points, face_quadrature_weights,           &
      wavenumber,                                                &
      tabulation_nb_integration_points, tabulation_grid_shape,   &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      derivative_with_respect_to_first_variable,                 &
      S(i_sample), VS(:, i_sample)                               &
      )
enddo
call system_clock(final_time)
print*, "Infinite depth (tabula.): ", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef LIANGWUNOBLESSE_OPTIONAL_DEPENDENCY
depth = ieee_value(1d0, ieee_positive_inf)
wavenumber = 1d0
call system_clock(starting_time)
do i_sample = 1, n_samples
  call integral_of_wave_part_infinite_depth                      &
      (points(:, i_sample),                                      &
      face_center, face_area,                                    &
      face_quadrature_points, face_quadrature_weights,           &
      wavenumber,                                                &
      tabulation_nb_integration_points, LIANG_WU_NOBLESSE,       &
      tabulated_r_range, tabulated_z_range, tabulated_integrals, &
      gf_singularities,                                          &
      derivative_with_respect_to_first_variable,                 &
      S(i_sample), VS(:, i_sample)                               &
      )
enddo
call system_clock(final_time)
print*, "Infinite depth (Wu):      ", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

finite_depth_method = NEWER_FINITE_DEPTH
depth = 10d0
wavenumber = 1d0
call lisc(real(wavenumber*depth*tanh(wavenumber*depth)), real(wavenumber*depth), nexp, prony_decomposition)
call system_clock(starting_time)
do i_sample = 1, n_samples
  call integral_of_wave_parts_finite_depth                     &
    (points(:, i_sample),                                      &
    face_center, face_area,                                    &
    face_quadrature_points, face_quadrature_weights,           &
    wavenumber, depth,                                         &
    tabulation_nb_integration_points, tabulation_grid_shape,   &
    tabulated_r_range, tabulated_z_range, tabulated_integrals, &
    gf_singularities,                                          &
    derivative_with_respect_to_first_variable,                 &
    int_G_wave, int_nablaG_wave                                &
    )
  S(i_sample) = S(i_sample) + int_G_wave
  VS(i_sample, :) = VS(i_sample, :) + int_nablaG_wave
  call integral_of_prony_decomp_finite_depth        &
    (points(:, i_sample),                           &
    face_nodes, face_center, face_normal,           &
    face_area, face_radius,                         &
    depth,                                          &
    prony_decomposition,                            &
    derivative_with_respect_to_first_variable,      &
    int_G_wave, int_nablaG_wave                     &
    )
  S(i_sample) = S(i_sample) + int_G_wave
  VS(i_sample, :) = VS(i_sample, :) + int_nablaG_wave
enddo
call system_clock(final_time)
print*, "Finite depth (Delhommeau):", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef FINGREEN3D_OPTIONAL_DEPENDENCY
finite_depth_method = FINGREEN3D_METHOD
depth = 10d0
wavenumber = 1d0
dispersion_roots = compute_dispersion_roots(200, wavenumber*tanh(wavenumber*depth), depth)
call system_clock(starting_time)
do i_sample = 1, n_samples
  call integral_of_wave_part_fingreen3d                          &
      (points(:, i_sample),                                      &
      face_quadrature_points, face_quadrature_weights,           &
      wavenumber, depth,                                         &
      dispersion_roots,                                          &
      derivative_with_respect_to_first_variable,                 &
      S(i_sample), VS(:, i_sample)                               &
      )
enddo
call system_clock(final_time)
print*, "Finite depth (Liu):       ", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


end program

program benchmark_rankine

use constants, only: pre  ! Floating point precision
use constants, only: nb_tabulated_values
use green_rankine

implicit none

integer, parameter :: n_samples = 1000
integer :: i_sample

integer(kind=8) :: starting_time, final_time, clock_rate, clock_rate_in_ns
real(kind=pre), dimension(:, :), allocatable  :: points
real(kind=pre), dimension(4, 3) :: face_nodes
real(kind=pre), dimension(3) :: face_center
real(kind=pre), dimension(3) :: face_normal
real(kind=pre) :: face_area
real(kind=pre) :: face_radius
logical, parameter :: derivative_with_respect_to_first_variable = .true.

real(kind=pre), dimension(:), allocatable :: S
real(kind=pre), dimension(:, :), allocatable :: VS

print*, "-- Run libDelhommeau/benchmarks/rankine/benchmark_rankine.f90"

call system_clock(count_rate=clock_rate)
clock_rate_in_ns = clock_rate / 1000000000

allocate(points(3, n_samples))
call random_number(points)

face_nodes(1, :) = [0d0, 0d0, 0d0]
face_nodes(2, :) = [1d0, 0d0, 0d0]
face_nodes(3, :) = [1d0, 1d0, 0d0]
face_nodes(4, :) = [0d0, 1d0, 0d0]
face_center(:) = [0.5d0, 0.5d0, 0d0]
face_normal(:) = [0d0, 0d0, 1d0]
face_area = 1d0
face_radius = sqrt(2d0)/2

allocate(S(n_samples))
allocate(VS(3, n_samples))


call system_clock(starting_time)
do i_sample = 1, n_samples
    call exact_integral_of_Rankine(                &
        points(:, i_sample),                       &
        face_nodes, face_center, face_normal,      &
        face_area, face_radius,                    &
        derivative_with_respect_to_first_variable, &
        S(i_sample), VS(:, i_sample)               &
    )
enddo
call system_clock(final_time)
print*, "Exact Rankine       :", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"


call system_clock(starting_time)
do i_sample = 1, n_samples
    call one_point_integral_of_Rankine(            &
        points(:, i_sample),                       &
        face_nodes, face_area,                     &
        derivative_with_respect_to_first_variable, &
        S(i_sample), VS(:, i_sample)               &
    )
enddo
call system_clock(final_time)
print*, "Asymptotic Rankine  :", (final_time - starting_time)/clock_rate_in_ns/n_samples, " ns"

end program

# How to contribute

Thank you for your interest into Capytaine.

## Contact

The best place to report a bug or to propose an enhancement is the [issue
tracker](https://github.com/mancellin/capytaine/issues) of Capytaine's Github
repository.

The [discussion page](https://github.com/mancellin/capytaine/discussions) can
also be used to ask questions and submit ideas.

## Submitting changes

Pull requests are welcome.
See the [developer manual](https://capytaine.org/master/developer_manual) for
instructions.
